--------------------------------------------------------------------------------
drkns 2023-07-27 19:40:17+01:00 - build 6175

1. Try to survive a conhost crash caused by a spawned process.

--------------------------------------------------------------------------------
drkns 2023-07-21 22:56:56+01:00 - build 6174

1. Preserve user-defined cursor shape if possible.

--------------------------------------------------------------------------------
drkns 2023-07-15 10:39:13+01:00 - build 6173

1. Fix a crash in prompt format parser.

2. Propagate taskbar state to the terminal.

3. Refactoring.

--------------------------------------------------------------------------------
zg 2023-07-12 22:29:50+03:00 - build 6172

1. far didn't ask to save unsaved data in editor then menu was active and the console window is closed with "X".

--------------------------------------------------------------------------------
drkns 2023-06-28 22:58:23+01:00 - build 6171

1. Continue 6170 & other highly experimental improvements in mouse processing.

--------------------------------------------------------------------------------
drkns 2023-06-27 21:47:13+01:00 - build 6170

1. Improve mouse buttons to fake macro keys translation.

--------------------------------------------------------------------------------
drkns 2023-06-27 19:58:03+01:00 - build 6169

1. Using a foreign format exclusively for the clipboard text size was probably not a good idea.
   E.g. now copying text between 6167 and 6168 is broken. Oops.

   To avoid repeating the same mistake in the future, we now have our own format ("FAR_Text_Length")
   and resort to "Notepad++ binary text length" only when our own format is not available.

2. With some magic copying text from pre-6168 should now work.
   Unfortunately, time travel is not yet discovered, so copying text into pre-6168 remains broken.

--------------------------------------------------------------------------------
zg 2023-06-26 20:55:27+03:00 - build 6168

1. correction of 4496. notepad++ expects data size in bytes including final '\0'.

--------------------------------------------------------------------------------
MZK 2023-06-20 19:53:29-07:00 - build 6167

1. More ways to scroll VMenu lists horizontally.
   - Ctrl+Alt+Arrows scroll all items by 20 characters at a time.
   - Ctrl+Shift+Arrows scroll the selected item by 20 characters at a time.
   - Alt+Shift+Home aligns the selected item to the left.
   - Alt+Shift+End aligns the selected item to the right.

--------------------------------------------------------------------------------
drkns 2023-06-20 20:01:57+01:00 - build 6166

1. Configurable cursor size in screen grabber.

--------------------------------------------------------------------------------
johnd0e 2023-06-17 14:55:00+01:00 - build 6165

1. Allow to break directory scan started from a macro (Mantis#0002692).
   Fix by Shmuel: https://github.com/shmuz/far2m/issues/36

--------------------------------------------------------------------------------
drkns 2023-06-14 20:01:09+01:00 - build 6164

1. Subscribe to power events only when needed.

2. Support more reparse tags.

3. Static analysis warnings.

4. Refactoring.

--------------------------------------------------------------------------------
drkns 2023-06-10 10:50:50+01:00 - build 6163

1. gh-704: Multiple log files created and console logs empty in sync mode.

--------------------------------------------------------------------------------
drkns 2023-06-09 19:49:34+01:00 - build 6162

1. Address gh-702 comments:
   - System.MsWheelThreshold option to adjust wheel sensitivity.
   - Discard accumulated events on scrolling direction change.

--------------------------------------------------------------------------------
drkns 2023-06-08 20:25:38+01:00 - build 6161

1. Continue 6159: finer-resolution wheels/pads should now work more or less as expected.

--------------------------------------------------------------------------------
drkns 2023-06-08 08:21:33+01:00 - build 6160

1. gh-702: Trackpad scrolling issue in build 6159.

--------------------------------------------------------------------------------
drkns 2023-06-07 22:32:00+01:00 - build 6159

1. Improve mouse wheel handling:
   - Take into account that one mouse event can describe more than one wheel detent.
   - Use OS wheel settings when System.Ms[H]WheelDelta* parameters are set to 0.

--------------------------------------------------------------------------------
drkns 2023-06-02 20:53:21+01:00 - build 6158

1. NumLeft & NumRight don't work as intended with radiobuttons.
   An ancient bug, planted 21 years ago.

--------------------------------------------------------------------------------
w17 2023-05-31 12:18:13+03:00 - build 6157

1. Continue 6155, 6153, 6152
   Correction for Temporary panel (OPIF_REALNAMES)

--------------------------------------------------------------------------------
MZK 2023-05-29 11:49:01-07:00 - build 6156

1. gh-697: Fixed disappearing autocomplete list in Search / Replace dialog.
   The bug was introduced in 6144.

--------------------------------------------------------------------------------
w17 2023-05-29 13:25:38+03:00 - build 6155

1. Continue 6153, OPIF_DEL.. on close can be used without RECURSIVEPANEL

--------------------------------------------------------------------------------
drkns 2023-05-29 10:19:46+01:00 - build 6154

1. gh-696: Don't call ProcessConsoleInput on special macro keys.

2. Refactoring.

--------------------------------------------------------------------------------
w17 2023-05-24 21:10:15+03:00 - build 6153

1. Fix 6152

--------------------------------------------------------------------------------
w17 2023-05-24 15:05:42+03:00 - build 6152

1. Continue 6134, 6140
   gh-683: Archive is deleted on close when using prefix to open it from another archive
   PF_RECURSIVEPANEL -> OPIF_RECURSIVEPANEL

--------------------------------------------------------------------------------
MZK 2023-05-21 19:01:56-07:00 - build 6151

1. gh-669: Now Home key works in the Search / Replace dialog.
1.a. Added new FARDIALOGITEMFLAGS: DIF_HOMEITEM.
     This flag indicates the item which should take focus on Home key press.
     Note: The first "focusable" item is not always the best target for Home key.
     It is a good idea to set this flag on the item which initially has DIF_FOCUS.

--------------------------------------------------------------------------------
drkns 2023-05-21 18:36:11+01:00 - build 6150

1. Adjust CreateFile access & sharing flags in a few places.

--------------------------------------------------------------------------------
drkns 2023-05-20 19:37:43+01:00 - build 6149

1. gh-692: Change time for read-only or system files cannot be set

2. gh-693: Change time cannot be set simultaneously with other file attributes

3. gh-694: File creation time lost after saving read-only file on secondary disk

--------------------------------------------------------------------------------
drkns 2023-05-20 17:54:07+01:00 - build 6148

1. More gh-691.

2. Exception handling improvements.

--------------------------------------------------------------------------------
johnd0e 2023-05-19 21:21:00+02:00 - build 6147

1. gh-691: Macros: fix Panel.Select.
   (patch by Shmuel)

--------------------------------------------------------------------------------
skipik 2023-05-16 19:36:39+03:00 - build 6146

1. SQLite v3.42.0

--------------------------------------------------------------------------------
w17 2023-05-16 15:39:22+03:00 - build 6145

1. Continue 6139 -- missed change

--------------------------------------------------------------------------------
MZK 2023-05-15 13:39:37-07:00 - build 6144

1. Fallout of 6135: Persist forgotten Find File dialog options.
1.1. gh-681: Persist empty search pattern.
1.2. gh-685: Persist "Search in archives" option.
1.3. gh-681: Find File content search parameters (search pattern, hex,
     case sensitive, whole words, fuzzy) are not shared with Viewer / Editor.
     However, if the search pattern is not empty, Find File content search
     parameters are copied to Viewer / Editor search.

2. gh-681: Do not allow empty search pattern in Viewer and Editor search dialog.

--------------------------------------------------------------------------------
drkns 2023-05-15 19:38:57+01:00 - build 6143

1. gh-687: Commands history: empty Folder for commands with host-file plugin prefix run via file association.

--------------------------------------------------------------------------------
drkns 2023-05-13 20:18:31+01:00 - build 6142

1. Improve insanely slow help rendering on large screens.
   I won't go into details, but we should rewrite the whole thing.

--------------------------------------------------------------------------------
drkns 2023-05-12 19:31:11+01:00 - build 6141

1. Remove sorting from Task List.
   Now it's MRU, as before 3451.

--------------------------------------------------------------------------------
w17 2023-05-12 14:00:05+03:00 - build 6140

1. Continue 6134.
   gh-680: Enable Recursive Plugin Panels for Plugin.Command Calls

--------------------------------------------------------------------------------
w17 2023-05-12 12:06:40+03:00 - build 6139

1. https://bugs.farmanager.com/view.php?id=3447
   Provide alive macro API in ExitFAR event.

--------------------------------------------------------------------------------
drkns 2023-05-11 19:36:13+01:00 - build 6138

1. fmt 10.0.0.

--------------------------------------------------------------------------------
drkns 2023-05-08 19:32:14+01:00 - build 6137

1. Enable consteval in fmt.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2023-05-06 20:55:00+01:00 - build 6136

1. Extend internal RGB color picker (similar to 256).

2. Refactoring.

--------------------------------------------------------------------------------
MZK 2023-05-05 22:02:12-07:00 - build 6135

1. gh-612: Help Search parameters are preserved between Help sessions.

2. gh-613: Search patterns and parameters are shared between
   Viewer, Editor, and Find File.

--------------------------------------------------------------------------------
w17 2023-05-04 22:01:33+03:00 - build 6134

1. Experimental: Auto plugin panel stack for PF_RECURSIVEPANEL plugins
   https://forum.farmanager.com/viewtopic.php?t=13202

--------------------------------------------------------------------------------
drkns 2023-04-29 00:28:52+01:00 - build 6133

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2023-04-14 00:24:32+01:00 - build 6132

1. Exception handling improvements.

2. Warnings.

--------------------------------------------------------------------------------
drkns 2023-04-13 00:55:13+01:00 - build 6131

1. Exception handling improvements.

--------------------------------------------------------------------------------
w17 2023-04-12 03:32:44+03:00 - build 6130

1. Continue 6124 -- Don't show Disk/Sort menu if [ ] Show sort mode letter

--------------------------------------------------------------------------------
drkns 2023-04-08 16:10:54+01:00 - build 6129

1. Exception handling improvements.

--------------------------------------------------------------------------------
w17 2023-04-02 10:03:32+03:00 - build 6128

1. Avoid far crash when lua script calls far.Host.GetFiles() for passive panel
   and active panel is not plugin panel.
   https://sourceforge.net/p/farplugs/tickets/205/

--------------------------------------------------------------------------------
MZK 2023-03-31 22:22:52-07:00 - build 6127

1. Continuation of 6122. Follow-up on the discussion in gh-662.
   Swapped buttons on the Search / Replace dialog and removed vertical separator.

--------------------------------------------------------------------------------
drkns 2023-03-31 21:11:07+01:00 - build 6126

1. Correction of 6101.

--------------------------------------------------------------------------------
w17 2023-03-31 10:49:36+03:00 - build 6125

1. Correct 6124

--------------------------------------------------------------------------------
w17 2023-03-31 09:21:17+03:00 - build 6124

1. Forum: Mouse click on Sort order mark letter didn't work if [ ] Show column titles
   https://forum.farmanager.com/viewtopic.php?t=13178

--------------------------------------------------------------------------------
drkns 2023-03-28 19:17:03+01:00 - build 6123

1. gh-665: Crash after an unexpected panel update.
   This is a rather hairy & global problem, see comments in filelist.hpp.

--------------------------------------------------------------------------------
MZK 2023-03-27 22:03:51-07:00 - build 6122

1. Forum: Search / Replace dialog facelift.
   On popular demand at https://forum.farmanager.com/viewtopic.php?t=13158.

--------------------------------------------------------------------------------
drkns 2023-03-27 22:35:19+01:00 - build 6121

1. gh-663: Fix text <-> hex conversions in Viewer and Find File.

--------------------------------------------------------------------------------
drkns 2023-03-27 18:19:56+01:00 - build 6120

1. New versions of fmt, tinyxml2, Catch2.

2. Refactoring.

3. Make unit tests runnable from IDE.

--------------------------------------------------------------------------------
MZK 2023-03-26 11:56:52-07:00 - build 6119

1. gh-542: Editor Search (plain text): Shift+F7 / Alt+F7 now finds the nearest match,
   even if it overlaps with the last found match.

2. gh-660: Editor Search (regex): Shift+F7 in cursor-at-the-end mode now continues
   from the next character.

--------------------------------------------------------------------------------
skipik 2023-03-22 17:19:19+03:00 - build 6118

1. SQLite v3.41.2.

--------------------------------------------------------------------------------
Yegor 2023-03-11 14:11:00-08:00 - build 6117

1. Fixed the rendering of the mark char if its length or visual length exceeds 1 char

--------------------------------------------------------------------------------
skipik 2023-03-11 00:22:07+03:00 - build 6116

1. SQLite v3.41.1.

--------------------------------------------------------------------------------
drkns 2023-03-10 15:00:26+00:00 - build 6115

1. Rendering fix.

--------------------------------------------------------------------------------
MZK 2023-03-07 20:13:03-08:00 - build 6114

1. gh-600: Shift+F7 and Alt+F7 now search in absolute directions (down or up respectfully)
   instead of reversing the direction defined by the last invocation of the Search / Replace dialog.
   Also, on the dialog itself, replaced "Reverse" checkbox with "Search Down / Up" buttons.

--------------------------------------------------------------------------------
drkns 2023-03-07 17:10:01+00:00 - build 6113

1. gh-650: Pressing Ctrl+Enter in the find all menu of the Editor crashes Far if all entries are filtered out.

--------------------------------------------------------------------------------
drkns 2023-03-07 16:29:53+00:00 - build 6112

1. gh-647: Selection not removed in Editor and edit controls on pressing Ctrl+Num6.

--------------------------------------------------------------------------------
drkns 2023-03-05 21:10:37+00:00 - build 6111

1. Refactoring: implement span in terms of std::span.

2. Clang warnings: remove unused variables.

--------------------------------------------------------------------------------
drkns 2023-02-28 21:43:49+00:00 - build 6110

1. Fix crash when window size is too small.

2. Include more data into minidumps.

--------------------------------------------------------------------------------
drkns 2023-02-25 16:36:54+00:00 - build 6109

1. Include Unicode notation (U+NNNN) into the "character is not supported by the selected code page" warning.

--------------------------------------------------------------------------------
zg 2023-02-24 00:45:38+02:00 - build 6108

1. correction of 6104: SE_FOLDERCHANGED sends only to LuaMacro temporary.

--------------------------------------------------------------------------------
skipik 2023-02-23 13:50:41+03:00 - build 6107

1. SQLite v3.41.0.

--------------------------------------------------------------------------------
drkns 2023-02-22 20:47:28+00:00 - build 6106

1. Refactoring.

--------------------------------------------------------------------------------
zg 2023-02-22 00:19:12+02:00 - build 6105

1. Correction of 5822.2 for persistent blocks.

--------------------------------------------------------------------------------
zg 2023-02-21 20:49:15+02:00 - build 6104

1. experimental: new event SE_FOLDERCHANGED, sent when changing the current directory in panels.

--------------------------------------------------------------------------------
MZK 2023-02-18 12:03:13-08:00

1. gh-614: Restored Viewer type-to-search feature which was removed in 6099.
   Now it is implemented as a macro, see View.TypeToSearch.lua.
   Thanks to all for the discussion and prototyping.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. gh-614: Восстановил функциональность Просмотрщика печатать-чтобы-искать,
   которая была удалена в 6099. Теперь это делается при помощи макроса,
   см. View.TypeToSearch.lua. Спасибо всем за обсуждение и прототипирование.

--------------------------------------------------------------------------------
drkns 2023-02-14 21:56:31+00:00 - build 6103

1. A few fixes.

--------------------------------------------------------------------------------
drkns 2023-02-12 00:38:45+00:00 - build 6102

1. Refactoring.

2. More tests.

3. Warnings.

--------------------------------------------------------------------------------
drkns 2023-02-06 22:08:52+00:00 - build 6101

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2023-02-05 13:01:34+00:00 - build 6100

1. gh-483: Do not update panel curdir too early. Experimental.

2. Refactoring.

3. More logging.

--------------------------------------------------------------------------------
MZK 2023-01-30 21:02:33-08:00 - build 6099

1. Viewer now uses the standard Search dialog.

2. Removed the following features:
   - Opening Viewer's Search dialog on typing the first character of the search pattern.
     See gh-614 for the discussion.
   - Search dialog auto-focus.

--------------------------------------------------------------------------------
rohitab 2023-01-30 01:17:44+11:00 - build 6098

1. gh-617: Allow history to be used with masked edit controls.

--------------------------------------------------------------------------------
MZK 2023-01-28 18:41:14-08:00

1. gh-618: Adjusted hotkey assignments on Search / Replace and Find File dialogs.

--------------------------------------------------------------------------------
drkns 2023-01-24 20:29:40+00:00 - build 6097

1. Continue 6095.

--------------------------------------------------------------------------------
MZK 2023-01-22 09:32:07-08:00 - build 6096

1. Added "Search for Hex" functionality to the unified SearchReplace dialog.
   Internal implementation only; no user-visible changes are expected.

--------------------------------------------------------------------------------
drkns 2023-01-22 21:06:44+00:00 - build 6095

1. Reduce CPU load on Ctrl+Alt+Shift.

--------------------------------------------------------------------------------
drkns 2023-01-20 19:34:14+00:00 - build 6094

1. gh-609: Regexp replace: quantifier applied to a group empties its matched text.
   Fix from Shmuel.

--------------------------------------------------------------------------------
drkns 2023-01-14 00:43:31+00:00 - build 6093

1. Refactoring: lock_guard -> scoped_lock.

2. Deduplicate refresh notifications.

3. Make notitication logs more readable.

--------------------------------------------------------------------------------
drkns 2023-01-09 17:57:23+00:00 - build 6092

1. gh-603: Process list plugin randomly switches selection to other processes with the same name.

2. Minor refactoring.

--------------------------------------------------------------------------------
MZK 2023-01-09 09:33:35-08:00 - build 6091

1. gh-605: Induced focus movement in Viewer Search dialog.

--------------------------------------------------------------------------------
drkns 2023-01-08 20:47:16+00:00 - build 6090

1. gh-601: Search for folders checkbox in Find file dialog not synchronized with Hex control
   Remove all shenanigans with that checkbox.

--------------------------------------------------------------------------------
MZK 2023-01-08 09:26:22-08:00 - build 6089

1. Viewer Search: minor refactoring.

--------------------------------------------------------------------------------
MZK 2023-01-07 20:34:03-08:00 - build 6088

1. Fallout of 6078: fixed Alt+F7 behavior in Viewer Search.

--------------------------------------------------------------------------------
drkns 2023-01-04 21:08:06+00:00 - build 6087

1. gh-583: Submenus with keyboard accelerators display ampersand character in title.

--------------------------------------------------------------------------------
drkns 2023-01-04 18:55:21+00:00 - build 6086

1. gh-591: Duplicate keyboard accelerators in Sort modes.

2. gh-593: Cancelling a copy operation on a symlink creates a zero-byte file.

3. Refactoring.

--------------------------------------------------------------------------------
MZK 2023-01-04 10:26:26-08:00 - build 6085

1. Continuation of 6082. Changed tab order on Find File dialog.
   Now Text/Hex radio is the next after "Containing".

2. gh-592: Bug in 6082. Find File dialog: fixed disappearing searched text
   when pressing the Text/Hex hotkey which matches the current state.

--------------------------------------------------------------------------------
zg 2023-01-04 19:47:50+02:00 - build 6084

1. non tread safe code removed from ACTL_SYNCHRO implementation.

--------------------------------------------------------------------------------
yjh 2023-01-04 12:12:29+03:00 - build 6083

1. SQLite v3.40.1

--------------------------------------------------------------------------------
MZK 2023-01-02 11:22:16-08:00 - build 6082

1. Rearranged Text/Hex controls on Find File dialog.

--------------------------------------------------------------------------------
drkns 2023-01-02 18:55:18+00:00 - build 6081

1. gh-588: Default code page problem.

--------------------------------------------------------------------------------
drkns 2023-01-02 18:09:42+00:00 - build 6080

1. gh-587: Environment variables not expanded when editing links.

--------------------------------------------------------------------------------
drkns 2023-01-01 14:24:37+00:00 - build 6079

1. Remove redundant code from Find File and Viewer Search dialogs.

--------------------------------------------------------------------------------
MZK 2022-12-29 18:02:10-08:00 - build 6078

1. Unifying Viewer and Editor search.
   Part 1: Added Fuzzy search to Viewer text search.

--------------------------------------------------------------------------------
MZK 2022-12-28 21:12:37-08:00 - build 6077

1. gh-581: A couple of bugs in Viewer search (text, forward, cycle).

--------------------------------------------------------------------------------
drkns 2022-12-28 23:57:35+00:00 - build 6076

1. Improve VT rendering in corner cases.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-12-27 19:40:03+00:00 - build 6075

1. If %comspec% is cmd.exe and System.Executor.ExcludeCmds is not specified, a predefined list is used.
   Users don't read the documentation, let alone understand the peculiarities of command execution.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-12-21 18:22:14+00:00 - build 6074

1. gh-576: Autocomplete does not work in a dialog launched from a macro.

2. gh-577 again.

--------------------------------------------------------------------------------
drkns 2022-12-20 20:57:35+00:00 - build 6073

1. gh-577: Configuration editor does not restore filtered state of unchanged options.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-12-19 22:14:19+00:00 - build 6072

1. Improve OS errors preserving during links creation.

2. Refactoring, tests etc.

--------------------------------------------------------------------------------
w17 2022-12-16 03:00:34+03:00 - build 6071

1. gh-573: viewer long regex serch fix

--------------------------------------------------------------------------------
drkns 2022-12-15 19:04:20+00:00 - build 6070

1. gh-575: Plugin help doesn't work when launched from some plugin panels.

2. Refactoring.

--------------------------------------------------------------------------------
w17 2022-12-15 13:23:17+03:00 - build 6069

1. Extend 'HH HH ...' mask in the viewer search dialog.

--------------------------------------------------------------------------------
drkns 2022-12-15 01:11:01+00:00 - build 6068

1. Remove redundant workarounds & homebrew implementations of language features.

--------------------------------------------------------------------------------
drkns 2022-12-14 03:36:13+00:00 - build 6067

1. Continue 6065.2.

--------------------------------------------------------------------------------
drkns 2022-12-14 00:51:14+00:00 - build 6066

1. Shuffle the code to make Clang happy.

2. Improve OS version info display.

3. Refactoring.

4. Bump VS version to 2019.5, GCC to 10.0, Clang to 10.0.

5. Use native concepts instead of SFINAE hacks.

6. Remove redundant workarounds.

--------------------------------------------------------------------------------
drkns 2022-12-13 19:59:11+00:00 - build 6065

1. Fix a typo in 4280.

2. Fix mask processing, broken by 5050.

--------------------------------------------------------------------------------
MZK 2022-12-11 17:22:57-08:00 - build 6064

1. Continuation of 6061:
   Decoupling fuzzy search from case sensitive search. Part 2.

--------------------------------------------------------------------------------
drkns 2022-12-11 23:18:33+00:00 - build 6063

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-12-11 00:58:15+00:00 - build 6062

1. 0003971: Cross-layout key mapping didn't work in some OSes after 5980.

--------------------------------------------------------------------------------
MZK 2022-12-07 19:00:08-08:00 - build 6061

1. Decoupling fuzzy search from case sensitive search. Part 1.

--------------------------------------------------------------------------------
drkns 2022-12-07 20:34:20+00:00 - build 6060

1. Add standard library info to far:about.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-12-07 00:24:41+00:00 - build 6059

1. Decode CLR exceptions.

2. Refactoring.

3. gh-567: Poor warm-up time.
   Continue the "SQLite vs nocase" saga: reindex affected tables only when integrity checks failed.

--------------------------------------------------------------------------------
drkns 2022-11-27 19:25:18+00:00 - build 6058

1. Refactoring.

2. Warnings.

3. More tests.

--------------------------------------------------------------------------------
drkns 2022-11-26 10:33:29+00:00 - build 6057

1. Fix empty sort criteria menus handling.

2. Optimize map file lookup.

--------------------------------------------------------------------------------
drkns 2022-11-24 21:22:23+00:00 - build 6056

1. Fix detach from WT & properly handle alternative buffers.

2. Refactoring, move plarform-specific code around.

--------------------------------------------------------------------------------
drkns 2022-11-18 17:50:19+00:00 - build 6055

1. Refactoring, move plarform-specific code around.

--------------------------------------------------------------------------------
yjh 2022-11-17 14:10:56+03:00 - build 6054

1. SQLite v3.40.0

--------------------------------------------------------------------------------
zg 2022-11-15 22:58:04+02:00 - build 6053

1. forum: quick view not updated after removing file from temporary panel.

--------------------------------------------------------------------------------
drkns 2022-11-15 00:59:12+00:00 - build 6052

1. 0003966: Correction of 5998 again.

--------------------------------------------------------------------------------
drkns 2022-11-10 17:40:00+00:00 - build 6051

1. gh-483: Change histories items order.

--------------------------------------------------------------------------------
drkns 2022-11-09 19:37:38+00:00 - build 6050

1. Recognize reparse point types on plugin panels.

--------------------------------------------------------------------------------
drkns 2022-11-08 19:47:00+00:00 - build 6049

1. Correction of 6047.

--------------------------------------------------------------------------------
drkns 2022-11-08 17:08:16+00:00 - build 6048

1. Correction of 6047.

--------------------------------------------------------------------------------
drkns 2022-11-07 22:07:21+00:00 - build 6047

1. Microsoft keeps fixing things that ain't broken.
   Apparently Windows Terminal is now default and we have another wave of questions about its eye-bleeding palette.
   It is getting annoying, so the classic palette is now set automatically by default,
   overriding any terminal preferences and rejecting any modern fashion trends in UI design.
   If you actually know what a palette is and have your own, turn the override off in color settings.

--------------------------------------------------------------------------------
drkns 2022-11-07 20:19:16+00:00 - build 6046

1. Rework InfoPanel memory section.

2. Fix color processing.

--------------------------------------------------------------------------------
drkns 2022-11-06 23:58:52+00:00 - build 6045

1. Fix ECTL_SETSTRING crash when source and destination strings overlap.

2. Static analysis warnings.

--------------------------------------------------------------------------------
drkns 2022-11-03 20:43:44+00:00 - build 6044

1. Make "path" in "pushd path" optional.

--------------------------------------------------------------------------------
drkns 2022-11-02 21:24:55+00:00 - build 6043

1. Refactoring, move plarform-specific code around.

2. Refactoring, reorganize error checking.

--------------------------------------------------------------------------------
drkns 2022-10-29 18:00:05+01:00 - build 6042

1. Include PE & file timestamps into generated bug reports.

--------------------------------------------------------------------------------
drkns 2022-10-15 19:27:16+01:00 - build 6041

1. Add workaround for incorrect encoding in OS-generated CF_UNICODETEXT.
   See far:config, ClipboardUnicodeWorkaround.

2. Refactoring.

--------------------------------------------------------------------------------
pepak 2022-10-13 20:18:32+01:00 - build 6040

1. Add special symbols to refer to the left ("![") or to the right ("!]") panel.

--------------------------------------------------------------------------------
drkns 2022-10-10 18:06:05+01:00 - build 6039

1. Use the real window handle when running in Windows Terminal.
   This should fix some scenarios like taskbar progress, flashing, icon setting, Alt+F9 etc.
   It also may or may not break your Terminal, who knows.

--------------------------------------------------------------------------------
drkns 2022-10-07 23:13:59+01:00 - build 6038

1. gh-551: Screen scrambled when pressing Alt-F9 under Windows 11 22H2

--------------------------------------------------------------------------------
drkns 2022-10-06 17:43:00+01:00 - build 6037

1. Fix string replace when pattern and/or replacement are views into the same string.

--------------------------------------------------------------------------------
drkns 2022-10-05 23:47:54+01:00 - build 6036

1. Remove "Colors - Black and white mode".

2. Add "Colors - Set default colors (RGB)" - same as "Set default colors", but fixed RGB values instead of indices.

--------------------------------------------------------------------------------
drkns 2022-10-05 17:15:46+01:00 - build 6035

1. far:regex: include offsets into match information.

2. Fix 6030.1.

--------------------------------------------------------------------------------
drkns 2022-10-04 21:56:22+01:00 - build 6034

1. Use IMultiLanguage2 for codepage detection.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-10-03 23:20:09+01:00 - build 6033

1. Add regex testing UI - far:regex

2. Fix regex named groups processing in cases like a(?{name}.)?b, improve tests

3. Suppress logs once the logger is destroyed.

4. Minor refactoring.

--------------------------------------------------------------------------------
yjh 2022-10-03 00:22:43+03:00 - build 6032

1. SQLite v3.39.4.

--------------------------------------------------------------------------------
drkns 2022-10-02 21:16:49+01:00 - build 6031

1. Correction of 6030.

--------------------------------------------------------------------------------
drkns 2022-10-02 19:29:07+01:00 - build 6030

1. Named groups in regular expressions are now included into the usual match list and can be referred by number in order of appearance.

2. Named groups support in RegExpControl:
   After a successful RECTL_MATCHEX/RECTL_SEARCHEX call RECTL_NAMEDGROUPINDEX with Param1 = 0 and Param2 = <group name>.
   The return value is the index of the group in the RegExpSearch.Match array, populated by the last call to match/search.

--------------------------------------------------------------------------------
drkns 2022-09-29 18:22:32+01:00 - build 6029

1. Capture dbgeng and dbghelp logs.

--------------------------------------------------------------------------------
drkns 2022-09-21 17:59:59+01:00 - build 6028

1. Fix colors import/export.

--------------------------------------------------------------------------------
drkns 2022-09-18 02:18:21+01:00 - build 6027

1. Support ASan exceptions.

--------------------------------------------------------------------------------
drkns 2022-09-16 22:16:00+01:00 - build 6026

1. Forum: ESC/F10 does not close Change Drive dialog in "elevated" folders.

--------------------------------------------------------------------------------
drkns 2022-09-16 00:08:25+01:00 - build 6025

1. Crash on panel update.

--------------------------------------------------------------------------------
drkns 2022-09-14 23:47:31+01:00 - build 6024

1. Show inline frames in stack traces.

--------------------------------------------------------------------------------
drkns 2022-09-13 22:45:05+01:00 - build 6023

1. fmt 9.1.1.

2. Catch2 2.13.9.

--------------------------------------------------------------------------------
drkns 2022-09-13 19:34:03+01:00 - build 6022

1. Optimise VT throughput.

2. Fix VT double underline to underline transitioning.

3. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-09-10 18:06:24+01:00 - build 6021

1. Add smooth rotation to 256 color picker.

--------------------------------------------------------------------------------
drkns 2022-09-08 01:08:00+01:00 - build 6020

1. Ignore directories when looking for specific file masks, e.g. lng & hlf.

2. Improve exception messages.

3. Improve recovery after exceptions in window processing.

4. Handle exceptions in help & remove a few old workarounds.

--------------------------------------------------------------------------------
yjh 2022-09-07 00:39:44+03:00 - build 6019

1. SQLite v3.39.3.

--------------------------------------------------------------------------------
drkns 2022-09-04 18:26:41+01:00 - build 6018

1. 0003336: Regex \{(.)?\} finds } in {}.

--------------------------------------------------------------------------------
drkns 2022-09-04 16:59:33+01:00 - build 6017

1. Enable VT directly from color dialog if supported.

--------------------------------------------------------------------------------
drkns 2022-08-31 20:57:09+01:00 - build 6016

1. Support FILE_ATTRIBUTE_DEVICE.

2. Use SAFESEH on x86.

3. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-08-30 19:54:53+01:00 - build 6015

1. Improve exception diagnostics.

--------------------------------------------------------------------------------
drkns 2022-08-29 21:59:46+01:00 - build 6014

1. Refactoring.

2. Correction of 5998.

3. Minor hlf corrections.

--------------------------------------------------------------------------------
drkns 2022-08-13 23:34:12+01:00 - build 6013

1. Whole words regex search in editor.

--------------------------------------------------------------------------------
drkns 2022-08-13 14:23:53+01:00 - build 6012

1. Include disassembly in bug_report.txt.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-08-10 22:34:43+01:00 - build 6011

1. Fix change disk dialog behavior.

2. Do not try to execute empty commands.

3. Fix build in VS 2022 17.4.

--------------------------------------------------------------------------------
MZK 2022-08-06 18:26:39-07:00 - build 6010

1. Fixed two bugs in the string search algorithm.

--------------------------------------------------------------------------------
drkns 2022-08-06 15:34:28+01:00 - build 6009

1. Improve exception diagnostics.

--------------------------------------------------------------------------------
drkns 2022-08-06 11:11:06+01:00 - build 6008

1. Fix Undo issue after 5916 & continue #0003907.

--------------------------------------------------------------------------------
drkns 2022-08-05 20:04:28+01:00 - build 6007

1. Improve exception diagnostics.

--------------------------------------------------------------------------------
drkns 2022-08-04 20:33:22+01:00 - build 6006

1. Fix filters issue after swapping panels.

2. Suppress plugin selection dialog during search.

--------------------------------------------------------------------------------
drkns 2022-08-02 22:50:15+01:00 - build 6005

1. "[x] Search in archives" was trying to read directories.

--------------------------------------------------------------------------------
drkns 2022-08-02 19:47:00+01:00 - build 6004

1. Correction of 5600.

2. Correction of 5983.

--------------------------------------------------------------------------------
drkns 2022-08-01 20:30:44+01:00 - build 6003

1. Extend RGB color picker.

2. Restore w2k compatibility.

3. Minor fixes.

--------------------------------------------------------------------------------
drkns 2022-08-01 02:51:40+01:00 - build 6002

1. Extend 256 color picker.

--------------------------------------------------------------------------------
drkns 2022-07-30 22:27:06+01:00 - build 6001

1. Refactoring.

2. Improve exception diagnostics.

3. Support UTF-8 in far.exe.ini.

4. Correction of 5936.

5. Correction of 5998.

--------------------------------------------------------------------------------
drkns 2022-07-22 23:55:11+01:00 - build 6000

1. Refactoring.

--------------------------------------------------------------------------------
yjh 2022-07-22 01:34:04+03:00 - build 5999

1. SQLite v3.39.2.

--------------------------------------------------------------------------------
drkns 2022-07-17 17:54:30+01:00 - build 5998

1. Continue fullwidth-aware rendering.

--------------------------------------------------------------------------------
drkns 2022-07-16 23:17:49+01:00 - build 5997

1. Continue 5996.

--------------------------------------------------------------------------------
drkns 2022-07-16 20:44:11+01:00 - build 5996

1. Files highlighting - Marking character can contain any number of characters.

--------------------------------------------------------------------------------
drkns 2022-07-16 00:16:57+01:00 - build 5995

1. Refactoring.

2. Add logger icon.

--------------------------------------------------------------------------------
yjh 2022-07-14 21:58:48+03:00 - build 5994

1. SQLite v3.39.1.

--------------------------------------------------------------------------------
drkns 2022-07-13 19:29:19+01:00 - build 5993

2. Continue fullwidth-aware rendering.

--------------------------------------------------------------------------------
drkns 2022-07-11 21:44:15+01:00 - build 5992

1. Switch to conformant preprocessor.

2. Refactoring.

3. Menu width correction.

4. Fix "use shell name" in disk menu.

--------------------------------------------------------------------------------
drkns 2022-07-08 08:39:53+01:00 - build 5991

1. Correction of 5989.2.

--------------------------------------------------------------------------------
drkns 2022-07-06 23:29:00+01:00 - build 5990

1. fmt v9.

2. Improve exception diagnostics, refactoring.

--------------------------------------------------------------------------------
drkns 2022-07-02 19:56:01+01:00 - build 5989

1. Improve exception diagnostics.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-06-28 02:04:55+01:00 - build 5988

1. Correction of 5983 or #0003951.

--------------------------------------------------------------------------------
drkns 2022-06-26 21:57:48+01:00 - build 5987

1. Continue 5985.

2. #0003950 - excessive attempts to set the owner when working with folders.

--------------------------------------------------------------------------------
yjh 2022-06-26 01:28:46+03:00 - build 5986

1. SQLite v3.39.0.

--------------------------------------------------------------------------------
drkns 2022-06-25 23:06:40+01:00 - build 5985

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-06-24 20:41:44+01:00 - build 5984

1. Add color picker dialog help page.

2. UI colors can be reset separately.

--------------------------------------------------------------------------------
drkns 2022-06-23 19:19:19+01:00 - build 5983

1. Workaround for broken half-width surrogates (e.g. "𝔟𝔞𝔫𝔞𝔫𝔞") in conhost & WT.

--------------------------------------------------------------------------------
drkns 2022-06-22 23:59:59+01:00 - build 5982

1. gh-532: Copy file bigger than target file system can store.
   Do not proceed if we can't reserve the space for the file.

--------------------------------------------------------------------------------
EugeneManushkin 2022-06-22 14:09:17+03:00 - build 5981

1. Allow run modal editor with XC_OPEN_NEWINSTANCE exit code. This fix invalid EF_OPENMODE_NEWIFOPEN flag behaviour #530.

--------------------------------------------------------------------------------
drkns 2022-06-20 22:32:45+01:00 - build 5980

1. Allow sourcing of keyboard mappings from xlat tables.

2. Minor refactoring.

--------------------------------------------------------------------------------
drkns 2022-06-12 20:20:20+01:00 - build 5979

1. 256 color palette support.

2. More "style" attributes: inverse, invisible.

3. Minor fixes.

--------------------------------------------------------------------------------
drkns 2022-06-08 23:20:56+01:00 - build 5978

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-06-07 01:31:20+01:00 - build 5977

1. More logging.

--------------------------------------------------------------------------------
drkns 2022-06-04 12:37:01+01:00 - build 5976

1. Correction of 5972.2.

--------------------------------------------------------------------------------
drkns 2022-06-03 22:47:43+01:00 - build 5975

1. Another day, another workaround for Windows 10 console.

2. More logging.

--------------------------------------------------------------------------------
yjh 2022-06-01 17:39:33+03:00 - build  5974

1. Fix GPF (in 32bit release) when build with VS2022 (19.32)

--------------------------------------------------------------------------------
drkns 2022-06-01 00:54:02+01:00 - build 5973

1. Improve exception diagnostics.

2. Use Clang and GCC maps for stack traces enrichment.

--------------------------------------------------------------------------------
drkns 2022-05-29 20:03:12+01:00 - build 5972

1. Improve exception diagnostics.

2. Validate command line arguments.

--------------------------------------------------------------------------------
drkns 2022-05-25 01:00:56+01:00 - build 5971

1. Continue 5970.

--------------------------------------------------------------------------------
drkns 2022-05-24 21:18:27+01:00 - build 5970

1. Intercept heap corruption.

--------------------------------------------------------------------------------
yjh 2022-05-07 22:32:09+03:00 - build 5969

1. SQLite v3.38.5.

--------------------------------------------------------------------------------
yjh 2022-05-05 01:02:21+03:00 - build 5968

1. SQLite v3.38.4.

--------------------------------------------------------------------------------
yjh 2022-04-28 01:20:26+03:00 - build 5967

1. SQLite v3.38.3.

--------------------------------------------------------------------------------
drkns 2022-04-24 17:14:58+01:00 - build 5966

1. 0003940: Editor crash when changing codepage to UTF16BE.

--------------------------------------------------------------------------------
drkns 2022-04-18 03:16:06+01:00 - build 5965

1. Correction of 5955.1.

--------------------------------------------------------------------------------
yjh 2022-03-28 12:19:04+03:00 - build 5964

1. SQLite v3.38.2.

--------------------------------------------------------------------------------
drkns 2022-02-24 01:23:37+00:00 - build 5963

1. Improve SQLite diagnostics.

2. More logging.

3. Refactoring.

--------------------------------------------------------------------------------
skipik 2022-02-23 19:46:25+03:00 - build 5962

1. SQLite v3.38.0.

--------------------------------------------------------------------------------
drkns 2022-02-04 17:54:40+00:00 - build 5961

1. Continue 5960.

--------------------------------------------------------------------------------
drkns 2022-02-04 00:15:55+00:00 - build 5960

1. Continue 5905: associations were overlooked.

--------------------------------------------------------------------------------
drkns 2022-02-02 02:02:02+00:00 - build 5959

1. Improve exception diagnostics.

--------------------------------------------------------------------------------
drkns 2022-02-01 01:17:02+00:00 - build 5958

1. Improve diagnostics in "access denied" errors.

--------------------------------------------------------------------------------
drkns 2022-01-28 09:21:47+00:00 - build 5957

1. Wrong backwards regex replace with named groups and multiple matches within the line.

2. Regex search didn't work in Help.

3. Regex should be truly thread-safe now (search/match-wise).

4. Other corner case regex fixes.

5. Refactoring.

--------------------------------------------------------------------------------
drkns 2022-01-25 00:07:30+00:00 - build 5956

1. Correction of 5955.1.

--------------------------------------------------------------------------------
drkns 2022-01-20 20:41:13+00:00 - build 5955

1. Refactoring.

2. GUID for "Groups of file masks" dialog.

--------------------------------------------------------------------------------
w17 2022-01-12 22:01:17+03:00 - build 5954

1. simplify disk sector size logic

--------------------------------------------------------------------------------
skipik 2022-01-07 14:11:12+03:00 - build 5953

1. SQLite v3.37.2.

--------------------------------------------------------------------------------
drkns 2022-01-04 21:22:37+00:00 - build 5952

1. Refactoring.

--------------------------------------------------------------------------------
skipik 2022-01-03 22:53:17+03:00 - build 5951

1. SQLite v3.37.1.

--------------------------------------------------------------------------------
drkns 2021-12-29 22:42:45+00:00 - build 5950

1. Crash (or two) on console detach.

--------------------------------------------------------------------------------
drkns 2021-12-26 13:58:32+00:00 - build 5949

1. Deadlock in executor in certain scenarios.

--------------------------------------------------------------------------------
drkns 2021-12-25 22:33:14+00:00 - build 5948

1. FS monitoring again.

--------------------------------------------------------------------------------
drkns 2021-12-25 16:27:10+00:00 - build 5947

1. Fix URLs processing in Help.

--------------------------------------------------------------------------------
drkns 2021-12-23 22:36:54+00:00 - build 5946

1. gh-502: Another parentheses-related issue.

--------------------------------------------------------------------------------
drkns 2021-12-23 17:28:03+00:00 - build 5945

1. gh-502: Removal of Parenthesis from a User Variable Initial Value in F2 User Command.

2. Minor refactoring & tests.

--------------------------------------------------------------------------------
drkns 2021-12-23 02:14:27+00:00 - build 5944

1. FS monitoring rework (again).
   Now only one extra thread.

--------------------------------------------------------------------------------
drkns 2021-12-22 20:00:38+00:00 - build 5943

1. Delay load config DBs.

--------------------------------------------------------------------------------
drkns 2021-12-22 02:14:35+00:00 - build 5942

1. Continue 5890: fuzzy search is now optional.
   It can be activated with the third state of the "Case sensitive" option in dialogs.

--------------------------------------------------------------------------------
drkns 2021-12-22 00:17:17+00:00 - build 5941

1. Refactoring.

2. Add a help page for sort criteria.

--------------------------------------------------------------------------------
drkns 2021-12-19 13:30:58+00:00 - build 5940

1. Continue 5938.

--------------------------------------------------------------------------------
drkns 2021-12-18 03:37:55+00:00 - build 5939

1. Alternative NTSTATUS accessing.

--------------------------------------------------------------------------------
drkns 2021-12-18 01:09:04+00:00 - build 5938

1. FS monitoring rework (again).
   "System settings - Update panels only when Far is active" is no longer needed and removed.

--------------------------------------------------------------------------------
drkns 2021-12-15 16:24:56+00:00 - build 5937

1. Data alignment corrections.

--------------------------------------------------------------------------------
drkns 2021-12-14 12:12:19+00:00 - build 5936

1. Correction of 5932.

--------------------------------------------------------------------------------
drkns 2021-12-13 23:10:45+00:00 - build 5935

1. Correction of 5932.

--------------------------------------------------------------------------------
drkns 2021-12-13 21:58:58+00:00 - build 5934

1. Forum: incorrect percents in editor progress bar (and potentially elsewhere).

--------------------------------------------------------------------------------
drkns 2021-12-13 12:50:18+00:00 - build 5933

1. Typo.

--------------------------------------------------------------------------------
drkns 2021-12-13 02:32:37+00:00 - build 5932

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-12-10 23:51:14+00:00 - build 5931

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-12-09 17:35:00+00:00 - build 5930

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-12-09 03:02:46+00:00 - build 5929

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-12-05 02:27:10+00:00 - build 5928

1. Continue 2493: now it works with folders as well.

--------------------------------------------------------------------------------
drkns 2021-12-03 23:17:16+00:00 - build 5927

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-12-02 18:21:35+00:00 - build 5926

1. 0003919 again.

--------------------------------------------------------------------------------
skipik 2021-12-01 21:42:37+03:00 - build 5925

1. SQLite 3.37.0.

--------------------------------------------------------------------------------
drkns 2021-12-02 01:03:27+00:00 - build 5924

1. 0003919: Crash on Alt+Enter.
   Windows 10 is a PITA.

--------------------------------------------------------------------------------
drkns 2021-11-26 01:22:00+00:00 - build 5923

1. 0003918: Manual non-Persistent selection in Viewer broken since build 5833.

--------------------------------------------------------------------------------
drkns 2021-11-24 22:49:22+00:00 - build 5922

1. 0003915: Redundant environment expansion in Folders History.

2. gh-481: Issue with navigation if dir structure was deleted outside of far.

--------------------------------------------------------------------------------
drkns 2021-11-24 17:10:25+00:00 - build 5921

1. Incorrect console title while copying files.

--------------------------------------------------------------------------------
drkns 2021-11-18 17:21:33+00:00 - build 5920

1. microsoft/terminal#11780: don't use C1 CSI for rendering.

--------------------------------------------------------------------------------
drkns 2021-11-17 22:46:07+00:00 - build 5919

1. Make search dialog more mouse-friendly.

--------------------------------------------------------------------------------
drkns 2021-11-16 21:51:24+00:00 - build 5918

1. Another fix for search in UTF-8 files. Multibyte code pages are Pure Evil.

--------------------------------------------------------------------------------
drkns 2021-11-14 22:07:29+00:00 - build 5917

1. Incorrect console title while deleting files.

--------------------------------------------------------------------------------
drkns 2021-11-14 21:34:19+00:00 - build 5916

1. 0003907: Undo after inserting with mouse.

--------------------------------------------------------------------------------
drkns 2021-11-10 23:37:46+00:00 - build 5915

1. gh-469: Unexpected delay between pressing F3 and showing the window

--------------------------------------------------------------------------------
drkns 2021-11-08 17:11:18+00:00 - build 5914

1. Correction of 5911.

--------------------------------------------------------------------------------
drkns 2021-11-07 11:27:01+00:00 - build 5913

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-11-03 16:31:26+00:00 - build 5912

1. 0003898: Sort layers menu not updated when changed.

2. Warnings.

--------------------------------------------------------------------------------
drkns 2021-11-03 11:51:32+00:00 - build 5911

1. Correction of 5909.

--------------------------------------------------------------------------------
johnd0e 2021-10-31 17:45:00+02:00 - build 5910

1. Panel API: ignore PluginId in GetPluginDirList
   because hPanel is enough.
   (patch by Shmuel)

--------------------------------------------------------------------------------
drkns 2021-10-31 13:56:15+00:00 - build 5909

1. Refactoring.

2. New versions of fmt, tinyxml2, Catch2.

3. Update translations.

--------------------------------------------------------------------------------
drkns 2021-10-28 00:46:04+01:00 - build 5908

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-10-27 02:13:23+01:00 - build 5907

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-10-26 00:31:11+01:00 - build 5906

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-10-22 18:06:14+01:00 - build 5905

1. gh-458: Wrong file path

--------------------------------------------------------------------------------
drkns 2021-10-19 19:58:55+01:00 - build 5904

1. Optimise adding, deleting, marking history.

2. Fix open combobox position.

--------------------------------------------------------------------------------
drkns 2021-10-18 17:08:39+01:00 - build 5903

1. 0003904: Plugin error after update.

--------------------------------------------------------------------------------
drkns 2021-10-12 18:09:00+01:00 - build 5902

1. 0003902: Panel.FAttr doesn't work on TmpPanel.

--------------------------------------------------------------------------------
drkns 2021-10-07 08:54:21+01:00 - build 5901

1. Continue 5900.

--------------------------------------------------------------------------------
drkns 2021-10-07 01:38:53+01:00 - build 5900

1. Partial revert to pre-5850 behaviour of progress dialogs. It's not ready yet.

--------------------------------------------------------------------------------
drkns 2021-10-07 00:35:33+01:00 - build 5899

1. Potential crash in plugin panels.

--------------------------------------------------------------------------------
drkns 2021-10-06 20:38:28+01:00 - build 5898

1. Forum: wrong selection in editor.

--------------------------------------------------------------------------------
drkns 2021-10-04 21:40:39+01:00 - build 5897

1. Continue 5890.

--------------------------------------------------------------------------------
drkns 2021-10-03 23:28:47+01:00 - build 5896

1. Improve exception handling in Find File.

--------------------------------------------------------------------------------
drkns 2021-10-03 23:13:33+01:00 - build 5895

1. Correction of 5890.

--------------------------------------------------------------------------------
drkns 2021-10-03 21:55:37+01:00 - build 5894

1. Include plugin info in exception dialog.

--------------------------------------------------------------------------------
drkns 2021-10-02 15:01:35+01:00 - build 5893

1. 0003897: File marking character in status line disappears after invoking user menu.

--------------------------------------------------------------------------------
drkns 2021-09-30 18:11:48+01:00 - build 5892

1. Correction of 5890.

--------------------------------------------------------------------------------
drkns 2021-09-25 22:06:04+01:00 - build 5891

1. Correction of 5890.

--------------------------------------------------------------------------------
drkns 2021-09-25 03:00:00+01:00 - build 5890

1. Experimental: fuzzy search in panels, editor and help: a can match àáâãäåāăą, еи - ёй, き- ぎ, Æ - ae, ß - ss and so on and vice versa.
   Beware of bugs.

2. Wrong files reading in certain rare scenarios, e.g. when a multibyte character or EOL falls on the read buffer boundary.

--------------------------------------------------------------------------------
drkns 2021-09-19 14:47:00+01:00 - build 5889

1. Support more reparse tags.

--------------------------------------------------------------------------------
drkns 2021-09-18 17:44:44+01:00 - build 5888

1. gh-449: Security concern: execute exe file without extension

--------------------------------------------------------------------------------
drkns 2021-09-15 18:26:08+01:00 - build 5887

1. Far now can use map files to enrich stack traces directly.

2. FExcept is no longer used.

--------------------------------------------------------------------------------
drkns 2021-09-01 20:51:01+01:00 - build 5886

1. gh-437: File list copy: Wrong number of total bytes on retry.

2. Correction of 5860.

--------------------------------------------------------------------------------
drkns 2021-08-29 22:22:22+01:00 - build 5885

1. Don't add Unicode BOM to file lists created with !@! (5740 again).

--------------------------------------------------------------------------------
drkns 2021-08-28 23:39:58+01:00 - build 5884

1. Improve buffer size change detection.

--------------------------------------------------------------------------------
drkns 2021-08-22 21:35:05+01:00 - build 5883

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-21 21:38:32+01:00 - build 5882

1. Continue 5881.1.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-20 19:42:31+01:00 - build 5881

1. Adjust filters behavior in Find File.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-19 18:33:48+01:00 - build 5880

1. Minor correction of moving dialog focus with hotkeys.

2. gh-436: Difference between help file and dialog window.

--------------------------------------------------------------------------------
drkns 2021-08-17 20:16:51+01:00 - build 5879

1. Forum: Stack overflow on panel update.

--------------------------------------------------------------------------------
drkns 2021-08-17 00:01:53+01:00 - build 5878

1. Correction of 5875.

--------------------------------------------------------------------------------
drkns 2021-08-16 21:46:12+01:00 - build 5877

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-16 17:34:55+01:00 - build 5876

1. Forum: some visual distinction for the "Inherit" flag in the Color dialog & hotkeys.

2. Minor executor correction.

3. Stop looking for GetColorDialog in extendedconsole.dll.

--------------------------------------------------------------------------------
drkns 2021-08-12 00:11:15+01:00 - build 5875

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-11 01:57:17+01:00 - build 5874

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-10 01:01:01+01:00 - build 5873

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-08-08 13:05:04+01:00 - build 5872

1. 0003891: Panel scrollbar wasn't shown in multicolumn modes in corner cases.

--------------------------------------------------------------------------------
drkns 2021-08-08 10:45:59+01:00 - build 5871

1. Pass both OPM_FIND and OPM_SILENT to plugins during directory scans.

--------------------------------------------------------------------------------
drkns 2021-08-07 12:26:09+01:00 - build 5870

1. Forum: Copy contents of symbolic links & total copy size.

--------------------------------------------------------------------------------
drkns 2021-08-04 22:55:19+01:00 - build 5869

2. Correction of 5865.

--------------------------------------------------------------------------------
drkns 2021-08-04 18:55:09+01:00 - build 5868

1. Continue 5866.

--------------------------------------------------------------------------------
drkns 2021-08-03 17:48:48+01:00 - build 5867

1. 0003889: Editor white space wasn't rendered in certain cases.

2. Correction of 5862.

--------------------------------------------------------------------------------
drkns 2021-08-03 02:04:01+01:00 - build 5866

1. Remove all fake dialogs & preredraw magic.

--------------------------------------------------------------------------------
drkns 2021-08-02 21:01:36+01:00 - build 5865

1. Remove more fake dialogs.

2. Minor performance optimisations.

--------------------------------------------------------------------------------
drkns 2021-08-01 15:34:13+01:00 - build 5864

1. Remove more fake dialogs.

--------------------------------------------------------------------------------
drkns 2021-07-31 14:22:45+01:00 - build 5863

1. Continue 5862.1.

--------------------------------------------------------------------------------
drkns 2021-07-31 12:58:27+01:00 - build 5862

1. gh-428: Security Issue: Execute the exe file when opening a file with same filename without file extension.

2. Correctly show the shell type (if any) for files without extension.

--------------------------------------------------------------------------------
drkns 2021-07-30 02:27:00+01:00 - build 5861

1. Correction of 5860.

--------------------------------------------------------------------------------
drkns 2021-07-29 23:04:52+01:00 - build 5860

1. Optimise adding items to history.

--------------------------------------------------------------------------------
drkns 2021-07-29 19:41:27+01:00 - build 5859

1. Fix a potential crash at exit.

2. Continue 5845.6 - do not populate FarDialogItem.ListItems in DN_DRAWDLGITEM.

--------------------------------------------------------------------------------
drkns 2021-07-26 17:27:54+01:00 - build 5858

1. Correction of 5855.

--------------------------------------------------------------------------------
drkns 2021-07-25 22:56:46+01:00 - build 5857

1. Correction of 5852.1.

--------------------------------------------------------------------------------
drkns 2021-07-25 20:02:30+01:00 - build 5856

1. Correction of 5852.2.

--------------------------------------------------------------------------------
drkns 2021-07-25 19:40:43+01:00 - build 5855

1. Copy progress is a real dialog now. Yay.

--------------------------------------------------------------------------------
drkns 2021-07-23 01:41:38+01:00 - build 5854

1. Set console input mode in a smarter way.

--------------------------------------------------------------------------------
drkns 2021-07-22 19:50:21+01:00 - build 5853

1. Reduce CPU load in the log viewer.

--------------------------------------------------------------------------------
drkns 2021-07-20 17:48:06+01:00 - build 5852

1. gh-425 Incorrect file sizes shown/calculated for files compressed with LZX

2. Continue 5850.

--------------------------------------------------------------------------------
drkns 2021-07-20 02:38:36+01:00 - build 5851

1. Rework and simplify Delete/Wipe/Recycle dialog localisation.

--------------------------------------------------------------------------------
drkns 2021-07-19 22:08:39+01:00 - build 5850

1. Experimental: removed fake dialogs and preredraw magic from editor load/save/find progress bars.

--------------------------------------------------------------------------------
drkns 2021-07-13 20:22:19+01:00 - build 5849

1. Preserve the locked state when reopening editor from history.

--------------------------------------------------------------------------------
drkns 2021-07-12 20:53:26+01:00 - build 5848

1. Render real shadows when possible.

--------------------------------------------------------------------------------
drkns 2021-07-12 00:21:06+01:00 - build 5847

1. Refactoring.

2. More logging.

--------------------------------------------------------------------------------
drkns 2021-07-11 16:27:30+01:00 - build 5846

1. Screen artefacts after updating QView panel.

--------------------------------------------------------------------------------
drkns 2021-07-10 15:55:20+01:00 - build 5845

1. Correctly show delete indicator if the directory scan before it was cancelled.

2. A few more fullwidth-related improvements.

3. Workaround for a conhost bug in DirectX mode.

4. Properly update Find File status bar.

5. Properly discard previous Find File results in all cases.

6. Speed up Find File by removing a few quadratic algorithms from the listbox / menu implementation.

--------------------------------------------------------------------------------
drkns 2021-07-06 17:17:17+01:00 - build 5844

1. #0003877: Exit to archive root via cd \ breaks the panel title.

2. #0003878: Incorrect selection when the block is beyond the screen border.

3. Several fixes in 1.x plugin wrapper related to colors processing.

4. Throttle down file panel updates on FS changes to one per second at most.

--------------------------------------------------------------------------------
drkns 2021-07-01 03:01:55+01:00 - build 5843

1. Autocomplete-related fixes.

--------------------------------------------------------------------------------
drkns 2021-06-30 01:41:10+01:00 - build 5842

1. Panels autoupdate again.

--------------------------------------------------------------------------------
drkns 2021-06-29 23:22:07+01:00 - build 5841

1. And more.

--------------------------------------------------------------------------------
drkns 2021-06-29 17:58:00+01:00 - build 5840

1. A few more fixes.

--------------------------------------------------------------------------------
drkns 2021-06-29 04:04:29+01:00 - build 5839

1. Correction of 5838.

--------------------------------------------------------------------------------
drkns 2021-06-29 00:41:42+01:00 - build 5838

1. Eradicate idle events. Use ACTL_SYNCHRO if you need one.

2. Correction of panels autoupdate.

--------------------------------------------------------------------------------
drkns 2021-06-26 13:57:43+01:00 - build 5837

1. Continue 5833.1, revert 5833.2.

--------------------------------------------------------------------------------
drkns 2021-06-25 23:38:49+01:00 - build 5836

1. Show 4-bit color codes in color dialog.

--------------------------------------------------------------------------------
drkns 2021-06-25 19:46:48+01:00 - build 5835

1. Continue 5833.1 & 5834.

--------------------------------------------------------------------------------
drkns 2021-06-24 21:42:04+01:00 - build 5834

1. Continue 5833 1 & 2.

--------------------------------------------------------------------------------
drkns 2021-06-23 23:34:45+01:00 - build 5833

1. Since 5804.1 didn't crash and burn, let's go further and poll once per minute if nothing else happens.

2. Remove polling from waitkey / ACTL_WAITKEY processing.

3. Forum: closing viewer/editor with F3/F4 should be more predictable now.

4. Forum: update edit history after changing the lock state.

5. Numpad should work in Windows Terminal now.

6. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-06-22 02:19:01+01:00 - build 5832

1. New versions of fmt, tinyxml2, Catch2.

--------------------------------------------------------------------------------
drkns 2021-06-20 02:24:21+01:00 - build 5831

1. Loading plugins from file symlinks didn't work.

--------------------------------------------------------------------------------
drkns 2021-06-19 16:54:09+01:00 - build 5830

1. Limit the workaround for microsoft/terminal#10456 to specific Windows versions.

--------------------------------------------------------------------------------
svs 2021-06-19 10:15:41+01:00 - build 5829

1. SQLite 3.36.0

--------------------------------------------------------------------------------
drkns 2021-06-18 00:53:41+01:00 - build 5828

1. Don't apply fullwidth-aware rendering workarounds when not needed.

--------------------------------------------------------------------------------
drkns 2021-06-17 21:25:13+01:00 - build 5827

1. In far:config Alt+F4 edits integer values as binary.

--------------------------------------------------------------------------------
drkns 2021-06-17 02:05:29+01:00 - build 5826

1. Continue 5822.2. More experimental removals.

--------------------------------------------------------------------------------
drkns 2021-06-16 22:45:42+01:00 - build 5825

1. Correction of 5818.1.

--------------------------------------------------------------------------------
drkns 2021-06-16 22:20:44+01:00 - build 5824

1. Typo in 2201 (yes, 10 years ago).

--------------------------------------------------------------------------------
drkns 2021-06-16 18:22:16+01:00 - build 5823

1. Correction of 5822.2.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-06-15 22:01:42+01:00 - build 5822

1. Forum: selection in fixed size edit controls.

2. Other selection-related fixes in edit controls and the editor.
   Various service keys shouldn't stop selection / deselect anymore.

3. Forum: extra echo when executing unknown commands in a new window.

--------------------------------------------------------------------------------
drkns 2021-06-14 19:10:39+01:00 - build 5821

1. Removed the workaround for plugins that erroneously add transparent editor highlighting.
   Transparency is now taken into account.
   If your plugin/script suddenly stopped working - fill the colors properly.

--------------------------------------------------------------------------------
drkns 2021-06-12 12:39:43+01:00 - build 5820

1. Show code point values for surrogate pairs in editor status line.

--------------------------------------------------------------------------------
drkns 2021-06-12 02:00:20+01:00 - build 5819

1. Vertical separators were shown incorrectly in the last few builds.

2. Trigger the screensaver only if the window is focused.

--------------------------------------------------------------------------------
drkns 2021-06-10 22:11:22+01:00 - build 5818

1. Hightly experimental changes in editor color processing and text rendering.
   Things should be simpler, saner and faster now. Hopefully.
   Expect bugs. Report ASAP.

2. Continue fullwidth-aware rendering.

3. Corrections of text attributes merging.

4. GCC warnings.

--------------------------------------------------------------------------------
drkns 2021-06-09 22:54:58+01:00 - build 5817

1. Correction of 5630: no need to call the sorting plugin in the "Unsorted" mode.

--------------------------------------------------------------------------------
drkns 2021-06-07 23:54:29+01:00 - build 5816

1. Forum: sorting on plugin panels is too slow.

--------------------------------------------------------------------------------
drkns 2021-06-07 22:28:28+01:00 - build 5815

1. Continue fullwidth-aware rendering.

--------------------------------------------------------------------------------
drkns 2021-06-06 21:01:06+01:00 - build 5814

1. Basic support for UTF-16 surrogates.

--------------------------------------------------------------------------------
drkns 2021-06-05 23:26:24+01:00 - build 5813

1. Continue fullwidth-aware rendering.

--------------------------------------------------------------------------------
drkns 2021-06-03 23:29:55+01:00 - build 5812

1. Workarounds for EMenu positioning in Windows Terminal.

--------------------------------------------------------------------------------
drkns 2021-06-02 18:45:47+01:00 - build 5811

1. Sanitise C1 control characters in output.

2. Executor logic correction.

--------------------------------------------------------------------------------
drkns 2021-06-02 00:23:38+01:00 - build 5810

1. Continuation of 5809. Selection and cursor movements should work now, more or less.

2. gh-409: Far crashed when entering in shared folder (SMB).

--------------------------------------------------------------------------------
drkns 2021-05-30 22:44:55+01:00 - build 5809

1. Rudimentary experimental support for fullwidth-aware rendering (weebs & East Asian users, FYI).

--------------------------------------------------------------------------------
drkns 2021-05-30 17:00:38+01:00 - build 5808

1. gh-407: Rejecting elevation request when saving a file prevents from a further saving

--------------------------------------------------------------------------------
drkns 2021-05-29 20:07:34+01:00 - build 5807

1. Correction of 5806.2.

--------------------------------------------------------------------------------
drkns 2021-05-29 17:26:08+01:00 - build 5806

1. 0003866: Elevation shouldn't need SeDebugPrivilege.

2. Forum: "combobox looses unchanged state as soon as it becomes focused".

--------------------------------------------------------------------------------
drkns 2021-05-28 17:18:19+01:00 - build 5805

1. Correction of 4788.2: edit controls were incorrectly set to unchanged state after DM_SETTEXT.

2. 1 second timeout before triggeting the screensaver with a mouse to avoid flickering.

3. "[x] Clock in viewer and editor" removed. Clock is now displayed either everywhere or nowhere.

--------------------------------------------------------------------------------
drkns 2021-05-27 23:22:21+01:00 - build 5804

1. Experimental: removed constant polling from the main thread.
   This should noticeably reduce CPU consumption and make various idle events more predictable.

2. Experimental: reworked Find File dialog updating.
   This should make the search faster and make UI updates more predictable.

3. Optimisation of message transfer between threads.
   This should reduce the amount of locks and make things faster in various places.

4. More logging.

5. Minor refactoring.

--------------------------------------------------------------------------------
drkns 2021-05-27 17:18:25+01:00 - build 5803

1. Workaround for gh-404: hangs on exit in Windows XP SP3.

--------------------------------------------------------------------------------
drkns 2021-05-20 23:33:22+01:00 - build 5802

1. Two separate minidumps: normal (small) and full memory (huge).
   To make it easier to report issues.

--------------------------------------------------------------------------------
drkns 2021-05-19 18:46:33+01:00 - build 5801

1. Alpha blending performance optimisation.

--------------------------------------------------------------------------------
drkns 2021-05-19 00:00:00+01:00 - build 5800

1. Continuation of 5788: proper alpha blending.
   Available in files highlighting and editor selection colour.

--------------------------------------------------------------------------------
drkns 2021-05-16 15:31:41+01:00 - build 5799

1. Correction of 5776.

--------------------------------------------------------------------------------
drkns 2021-05-11 02:02:02+01:00 - build 5798

1. Continue the "SQLite vs nocase" saga. Now any related errors should be fixed automatically.

--------------------------------------------------------------------------------
drkns 2021-05-09 20:00:49+01:00 - build 5797

1. Experimental: since it's nearly impossible to teach the users that screenshots of the exception dialog are NOT useful for investigations,
   the aforementioned dialog now doesn't display any technical information at all.
   That information is now saved to a text file in the local profile, along with a minidump.

--------------------------------------------------------------------------------
drkns 2021-05-09 00:20:43+01:00 - build 5796

1. Exception handling improvements.

--------------------------------------------------------------------------------
drkns 2021-05-08 14:53:05+01:00 - build 5795

1. Correction of 5788 - visual artefacts during selection.

--------------------------------------------------------------------------------
drkns 2021-05-07 22:26:27+01:00 - build 5794

1. Typo in 5718.

--------------------------------------------------------------------------------
drkns 2021-05-06 20:50:34+01:00 - build 5793

1. Error handling improvements.

--------------------------------------------------------------------------------
w17 2021-05-05 23:06:45+03:00 - build 5792

1. -typo2

--------------------------------------------------------------------------------
w17 2021-05-05 19:19:34+03:00 - build 5791

1. -typo

--------------------------------------------------------------------------------
w17 2021-05-05 17:58:17+03:00 - build 5790

1. Correction 5733 (questionable)
   far:config Descriptions.ValidateConversion=true -- configurable description encoding validation.

--------------------------------------------------------------------------------
drkns 2021-05-04 18:08:14+01:00 - build 5789

1. SQLite exception due to outdated index after collation update.

2. Redirect SQLite logging to our logging.

--------------------------------------------------------------------------------
drkns 2021-05-02 11:28:04+01:00 - build 5788

1. Experimental: editor selection color can have transparent foreground/background.

2. More transparency to come: make sure you fill alpha channels in FarColor structures properly in API.

2. Multiple fixes related to color merging and processing.

3. Continuation of 5785.

4. SQLite diagnostic improvements.

5. Minor fixes in grabber.

--------------------------------------------------------------------------------
drkns 2021-04-30 17:24:37+01:00 - build 5787

1. Forum: Repeated rescan directory tree.

--------------------------------------------------------------------------------
drkns 2021-04-28 00:43:06+01:00 - build 5786

1. As it turned out, the sqlite unicode extension that we were using has a rather unorthodox notion of nocase collation.
   Quote: "automatically try to unaccent any characters that are over the 0x80 character", in other words it treats Ä, Á, Ą, Â, Ă as the same thing.
   Given that we only need nocase for case-insensitive, Windows-like file name lookup, this does more harm than good.
   The extension has been removed and nocase collation is now delegated to Windows.

2. Remove System.FlagPosixSemantics config parameter.

--------------------------------------------------------------------------------
drkns 2021-04-25 18:08:48+01:00 - build 5785

1. Add more "style" attributes: double underline, overline, strikeout, faint, blink.

2. Rework color dialog to support these attributes, as well as existing bold, italic, underline.
   Keep in mind that Far doesn't draw anything directly - to see all this luxury your terminal must support it.

3. Minor fixes to extended attributes processing.

4. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-04-20 17:51:24+01:00 - build 5784

1. Correction of 5783.

--------------------------------------------------------------------------------
drkns 2021-04-20 17:21:48+01:00 - build 5783

1. 0003862: Preserve the description file code page.

--------------------------------------------------------------------------------
drkns 2021-04-16 01:54:01+01:00 - build 5782

1. By popular demand: history checkboxes in settings are now tri-state:
   in the third state the history records, simultaneously created by other Far instances, will be ignored.

--------------------------------------------------------------------------------
drkns 2021-04-14 00:49:16+01:00 - build 5781

1. Refactoring.

2. Warnings.

--------------------------------------------------------------------------------
drkns 2021-04-12 22:35:48+01:00 - build 5780

1. 0003860: file descriptions are not updated (access rights issue)

--------------------------------------------------------------------------------
drkns 2021-04-09 17:28:29+01:00 - build 5779

1. 0003859: Copying a file over itself leads to data loss.

2. Remove the <ACTL|DM>_<SUPPRESS|RESTORE>HISTORY commands, introduced in 5773.

--------------------------------------------------------------------------------
drkns 2021-04-07 17:30:06+01:00 - build 5778

1. Correction of 5776.

--------------------------------------------------------------------------------
drkns 2021-04-06 17:18:03+01:00 - build 5777

1. Correction of 5776.

--------------------------------------------------------------------------------
drkns 2021-04-05 12:44:10+01:00 - build 5776

1. An attempt to fix 0003856: Wrong file count in copy dialog.
   As usual, copying is a can of worms. Brace yourself.

2. Refactoring.

--------------------------------------------------------------------------------
svs 2021-04-04 10:00:00+03:00 - build 5775

1. SQLite 3.35.4

--------------------------------------------------------------------------------
drkns 2021-04-02 01:25:54+01:00 - build 5774

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-04-01 23:08:23+01:00 - build 5773

1. Experimental: view / edit history is now updated as soon as the file is opened instead of at exit.
   Shift+Enter in the history menu should work as intended now.

2. Experimental: folders history is now updated as soon as the folder is entered instead of at exit.
   Shift+Enter in the history menu should work as intended now.

3. Minor refactoring.

--------------------------------------------------------------------------------
drkns 2021-03-29 00:00:09+01:00 - build 5772

1. Error handling improvements.

--------------------------------------------------------------------------------
svs 2021-03-28 18:13:00+03:00 - build 5771

1. SQLite 3.35.3

--------------------------------------------------------------------------------
drkns 2021-03-26 23:07:38+00:00 - build 5770

1. 0003855: Cannot rename symlinks

--------------------------------------------------------------------------------
drkns 2021-03-25 22:23:45+00:00 - build 5769

1. gh-368: Cannot copy to network share (samba).

--------------------------------------------------------------------------------
drkns 2021-03-23 17:59:39+00:00 - build 5768

1. 0003853: Slow file copying

--------------------------------------------------------------------------------
drkns 2021-03-21 19:15:26+00:00 - build 5767

1. Another attempt to keep the main thread COM-free (most of the time).

--------------------------------------------------------------------------------
drkns 2021-03-21 15:03:52+00:00 - build 5766

1. Revert 5764.1 - the experiment wasn't successful.

--------------------------------------------------------------------------------
drkns 2021-03-21 03:40:44+00:00 - build 5765

1. 0003852: an alternative (and, hopefully, better) way to approximate truecolor to console index.

--------------------------------------------------------------------------------
drkns 2021-03-20 23:22:21+00:00 - build 5764

1. Move COM MTA initialisation into a separate thread to allow plugins to have STA in the main thread.

2. A few minor fixes.

--------------------------------------------------------------------------------
svs 2021-03-17 16:39:34+03:00 - build 5763

1. SQLite 3.35.1

--------------------------------------------------------------------------------
drkns 2021-03-16 23:05:27+00:00 - build 5762

1. Continuation of 5761.

--------------------------------------------------------------------------------
drkns 2021-03-15 18:31:13+00:00 - build 5761

1. Fix stack tracing on 2k/XP.

--------------------------------------------------------------------------------
svs 2021-03-14 23:34:34+03:00 - build 5760

1. SQLite 3.35.0

--------------------------------------------------------------------------------
drkns 2021-03-14 16:53:28+00:00 - build 5759

1. VS2019 & 2k/XP compatibility.

2. Reduce log spamming about absent imports for old OSes.

3. Replace \xNNNN character codes in sources with actual characters - we use UTF-8 now so nothing should get lost.

--------------------------------------------------------------------------------
drkns 2021-03-14 15:36:26+00:00 - build 5758

1. gh-371: fails to obtain administrator privileges

--------------------------------------------------------------------------------
drkns 2021-03-10 19:21:56+00:00 - build 5757

1. 0003850: Error running files from Google Drive

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-03-06 22:30:25+00:00 - build 5756

1. Reduce log binary footprint.

2. Remove excessive logging.

--------------------------------------------------------------------------------
drkns 2021-03-05 21:02:33+00:00 - build 5755

1. gh-367: Reproducible exception related to regular expressions.

--------------------------------------------------------------------------------
drkns 2021-03-05 00:31:26+00:00 - build 5754

1. UCD can detect CJK charsets if the locale is CJK.

2. More logging.

3. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-03-03 22:03:55+00:00 - build 5753

1. More logging.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-03-03 13:11:41+00:00 - build 5752

1. VS2017.

--------------------------------------------------------------------------------
drkns 2021-03-02 22:10:08+00:00 - build 5751

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-03-02 18:43:56+00:00 - build 5750

1. Further logging improvements.

--------------------------------------------------------------------------------
drkns 2021-03-01 20:19:18+00:00 - build 5749

1. More logging.

--------------------------------------------------------------------------------
drkns 2021-03-01 18:39:55+00:00 - build 5748

1. More logging.

--------------------------------------------------------------------------------
drkns 2021-03-01 15:26:17+00:00 - build 5747

1. Add the process ID to the log file name.

--------------------------------------------------------------------------------
drkns 2021-02-28 20:41:25+00:00 - build 5746

1. More logging.

--------------------------------------------------------------------------------
drkns 2021-02-28 13:18:47+00:00 - build 5745

1. Added more logging.

2. Log parameters can be changed after the start: update the environment variables as needed and run "far:log reconfigure".

3. Minor refactoring related to #1.

4. A workaround for 0003849: Exception during re-reading folder tree.

--------------------------------------------------------------------------------
drkns 2021-02-23 01:55:05+00:00 - build 5744

1. Fix a few issues in the previous build.

--------------------------------------------------------------------------------
drkns 2021-02-21 21:47:47+00:00 - build 5743

1. A new logging engine. Currently it can be configured via environment variables:

   - FAR.LOG.LEVEL:
     The log level. Can be one of the following values: "off", "fatal", "error", "warning", "notice", "info", "debug", "trace", "all".
     Default value: off

   - FAR.LOG.SINK:
     Log sink(s). Can contain one or more comma- or semicolon-separated values:
      - "debug": the system debugger.
      - "console": a new buffer in the same console window, available via the Ctrl+Shift+L hotkey or the "far:log" command.
      - "file": a text file with a unique name. The file's directory can be specified via FAR.LOG.SINK.FILE.PATH.
      - "pipe": similar to "console", but in a new window.

2. syslog.* and everything related to it removed.

3. Plugins cache:
   - Removed replacing of '\' with '/' (remnants of the Windows Registry days).
   - Only lower 32 bits of timestamps were checked (with potential collisions every ~7 minutes).

4. Skipping the file size in descriptions didn't work.

5. Added logging in quite a few places where it should be, more to come.

6. Minor refactoring related to #1.

--------------------------------------------------------------------------------
drkns 2021-02-16 19:46:10+00:00 - build 5742

1. Potential null pointer dereference in custom sort.

--------------------------------------------------------------------------------
drkns 2021-02-09 17:37:00+00:00 - build 5741

1. Always preserve Last Write Time when copying files.

--------------------------------------------------------------------------------
drkns 2021-02-04 19:06:02+00:00 - build 5740

1. Don't add Unicode BOM to file lists created with !@!.

--------------------------------------------------------------------------------
svs 2021-02-03 16:46:34+03:00 - build 5739

1. SQLite 3.34.1

--------------------------------------------------------------------------------
drkns 2021-02-02 01:49:01+00:00 - build 5738

1. Warnings, typos, cleanup.

--------------------------------------------------------------------------------
drkns 2021-01-30 23:18:23+00:00 - build 5737

1. 0003845: Relax "Compare Folders" time comparison precision.

--------------------------------------------------------------------------------
drkns 2021-01-30 17:18:13+00:00 - build 5736

1. Correction of 5735.

--------------------------------------------------------------------------------
drkns 2021-01-30 13:06:35+00:00 - build 5735

1. Forum: Modifier keys close the Fast Find.

--------------------------------------------------------------------------------
drkns 2021-01-30 00:37:49+00:00 - build 5734

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2021-01-27 18:59:03+00:00 - build 5733

1. Encoding validation for file lists created with !@!, descriptions and some other places.

2. Minor lng & hlf corrections.

--------------------------------------------------------------------------------
drkns 2021-01-26 11:53:23+00:00 - build 5732

1. gh-240: Temp file with list of selected file names has missing entries

--------------------------------------------------------------------------------
drkns 2021-01-23 21:25:01+00:00 - build 5731

1. Workaround for https://github.com/microsoft/terminal/issues/8866

--------------------------------------------------------------------------------
drkns 2021-01-14 17:50:34+00:00 - build 5730

1. 5728 once again.

--------------------------------------------------------------------------------
drkns 2021-01-13 20:41:29+00:00 - build 5729

1. Correction of 5728.

2. A few minor changes.

--------------------------------------------------------------------------------
drkns 2021-01-12 19:05:57+00:00 - build 5728

1. Restore cursor state after launching programs.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Восстановление состояния курсора после запуска программ.

--------------------------------------------------------------------------------
drkns 2021-01-12 01:05:24+00:00 - build 5727

1. More 5726.

--------------------------------------------------------------------------------
drkns 2021-01-10 22:39:41+00:00 - build 5726

1. AppExecLink reparse point support.

--------------------------------------------------------------------------------
drkns 2021-01-07 17:33:44+00:00 - build 5725

1. gh-335: BreakKeys fix for ansi plugins.

2. Restore ClearType-friendly redraw for Windows 10.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. gh-335: Исправление BreakKeys для ansi плагинов.

2. Вернем ClearType-friendly redraw для Windows 10.

--------------------------------------------------------------------------------
drkns 2021-01-06 18:54:47+00:00 - build 5724

1. Correction of 5604 to avoid conflicts with AltGr.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5604 для избежания конфликтов с AltGr.

--------------------------------------------------------------------------------
drkns 2021-01-05 20:10:45+00:00 - build 5723

1. Another executor correction.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ещё одно уточнение в запускателе.

--------------------------------------------------------------------------------
drkns 2021-01-03 12:51:01+00:00 - build 5722

1. gh-315: [Feature request] far:config Using "Del" to reset an option.

--------------------------------------------------------------------------------
drkns 2020-12-30 08:24:39+00:00 - build 5721

1. Modules versions in exception information.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Версии модулей в информации об исключении.

--------------------------------------------------------------------------------
MZK 2020-12-26 16:10:32-08:00 - build 5720

1. `Alt+<Gray *>` inverts selection on files only, excluding folders.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. `Alt+<Gray *>` инвертирует пометку только на файлах, исключая папки.

--------------------------------------------------------------------------------
drkns 2020-12-24 00:22:43+00:00 - build 5719

1. gh-319: An undesirable navigation when Far Manager is being launched with a passed path.

--------------------------------------------------------------------------------
drkns 2020-12-18 12:17:39+00:00 - build 5718

1. Another executor correction.

2. System.QuotedName was ignored in Tree Panel.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ещё одно уточнение в запускателе.

2. System.QuotedName игнорировалось в панели дерева.

--------------------------------------------------------------------------------
drkns 2020-12-14 22:31:28+00:00 - build 5717

1. Another executor correction.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ещё одно уточнение в запускателе.

--------------------------------------------------------------------------------
drkns 2020-12-12 16:18:28+00:00 - build 5716

1. Correction of 5711.

--------------------------------------------------------------------------------
svs 2020-12-12 17:57:34+03:00 - build 5715

1. SQLite 3.34.0

--------------------------------------------------------------------------------
drkns 2020-12-11 00:01:03+00:00 - build 5714

1. Continuation of 5713.

--------------------------------------------------------------------------------
drkns 2020-12-10 02:30:20+00:00 - build 5713

1. Another attempt to workaround Windows 10 bugs (0003827 etc.).

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Еще одна попытка обойти баги Windows 10 (0003827 и т.п.).

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-12-09 08:34:58+00:00 - build 5712

1. Corrections of 5711.

--------------------------------------------------------------------------------
drkns 2020-12-08 23:31:46+00:00 - build 5711

1. gh-311: Wrong counter of copied bytes

2. Refactoring.

--------------------------------------------------------------------------------
yjh 2020-12-01 21:15:24+03:00 - build 5710

1. Another executor correction.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ещё одно уточнение в запускателе.

--------------------------------------------------------------------------------
drkns 2020-11-22 22:32:51+00:00 - build 5709

1. And again.

--------------------------------------------------------------------------------
drkns 2020-11-22 17:59:19+00:00 - build 5708

1. A few executor corrections.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Пара уточнений в запускателе.

--------------------------------------------------------------------------------
drkns 2020-11-22 01:28:27+00:00 - build 5707

1. Exception handling improvements.

--------------------------------------------------------------------------------
drkns 2020-11-16 22:47:34+00:00 - build 5706

1. gh-290 again: searching for the executable partially restored. Alas, there's no other way.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение gh-290: частично возвращен поиск запускаемого. Без этого никак, увы.

--------------------------------------------------------------------------------
drkns 2020-11-16 18:52:48+00:00 - build 5705

1. gh-290: New executor gives priority to folders over programs with the same name in PATH.

--------------------------------------------------------------------------------
drkns 2020-11-15 22:37:26+00:00 - build 5704

1. Increase the delay before removing the temporary files, created with !@!.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Увеличена задержка удаления временных файлов, создаваемых по !@!.

--------------------------------------------------------------------------------
drkns 2020-11-15 10:16:18+00:00 - build 5703

1. Executor logic correction.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение работы запускателя.

--------------------------------------------------------------------------------
drkns 2020-11-14 22:00:22+00:00 - build 5702

1. Experimental: reimplemented and simplifiled the executor (based on https://forum.farmanager.com/viewtopic.php?t=12275):
   - Removed searching for the executable - the OS knows better.
   - Removed System.Executor.UseAppPath and System.Executor.FullTitle.
   - Associations processing is disabled by default. Set System.Executor.UseAssociations to true to enable.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментально: переделан и упрощен запускатель (по мотивам https://forum.farmanager.com/viewtopic.php?t=12275):
   - Поиск запускаемого не производится - ОС видней.
   - System.Executor.UseAppPath и System.Executor.FullTitle больше нет.
   - Обработка ассоциаций отключена по умолчанию. Включается по System.Executor.UseAssociations = true.

2. Рефакторинг.

--------------------------------------------------------------------------------
yjh 2020-11-14 21:21:30+03:00 - build 5701

1. Add .msi to <arc> mask.

--------------------------------------------------------------------------------
drkns 2020-11-11 19:38:14+00:00 - build 5700

1. Correction of 5698.1 again.

--------------------------------------------------------------------------------
drkns 2020-11-08 19:45:32+00:00 - build 5699

1. Correction of 5698.1.

--------------------------------------------------------------------------------
drkns 2020-11-05 19:04:14+00:00 - build 5698

1. Experimental: reduce the number of executor parameters.

2. Add a list of loaded modules to exception information.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментально: уменьшим количество параметров запускателя.

2. В информацию об исключении добавлен список загруженных модулей.

--------------------------------------------------------------------------------
drkns 2020-11-03 15:55:05+00:00 - build 5697

1. In some cases some data coundn't be read from registry.

2. Executor logic correction.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях не читались некоторые данные из реестра.

2. Уточнение работы запускателя.

--------------------------------------------------------------------------------
drkns 2020-10-28 00:18:12+00:00 - build 5696

1. Is some cases pointers to internal data were exposed to plugins.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях плагинам отдавались указатели на внутренние данные.

--------------------------------------------------------------------------------
drkns 2020-10-27 20:48:41+00:00 - build 5695

1. Forum: if FarGetPluginPanelItem::Size is less than the required size, FCTL_GETPANELITEM will fill as much as possible.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: если FarGetPluginPanelItem::Size меньше требуемого размера, то FCTL_GETPANELITEM заполнит столько, сколько возможно.

--------------------------------------------------------------------------------
drkns 2020-10-27 00:25:27+00:00 - build 5694

1. 0003821 / gh-279: Redundant ampersand in the "Group of file masks" dialog title.

--------------------------------------------------------------------------------
drkns 2020-10-26 20:48:46+00:00 - build 5693

1. New versions of fmt, tinyxml2, Catch2.

--------------------------------------------------------------------------------
drkns 2020-10-26 18:02:12+00:00 - build 5692

1. Forum: 5688 freezes in disks menu if a network drive is not available.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: 5688 подвисает в меню дисков, если сетевой диск не доступен.

--------------------------------------------------------------------------------
drkns 2020-10-26 02:03:19+00:00 - build 5691

1. Correction of 5683.

--------------------------------------------------------------------------------
drkns 2020-10-25 20:54:39+00:00 - build 5690

1. 0003818: Infinite restart of .cmd batches via a double click and exiting using Ctrl-Break.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003818: Бесконечный перезапуск .cmd батчей через double-click и попытке выхода через Ctrl-Break

--------------------------------------------------------------------------------
drkns 2020-10-25 05:30:03+00:00 - build 5689

1. Fix clang build & warnings.

--------------------------------------------------------------------------------
drkns 2020-10-25 01:11:40+00:00 - build 5688

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-10-23 22:18:08+01:00 - build 5687

1. Exception handling:
   - intercept std::terminate
   - alternative stack retrieval
   - show registers.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Обработка исключений:
   - перехват std::terminate
   - альтернативный способ получения стека
   - вывод регистров.

--------------------------------------------------------------------------------
drkns 2020-10-22 22:17:27+01:00 - build 5686

1. Removed lng lines for single viewer/editor functional keys.
   They are the same anyway, and we can make the unavailabe buttons empty programmatically.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Удалены lng строки для single viewer/editor functional keys.
   Они все равно такие же, а пустые кнопки для недоступных действий мы можем сделать и программно.

--------------------------------------------------------------------------------
yogdg 2020-10-22 14:31:20-03:00 - build 5685

1. gh-247: Customizable number of bytes by line in hex viewer

--------------------------------------------------------------------------------
drkns 2020-10-21 17:46:37+01:00 - build 5684

1. gh-274: Editor: Selection isn't cleared on Ctrl+Home/End.

--------------------------------------------------------------------------------
drkns 2020-10-21 01:35:56+01:00 - build 5683

1. Mouse selection in input fields sometimes wasn't working as expected.

2. Corrections of mouse handling in other UI elements.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Выделение мышью в полях ввода могло работать неадекватно.

2. Уточнения обработки мыши в прочих элементах интерфейса.

--------------------------------------------------------------------------------
drkns 2020-10-19 07:52:23+01:00 - build 5682

1. Correction of 5681.

--------------------------------------------------------------------------------
drkns 2020-10-19 00:01:37+01:00 - build 5681

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-10-18 23:54:25+01:00 - build 5680

1. Correction of 5679.

--------------------------------------------------------------------------------
drkns 2020-10-18 23:32:51+01:00 - build 5679

1. gh-269: Apply variables to subsequent lines as well.

--------------------------------------------------------------------------------
drkns 2020-10-12 08:40:27+01:00 - build 5678

1. Correction of 5677.

--------------------------------------------------------------------------------
drkns 2020-10-12 00:12:45+01:00 - build 5677

1. Refactoring.

2. As it turns out, gnu ld maps are useless for stack tracing, so now objdump output is used instead.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Как выяснилось, gnu ld maps бесполезны для stack tracing, поэтому теперь вместо них используется вывод objdump.

--------------------------------------------------------------------------------
yjh 2020-10-11 09:35:31+03:00 - build 5676

1. Add .lz,.tlz to <arc> mask.

--------------------------------------------------------------------------------
drkns 2020-09-30 17:31:32+01:00 - build 5675

1. gh-269: Feature Request: Reuse User Input tokens in F2 User Menu

--------------------------------------------------------------------------------
drkns 2020-09-28 20:03:38+01:00 - build 5674

1. Correction of 5672.

--------------------------------------------------------------------------------
bitraid 2020-09-28 13:00:01+01:00 - build 5673

1. gh-268: Enable saving state of unmounted volumes display

--------------------------------------------------------------------------------
drkns 2020-09-27 23:37:58+01:00 - build 5672

1. Disk menu can show not mounted volumes (Ctrl-H).

2. Minor corrections in handling of various non-standard paths.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Меню дисков умеет показывать непримонтированные тома (Ctrl-H).

2. Мелкие уточнения обработки разнообразных нестандартных путей.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-09-22 08:45:08+01:00 - build 5671

1. Copying from viewer didn't work properly.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Криво работало копирование из вьювера.

--------------------------------------------------------------------------------
drkns 2020-09-19 18:43:36+01:00 - build 5670

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-09-17 00:15:38+01:00 - build 5669

1. Continuation of 5667.

--------------------------------------------------------------------------------
drkns 2020-09-14 17:39:39+01:00 - build 5668

1. 0003819: Editor: crash when typing in alternate layout.

--------------------------------------------------------------------------------
drkns 2020-09-14 00:58:21+01:00 - build 5667

1. Switching exotic code pages didn't work as expected due to incorrectly set flags.

2. Added a manual roundtrip checking for the codepages that OS can't validate.

3. Refactoring.

4. Tests.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Криво работало переключение экзотических кодовых страниц из-за неправильно устанавливаемых флагов.

2. Добавлена ручная roundtrip-проверка для тех страниц, которые не умеет валидировать ОС.

3. Рефакторинг.

4. Тесты.

--------------------------------------------------------------------------------
zg 2020-09-14 01:03:19+03:00 - build 5666

1. surpress redraw under exception dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. подавление перерисовки под диалогом с исключениями.

--------------------------------------------------------------------------------
drkns 2020-09-12 02:02:02+01:00 - build 5665

1. Regex word search didn't work properly in some cases.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях неправильно работал regex-поиск слов.

--------------------------------------------------------------------------------
drkns 2020-09-10 00:11:09+01:00 - build 5664

1. Corrections in exception handling.

2. Show system errors in SQLite exeptions.

3. Other minor things.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения обработки исключений.

2. Отображение системных ошибок в исключениях SQLite.

3. Прочие мелочи.

--------------------------------------------------------------------------------
drkns 2020-09-06 23:00:00+01:00 - build 5663

1. Store binary data in exported configuration as base64.

2. Reading UTF-7 didn't work. At all.

3. Refactoring.

4. Tests.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Бинарные данные в экспортируемой конфигурации теперь хранятся как base64.

2. Чтение UTF-7 не работало. Совсем.

3. Рефакторинг.

4. Тесты.

--------------------------------------------------------------------------------
drkns 2020-09-01 17:48:03+01:00 - build 5662

1. Setting db key descriptions didn't work in some cases.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях не работала установка описаний ключей бд.

--------------------------------------------------------------------------------
drkns 2020-08-31 23:01:01+01:00 - build 5661

1. Continuation of #3817.

2. VS2017.

--------------------------------------------------------------------------------
drkns 2020-08-31 19:18:12+01:00 - build 5660

1. Show the version in the UI as major.minor.build.revision, for compatibility with the OS and for the future.

2. Restore the /x parameter - disable exception handling (for ease of development and debugging).

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Версия в интерфейсе выводится как major.minor.build.revision, для совместимости с OS и на будущее.

2. Возвращен параметр /x - отключить обработку исключений (для удобства разработки и отладки).

3. Рефакторинг.

--------------------------------------------------------------------------------
zg 2020-08-28 03:38:58+03:00 - build 5659

1. forum: titles never shown in listbox with DIF_LISTNOBOX flag.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: никогда не показывать заголовки в листбоксе с флагом DIF_LISTNOBOX.

--------------------------------------------------------------------------------
drkns 2020-08-27 00:35:51+01:00 - build 5658

1. 0003817: F6 - Failed move file when volume is mounted to folder only

2. A few minor changes.

--------------------------------------------------------------------------------
drkns 2020-08-22 22:49:52+01:00 - build 5657

1. Sorting again: additional criteria direction can inherit the primary one.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Снова о сортировке: направление для дополнительных критериев может наследовать основное.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-08-20 18:00:35+01:00 - build 5656

1. Correction of 5655.

--------------------------------------------------------------------------------
drkns 2020-08-19 22:29:34+01:00 - build 5655

1. Added a constant that defines the range of custom sort modes to Plugin API.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В Plugin API добавлена константа, определяющая диапазон кастомных сортировок.

--------------------------------------------------------------------------------
zg 2020-08-17 22:24:45+03:00 - build 5654

1. forum: empty DI_LIST's list in case in initial list all elements have flag LIF_HIDDEN.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: Пустой список DI_LIST-а, если исходном списке все строки - LIF_HIDDEN.

--------------------------------------------------------------------------------
drkns 2020-08-17 19:45:45+01:00 - build 5653

1. gh-263: Use ArcLite for .aab by default

--------------------------------------------------------------------------------
drkns 2020-08-16 01:04:27+01:00 - build 5652

1. 0003816: Incorrect text alignment in dialog separators.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003816: Смещение текста вправо на 1 символ при центрировании сепаратора.

2. Рефакторинг.

--------------------------------------------------------------------------------
svs 2020-08-15 18:34:34+03:00 - build 5651

1. SQLite 3.33.0

--------------------------------------------------------------------------------
drkns 2020-08-09 12:26:42+01:00 - build 5650

1. Ignore paths when sorting in panel modes without paths.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При сортировке в режимах панели без отображения путей пути игнорируются.

--------------------------------------------------------------------------------
drkns 2020-08-04 17:56:27+01:00 - build 5649

1. Forum: unnecessary privilege request

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: ненужный запрос привилегий

--------------------------------------------------------------------------------
drkns 2020-08-03 22:49:55+01:00 - build 5648

1. gh-262 AutoComplete popup does not show under Windows 10's Terminal

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-07-30 19:00:15+01:00 - build 5647

1. Correction of 5646.

--------------------------------------------------------------------------------
drkns 2020-07-29 23:39:52+01:00 - build 5646

1. Refactoring.

2. gh-261 Mistake in help file
   Actually not.
   Ibid - added a couple of new user name display formats to Info Panel.

3. Clang analyzer warnings.

4. Rewritten the screensaver (why not).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. gh-261 Mistake in help file
   На самом деле нет.
   Там же - добавлена пара новых форматов отображения имени в Info Panel.

3. Clang analyzer warnings.

4. Переписан скринсейвер (а почему бы и нет).

--------------------------------------------------------------------------------
drkns 2020-07-22 01:35:45+01:00 - build 5645

1. Correction of 5643.

--------------------------------------------------------------------------------
drkns 2020-07-21 19:49:10+01:00 - build 5644

1. Minor correction of launcher logic.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Мелкое уточнение логики запускателя.

--------------------------------------------------------------------------------
drkns 2020-07-21 17:34:53+01:00 - build 5643

1. Continuation of 5631.1.

--------------------------------------------------------------------------------
drkns 2020-07-20 19:33:22+01:00 - build 5642

1. Keyboard tips in various menus are now generated by the code.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Подсказки по клавишам в различных меню теперь генерируются кодом.

--------------------------------------------------------------------------------
drkns 2020-07-19 01:44:02+01:00 - build 5641

1. Refactoring.

--------------------------------------------------------------------------------
MZK 2020-07-11 21:04:57-07:00

1. Translated remaining far:config help pages into English; cleaned up eng/TechInfo.txt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский оставшиеся страницы справки far:config; дочистил eng/TechInfo.txt.

--------------------------------------------------------------------------------
drkns 2020-07-11 02:48:48+01:00 - build 5640

1. Refactoring.

2. Glang with GNU toolchain can now be used for build.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Для сборки теперь можно использовать Clang с GNU toolchain.

--------------------------------------------------------------------------------
drkns 2020-07-07 17:57:54+01:00 - build 5639

1. Continuation of 5631.1.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-07-06 18:56:37+01:00 - build 5638

1. New versions of fmt, tinyxml2, Catch2.

--------------------------------------------------------------------------------
drkns 2020-07-05 19:49:40+01:00 - build 5637

1. Continuation of 5370 - skip redundant scroll on startup.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5370 - пропуск излишней прокрутки при запуске.

--------------------------------------------------------------------------------
drkns 2020-07-05 18:37:32+01:00 - build 5636

1. VS 2019 16.7 & GCC warnings.

--------------------------------------------------------------------------------
drkns 2020-07-05 15:10:15+01:00 - build 5635

1. Another attempt to workaround Windows 10 console host bugs.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Очередная попытка обхода багов Windows 10 console host.

--------------------------------------------------------------------------------
drkns 2020-07-04 13:30:24+01:00 - build 5634

1. Correction of 5598.

--------------------------------------------------------------------------------
drkns 2020-07-04 12:52:29+01:00 - build 5633

1. gh-250: Use ArcLite for .apk and .aar by default

--------------------------------------------------------------------------------
drkns 2020-07-04 02:32:19+01:00 - build 5632

1. C++20 warnings.

2. VS 2019 16.7 warnings.

3. A few minor optimisations of size formatting.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. C++20 warnings.

2. VS 2019 16.7 warnings.

3. Пара мелких оптимизаций форматирования размеров.

--------------------------------------------------------------------------------
drkns 2020-07-03 02:42:42+01:00 - build 5631

1. Continuation and improving of 5630.1:
   - Multiple sorting criteria can be defined permanently: Ctrl+F12, F4 on a mode, Ins/Del/CtrlUp/CtrlDown/CtrlR.
   - Default criteria replicate the previous behaviour.

2. Fixed old and new bugs in preserving selection on a panel update.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение и углубление 5630.1:
   - Множественные критерии сортировки можно определять перманентно: Ctrl+F12, F4 на режиме, Ins/Del/CtrlUp/CtrlDown/CtrlR.
   - По умолчанию определены критерии, повторяющие предыдущее поведение.

2. Исправлены новые и старые баги с сохранением выделения при обновлении панели.

--------------------------------------------------------------------------------
drkns 2020-07-02 01:07:47+01:00 - build 5630

1. Experimental:
   - File panels use stable sorting.
   - Sorting criteria don't fallback to file names.
   What does it mean:
   - Panel sorting preserves the current order of equivalent elements.
   What does it mean:
   - Various criteria can be applied sequentially.
     Example:
     Ctrl+F5, Ctrl+F6 - sort files by size, files of the same size - by modification time.

2. Experimental:
   - "Name" criterion renamed to "Only name".
   - "Full name" criterion renamed to "Name".
   No difference in normal panels, but should work faster.
   In plugin panels this is more sensible when full names are displayed.

3. Folders re-reading optimisation.

4. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментально:
   - В файловых панелях используется стабильная сортировка.
   - Критерии сортировки не используют имя файла в качестве запасного варианта.
   Что это значит:
   - Сортировка в панелях не изменяет текущий порядок эквивалентных элементов.
   Что это значит:
   - Различные критерии можно применять последовательно.
     Например:
     Ctrl+F5, Ctrl+F6 - сотрировать файлы по размеру, файлы одинакового размера - по времени записи.

2. Экспериментально:
   - Критерий "Имя" переименован в "Только имя".
   - Критерий "Полное имя" переименован в "Имя".
   В обычных панелях разницы нет, а работать будет быстрее.
   В плагиновых панелях это имеет больше смысла при отображении полных имён.

3. Оптимизация перечитывания папки.

4. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2020-06-29 20:22:06+01:00 - build 5629

1. Ejecting a CD with Panel.RememberLogicalDrives enabled had funny effects.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Извлечение CD при включенной опции Panel.RememberLogicalDrives приводило к забавным эффектам.

--------------------------------------------------------------------------------
drkns 2020-06-27 15:01:02+01:00 - build 5628

1. Correction of 5627.

--------------------------------------------------------------------------------
drkns 2020-06-26 22:44:22+01:00 - build 5627

1. Forum: A strange revert of the previous user filter selection after editing.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Странный автовозврат предыдущей пометки фильтра пользователя после редактирования.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-06-24 17:33:33+01:00 - build 5626

1. 0003804: "Save file position" option doesn't work in editor and viewer.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003804: Не работает опция "сохранять позицию файла" в редакторе и просмотрщике.

--------------------------------------------------------------------------------
drkns 2020-06-21 22:47:28+01:00 - build 5625

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-06-20 18:27:17+01:00 - build 5624

1. Continuation of 3449 - bypassing Recycle Bin is possible on any errors, since the OS returns arbitrary errors in general.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 3449 - удаление в обход корзины доступно при любых ошибках, т.к. ОС в общем случае возвращает что попало.

--------------------------------------------------------------------------------
svs 2020-06-19 00:24:34+03:00 - build 5623

1. SQLite 3.32.3

--------------------------------------------------------------------------------
drkns 2020-06-17 19:50:37+01:00 - build 5622

1. Copy progress dialog correctly shows times over 100 hours.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Диалог прогресса копирования корректно отображает времена более 100 часов.

--------------------------------------------------------------------------------
drkns 2020-06-17 08:40:49+01:00 - build 5621

1. Fix typo in 5620.

--------------------------------------------------------------------------------
drkns 2020-06-17 01:01:01+01:00 - build 5620

1. Incorrect flags processing in DialogBuilder.

2. Corrections of codepage switching error messages.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Некорректная обработка флагов в DialogBuilder.

2. Уточнения сообщений об ошибках переключения кодовых страниц.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-06-16 02:25:55+01:00 - build 5619

1. Correction of 5618.

--------------------------------------------------------------------------------
drkns 2020-06-15 21:22:23+01:00 - build 5618

1. Incorrect CD drive type detection in some cases.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях некорректно определялся тип CD-привода.

2. Рефакторинг.

--------------------------------------------------------------------------------
shmuel 2020-06-09 16:37:06+03:00 - build 5617

1. Revert 5613.

--------------------------------------------------------------------------------
svs 2020-06-08 20:49:34+03:00 - build 5616

1. SQLite 3.32.2

--------------------------------------------------------------------------------
drkns 2020-06-01 02:05:40+01:00 - build 5615

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-05-30 20:22:00+01:00 - build 5614

1. FarDlgBuilder.hpp doesn't depend on DlgBuilder.hpp anymore.
   DlgBuilder.hpp is now only used by plugins.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убрана зависимость FarDlgBuilder.hpp от DlgBuilder.hpp.
   DlgBuilder.hpp теперь используется только в плагинах.

--------------------------------------------------------------------------------
shmuel 2020-05-30 19:39:20+03:00 - build 5613

1. Experimentally: do not hide progress windows (e.g. copy progress) during macro execution.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментально: не будем прятать окошки прогресса (например, копирования) при исполнении макроса.

--------------------------------------------------------------------------------
drkns 2020-05-29 18:57:47+01:00 - build 5612

1. File descriptions weren't removed in some cases.

2. Refactoring.

3. Warnings.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях не удалялись описания файлов.

2. Рефакторинг.

3. Warnings.

--------------------------------------------------------------------------------
svs 2020-05-27 21:30:18+03:00 - build 5611

1. SQLite 3.32.1

--------------------------------------------------------------------------------
drkns 2020-05-26 08:45:08+01:00 - build 5610

1. Correction of 5608.

--------------------------------------------------------------------------------
svs 2020-05-26 10:38:50+03:00 - build 5609

1. SQLite 3.32.0

--------------------------------------------------------------------------------
drkns 2020-05-25 16:27:26+01:00 - build 5608

1. Incorrect symlink creation.

2. Incorrect display of network drives in attributes dialog.

3. Refactoring. Removed a lot of copy-paste.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Некорректно создавались символические ссылки.

2. В диалоге атрибутов некорректно отображались сетевые диски.

3. Рефакторинг. Выкинуто много копипасты.

--------------------------------------------------------------------------------
drkns 2020-05-24 20:53:25+01:00 - build 5607

1. New versions of fmt, tinyxml2, Catch2.

2. Warnings.

--------------------------------------------------------------------------------
drkns 2020-05-24 02:04:04+01:00 - build 5606

1. Correction of 5599 once more.

2. Ignore spaces before / after far:config and far:about.

3. A few minor optimisations.

4. Unit tests preserve the clipboard.

5. Remove the disclaimer from this file. Update it along with everything else, it's not that hard.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5599 еще раз.

2. Игнорирование пробелов перед / после far:config и far:about.

3. Пара мелких оптимизаций.

4. Юнит-тесты не очищают буфер обмена.

5. Убран дисклеймер из changelog_eng. Обновляйте его вместе со всем остальным, это не так сложно.

--------------------------------------------------------------------------------
zg 2020-05-21 14:52:59+03:00 - build 5605

1. first DN_GOTFOCUS could contain outdated information.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. первый DN_GOTFOCUS приходил не всегда с актуальной информацией.

--------------------------------------------------------------------------------
drkns 2020-05-19 20:35:17+01:00 - build 5604

1. gh-242: Far2 CtrlAltShift behavior

--------------------------------------------------------------------------------
zg 2020-05-18 23:28:13+03:00 - build 5603

1. revert 5601.

--------------------------------------------------------------------------------
drkns 2020-05-18 18:13:57+01:00 - build 5602

1. Correction of 5599.

--------------------------------------------------------------------------------
zg 2020-05-18 17:08:41+03:00 - build 5601

1. experimental: new event SE_FOLDERCHANGED, sent when changing the current directory in panels.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. экспериментально: новое событие SE_FOLDERCHANGED, приходит асинхронно при смене текущей папки в панелях.

--------------------------------------------------------------------------------
drkns 2020-05-17 17:56:00+01:00 - build 5600

1. Refactoring.

2. Tests.

--------------------------------------------------------------------------------
drkns 2020-05-16 02:22:20+01:00 - build 5599

1. Refactoring.

2. Warnings.

--------------------------------------------------------------------------------
drkns 2020-05-15 18:05:22+01:00 - build 5598

1. Request credentials when traversing network paths.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Запрос имени & пароля при переходам по сетевым путям.

--------------------------------------------------------------------------------
drkns 2020-05-13 23:46:30+01:00 - build 5597

1. Refactoring.

2. Corrections of 5592.

3. Warnings.

--------------------------------------------------------------------------------
drkns 2020-05-04 20:12:47+03:00 - build 5596

1. Correction of 5592.

--------------------------------------------------------------------------------
zg 2020-05-04 14:50:25+03:00 - build 5595

1. forum: combobox allows to position the cursor outside the text boundaries.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: Комбобокс позволяет установить курсор за пределы текста.

--------------------------------------------------------------------------------
MZK 2020-05-02 23:48:24-07:00

1. Translated more far:config help pages into English.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config.

--------------------------------------------------------------------------------
drkns 2020-05-02 12:56:48+03:00 - build 5594

1. Correction of 5592.

--------------------------------------------------------------------------------
drkns 2020-05-02 02:54:39+03:00 - build 5593

1. Continue 5592 - simplify copying files & setting attributes.

2. Remove splitting files from copying.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5592 - упрощение копирования файлов и установки атрибутов.

2. Из копирования убрано разрезание файлов.

--------------------------------------------------------------------------------
drkns 2020-04-30 20:15:13+03:00 - build 5592

1. Refactoring.

--------------------------------------------------------------------------------
shmuel 2020-04-23 22:40:18+02:00 - build 5591

1. gh-233: Panel.SetPosIdx makes hidden Panel visible

--------------------------------------------------------------------------------
drkns 2020-04-21 20:12:46+03:00 - build 5590

1. Switching the code page breaks the editor state in some cases.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В некоторых случаях переключение кодовой страницы могло портить состояние редактора.

--------------------------------------------------------------------------------
drkns 2020-04-19 22:19:47+03:00 - build 5589

1. gh-237: set command is too strict with whitespace

--------------------------------------------------------------------------------
drkns 2020-04-16 20:14:43+03:00 - build 5588

1. Exception dialog: look for symbols in the crashed plugin's directory.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Диалог исключения: поиск символов в папке упавшего плагина.

--------------------------------------------------------------------------------
drkns 2020-04-15 22:27:36+03:00 - build 5587

1. Experimental UTF-8 converter extension to support the full UCS-2 range, including unpaired surrogates.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментальное расширение UTF-8 конвертера для поддержки полного диапазона UCS-2, включая непарные суррогаты.

--------------------------------------------------------------------------------
drkns 2020-04-15 02:08:30+03:00 - build 5586

1. Continuation of 5585.

--------------------------------------------------------------------------------
drkns 2020-04-14 22:38:19+03:00 - build 5585

1. As it turned out, the wonderful SQLite library wonderfully works with UTF16, namely:
   - converts the passed strings to UTF8, replacing any failures with 0xfffd.
   - looks for BOM in the passed strings to decide whether it's LE or BE.
   Maybe it's reasonable in some cloud cuckoo land, but definitely not in our case.
   All this luxury can't be turned off, so now we convert to UTF8 manually.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Как выяснилось, прекрасная библиотека SQLite прекрасно работает с UTF16, а именно:
   - конвертирует переданные строки в UTF8, при этом заменяя на 0xfffd всё, что не получилось.
   - пытается искать BOM в переданных строках и угадывать по нему, это LE или BE.
   Может быть это и уместно в какой-то сказочной стране, но точно не в нашем случае.
   Так как вся эта роскошь не отключается - будем конвертировать в UTF8 самостоятельно.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-04-13 00:07:06+03:00 - build 5584

1. Private flags of ansi plugins panel items weren't preserved.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не сохранялись приватные флаги элементов панелей ansi плагинов.

--------------------------------------------------------------------------------
zg 2020-04-12 14:24:14+03:00 - build 5583

1. 0003703: Colorer: invisible dialog on log creation error.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003703: Colorer: невидимый диалог при ошибке создания лога.

--------------------------------------------------------------------------------
drkns 2020-04-12 14:01:23+03:00 - build 5582

1. Exception dialog:
   - Show plugin name, version, description, author
   - Add "Copy" button (for those who are not aware of Ctrl+C)
   - "Terminate" button is always available.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Диалог исключения:
   - Показываем имя, версию, описание, автора плагина
   - Добавлена кнопка "Copy" (для тех, кто не в курсе о Ctrl+C)
   - Кнопка "Terminate" доступна всегда.

--------------------------------------------------------------------------------
drkns 2020-04-11 15:21:20+03:00 - build 5581

1. Extend the "Interface / console icon" option - now it's possible to choose which one to use.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Расширена опция "Interface / console icon" - теперь можно выбрать, что именно использовать.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-04-07 02:46:13+03:00 - build 5580

1. Changed the format of filter flags in the database (to make further changes possible - keeping blobs was not the best idea).
   Reading of the old format is still supported for compatibility.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Изменён формат флагов фильтров в базе данных (задел на будущее - хранить блобы было не самой лучшей идеей).
   В целях совместимости пока поддерживается чтение старого формата.

--------------------------------------------------------------------------------
yjh 2020-04-03 12:03:46+03:00 - build 5579

1. New option Panel.ReverseSortCharCompat - when set, the sorting indicator behaves like in Far 1 & 2.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Добавлена настройка Panel.ReverseSortCharCompat - при установке её
   в true отображение обратных режимов сортивоки происходит так же как
   в Far2/Far1 (маленька буква обратный порядок, большая - прямой).

--------------------------------------------------------------------------------
drkns 2020-03-28 15:58:39+02:00 - build 5578

1. Refactoring.

2. Minimum GCC version - 8.1.

--------------------------------------------------------------------------------
drkns 2020-03-26 19:19:19+02:00 - build 5577

1. New versions of fmt, tinyxml2, Catch2.

--------------------------------------------------------------------------------
drkns 2020-03-26 00:44:00+02:00 - build 5576

1. Correction of 5570 - the plugins cache might work incorrectly.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5570 - кеш плагинов мог работать некорректно.

--------------------------------------------------------------------------------
drkns 2020-03-24 01:10:31+02:00 - build 5575

1. gh-45: Editor: A very strange bug in cursor positioning.

2. Correction of 5554: visual artefacts after resizing the console.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. gh-45: Editor: Очень странный баг позиции курсора

2. Уточнение 5554 - визуальные артефакты при изменении размеров консоли.

--------------------------------------------------------------------------------
drkns 2020-03-22 16:09:56+02:00 - build 5574

1. Possible stack corruption when switching the main menu with a mouse.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Можно было испортить стек, переключая главное меню мышью.

--------------------------------------------------------------------------------
drkns 2020-03-22 13:47:01+02:00 - build 5573

1. More about unicode & debugging.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ещё на тему юникода и отладки.

--------------------------------------------------------------------------------
drkns 2020-03-22 12:46:20+02:00 - build 5572

1. A few corrections of 5571.

--------------------------------------------------------------------------------
drkns 2020-03-22 01:25:01+02:00 - build 5571

1. 0003313: FCTL_SETPANELDIRECTORY not working for certain types of paths.

2. Search results could sometimes include results of the previous search.

3. Use unicode DbgHelp functions (if available).

4. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003313: FCTL_SETPANELDIRECTORY not working for certain types of paths.

2. Результаты поиска могли иногда включать результаты предыдущего поиска.

3. Используются юникодные функции DbgHelp (если есть).

4. Рефакторинг.

--------------------------------------------------------------------------------
MZK 2020-03-11 23:03:40-07:00

1. Translated more far:config help pages into English; cleaned up eng/TechInfo.txt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config; почистил eng/TechInfo.txt.

--------------------------------------------------------------------------------
drkns 2020-03-11 18:14:35+00:00 - build 5570

1. A bit of magic to make the wow64 hook work in VS2019.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Немного магии для работы wow64 хука в VS2019.

2. Рефакторинг.

--------------------------------------------------------------------------------
zg 2020-03-10 00:35:41+02:00 - build 5569

1. crash in SettingsControl if the setting name is nullptr.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. падение в SettingsControl, если в качестве названия настройки передать nullptr.

--------------------------------------------------------------------------------
drkns 2020-03-07 22:21:15+00:00 - build 5568

1. Refactoring.

2. More tests.

3. Continuation of 5567.

--------------------------------------------------------------------------------
MZK 2020-03-07 12:45:31-08:00

1. Revised @System.CopySecurityOptions help page, both English and Russian.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переработал страницу справки @System.CopySecurityOptions, английскую и русскую.

--------------------------------------------------------------------------------
drkns 2020-03-07 18:03:21+00:00 - build 5567

1. Forum: opening large files in editor is too slow after 5527.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: начиная с билда 5527 стало тормозить открывание больших файлов редактором.

--------------------------------------------------------------------------------
drkns 2020-03-02 22:55:22+00:00 - build 5566

1. Correction of 5564.

--------------------------------------------------------------------------------
drkns 2020-03-02 19:36:15+00:00 - build 5565

1. gh-221: Help for MkTemp is out of date or something is broken

--------------------------------------------------------------------------------
drkns 2020-03-01 21:34:45+00:00 - build 5564

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2020-02-24 20:56:50+00:00 - build 5563

1. Refactoring.

2. Clang warnings.

--------------------------------------------------------------------------------
zg 2020-02-24 14:44:36+02:00 - build 5562

1. correction of 5561.

--------------------------------------------------------------------------------
zg 2020-02-18 19:59:14+02:00 - build 5561

1. crash in FCTL_GETUSERSCREEN.

--------------------------------------------------------------------------------
drkns 2020-02-17 18:09:59+00:00 - build 5560

1. Forum: User Menu and panels flickering.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: UserMenu и мерцание панелей.

--------------------------------------------------------------------------------
drkns 2020-02-17 01:36:09+00:00 - build 5559

1. Correction of 5558.4.

--------------------------------------------------------------------------------
drkns 2020-02-15 20:30:40+00:00 - build 5558

1. Remove thread priority overriding.

2. Remove XLat tables from the code, there's default.farconfig for that.

3. Buffer overflow on pasting into an edit field win an input mask.

4. Other refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убрано ручное переопределение приоритета.

2. Убрано добавление таблиц XLat из кода, для этого default.farconfig.

3. Выход за границу буфера при вставке в поле ввода с маской.

4. Прочий рефакторинг.

--------------------------------------------------------------------------------
drkns 2020-02-09 10:28:30+00:00 - build 5557

1. Apply 5556.1 to plugin panels as well (#0003675).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Применим 5556.1 и к плагиновым панелям (#0003675).

--------------------------------------------------------------------------------
drkns 2020-02-09 00:11:22+00:00 - build 5556

1. Correction of 5514 - already filtered out extensions were unavailable in autofilters.

2. Corrections of disks and filters menu rendering for some corner cases.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5514 - в автофильтрах были недоступны уже отфильтрованные расширения.

2. Уточнения отображения меню дисков и фильтров для некоторых вычурных случаев.

--------------------------------------------------------------------------------
drkns 2020-02-07 21:55:55+00:00 - build 5555

1. New versions of fmt and Catch2.

--------------------------------------------------------------------------------
drkns 2020-02-07 21:43:51+00:00 - build 5554

1. Refactoring.

2. More tests.

3. Potential leaks in RestoreScreen & FreeScreen.

4. Please note that any new fields in API structures should be added at the end only.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Больше тестов.

3. Потенциальные утечки в RestoreScreen & FreeScreen.

4. Пожалуйста, имейте в виду, что любые новые поля в структурах API должны добавляться исключительно в конец.

--------------------------------------------------------------------------------
shmuel 2020-02-07 21:48:51+02:00 - build 5553

1. Function FreeScreen added to the plugins API.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В API плагинов добавлена функция FreeScreen.

--------------------------------------------------------------------------------
drkns 2020-02-02 23:59:59+00:00 - build 5552

1. Refactoring.

--------------------------------------------------------------------------------
zg 2020-02-03 00:46:01+02:00 - build 5551

1. correction of 5542.

--------------------------------------------------------------------------------
svs 2020-01-29 12:51:16+03:00 - build 5550

1. SQLite 3.31.1

--------------------------------------------------------------------------------
drkns 2020-01-25 22:32:20+00:00 - build 5549

1. Possible rubbish in time field when creating a new filter.

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При создании фильтра в поле времени мог попадать мусор.

2. Пара мелочей.

--------------------------------------------------------------------------------
svs 2020-01-23 16:42:03+03:00 - build 5548

1. SQLite 3.31.0

--------------------------------------------------------------------------------
zg 2020-01-21 23:24:24+02:00 - build 5547

1. correction of 5542.

--------------------------------------------------------------------------------
drkns 2020-01-18 00:59:59+00:00 - build 5546

1. Refactoring.

--------------------------------------------------------------------------------
MZK 2020-01-05 20:56:58-08:00

1. Translated more far:config help pages into English; cleaned up eng/TechInfo.txt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config; почистил eng/TechInfo.txt.

--------------------------------------------------------------------------------
zg 2020-01-02 10:03:36+02:00 - build 5545

1. Correction of 5544.

--------------------------------------------------------------------------------
zg 2020-01-02 03:19:09+02:00 - build 5544

1. Crash on deleting an item from history #219.

--------------------------------------------------------------------------------
zg 2019-12-30 15:54:05+02:00 - build 5543

1. Correction of 5542.

--------------------------------------------------------------------------------
zg 2019-12-30 04:29:53+02:00 - build 5542

1. Experimental: DN_LISTCHANGE is delivered to regular menus.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. экспериментально: DN_LISTCHANGE приходит в обычные меню.

--------------------------------------------------------------------------------
drkns 2019-12-29 14:31:00+02:00 - build 5541

1. Continuation of 5540.

--------------------------------------------------------------------------------
drkns 2019-12-28 21:08:45+02:00 - build 5540

1. Show platform and SCM revision in Exception Dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем платформу и SCM revision в диалоге исключения.

--------------------------------------------------------------------------------
drkns 2019-12-27 19:20:00+02:00 - build 5539

1. Ctrl+C works in Exception Dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В диалоге иключения работает Ctrl+C.

--------------------------------------------------------------------------------
drkns 2019-12-27 10:45:14+02:00 - build 5538

1. Continuation of 5534 once more.

--------------------------------------------------------------------------------
drkns 2019-12-27 02:56:14+02:00 - build 5537

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-12-25 13:19:27+02:00 - build 5536

1. Correction of 5523.

--------------------------------------------------------------------------------
drkns 2019-12-24 19:25:57+02:00 - build 5535

1. Continuation of 5534 - an attempt to correctly process some corner cases, e.g. empty menus or menus without borders.

2. Show the most nested exception first.

3. Minor refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5534 - попробуем корректно обрабатывать всякие дивные случаи типа пустых меню или меню без рамок.

2. При отображении исключений показываем сначала наиболее глубокое.

3. Мелкий рефакторинг.

--------------------------------------------------------------------------------
zg 2019-12-24 02:04:54+02:00 - build 5534

1. continuation of 5530.2: minimal menu size is 8x5.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. продолжение 5530.2: размер меню не может быть меньше 8x5.

--------------------------------------------------------------------------------
drkns 2019-12-23 19:22:00+02:00 - build 5533

1. Forum: "Unexpected current file when opening a panel". A prehistoric bug.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: "Неожиданный текущий файл при запуске панели". Доисторический баг.

--------------------------------------------------------------------------------
drkns 2019-12-20 18:58:10+00:00 - build 5532

1. Forum: Alt+<Gray +> doesn't select files without extension.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Alt+<Gray +> не выделяет на панели файлы без расширения

--------------------------------------------------------------------------------
drkns 2019-12-20 17:22:58+00:00 - build 5531

1. 0003758: Crash after F3 on .. in plugin panel.

2. Correction of 5530.2.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003758: Падение Фара при нажатии F3 на .. в панели плагина.

2. Уточнение 5530.2.

--------------------------------------------------------------------------------
zg 2019-12-20 05:17:48+02:00 - build 5530

1. DM_RESIZEDIALOG: sizes that are smaller than 1 are treated as 1. same as 5267.

2. crash if a menu hotkey was outside the menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. DM_RESIZEDIALOG: при указании размеров меньше 1 они считаются равными 1. аналогично 5267.

2. падение, если хоткей в меню оказывался за пределами меню.

--------------------------------------------------------------------------------
drkns 2019-12-18 00:03:08+00:00 - build 5529

1. 0003757: far:config menu enters inconsistent state

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003757: Меню far:config входит в нерабочее состояние

--------------------------------------------------------------------------------
drkns 2019-12-16 21:38:49+00:00 - build 5528

1. Opening editor with an empty file name via API gives funny results.
   All this magic about ?New File? is bad, really bad.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Открывая через API редактор с пустым именем файла можно было получить забавные результаты.
   Всё это шаманство с ?New File? - это плохо, очень плохо.

--------------------------------------------------------------------------------
drkns 2019-12-14 23:03:49+00:00 - build 5527

1. 5524 - attempt #2, now with tests.

2. Other refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 5524 - попытка №2, теперь с тестами.

2. Прочий рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-12-12 08:03:42+00:00 - build 5526

1. Partial revert of 5524.

--------------------------------------------------------------------------------
drkns 2019-12-11 17:37:34+00:00 - build 5525

1. Correction of 5524.

--------------------------------------------------------------------------------
drkns 2019-12-11 01:29:03+00:00 - build 5524

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-12-08 23:12:53+00:00 - build 5523

1. Refactoring.

--------------------------------------------------------------------------------
shmuel 2019-12-07 23:25:55+02:00 - build 5522

1. Minor refactoring.

--------------------------------------------------------------------------------
drkns 2019-12-07 01:00:47+00:00 - build 5521

1. New fmt and Catch2 versions.

--------------------------------------------------------------------------------
drkns 2019-12-06 20:56:17+00:00 - build 5520

1. GCC build and warnings.

--------------------------------------------------------------------------------
drkns 2019-12-06 18:23:09+00:00 - build 5519

1. 0003755: Ctrl-H is slow in Code pages list
   Same in Task list.

2. Task list: mark the current task and other refactoring.

3. More logical wrapping in DIF_WORDWRAP.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003755: Тормозит Ctrl-H в списке Code pages
   То же самое в списке задач.

2. Cписок задач: пометка текущего окна и прочий рефакторинг.

3. Более логичная свёртка в DIF_WORDWRAP.

--------------------------------------------------------------------------------
drkns 2019-12-04 18:28:22+00:00 - build 5518

1. Removed UI time separation to milliseconds and ticks, now it's just ticks.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убрано разделение времени в UI на миллисекунды и такты, теперь просто такты.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-12-04 17:44:18+00:00 - build 5517

1. And once more.

--------------------------------------------------------------------------------
drkns 2019-12-04 09:13:12+00:00 - build 5516

1. Correction of 5514.

--------------------------------------------------------------------------------
drkns 2019-12-03 08:04:01+00:00 - build 5515

1. Correction of 5514.

--------------------------------------------------------------------------------
drkns 2019-12-02 23:24:22+00:00 - build 5514

1. Wild things in autofilters:
   - the extensions list was read from the FS instead of the panel, causing slowness in network folders
   - with a lucky stars arrangement it was posible to get untoggleable filters.
   A lot of changes, strange things could happen.

2. Wild things in ampersand shortcuts handling: keys didn't work sometimes, menu scrolling was incorrect, copypaste and so on.
   A lot of changes, strange things could happen.

3. More tolerant loading of filters, highlight, panel modes - not until the first failure, but as much as possible.
   A lot of changes, strange things could happen.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В автофильтрах творилась дичь:
   - список расширений брался не с панели, а с ФС, что приводило к тормозам в сетевых папках
   - при удачном расположении звёзд можно было получить неотключаемые фильтры.
   Много изменений, возможны чудеса.

2. В обработке ampersand shortcuts творилась дичь: иногда не работали клавиши, криво работала прокрутка в меню, копипаста и т.д и т.п.
   Много изменений, возможны чудеса.

3. Более толерантная загрузка фильтров, раскраски, режимов панели - не до первой неудачи, а пока есть, что загружать.
   Много изменений, возможны чудеса.

--------------------------------------------------------------------------------
drkns 2019-11-26 21:09:23+00:00 - build 5513

1. Copying files from panels to clipboard reassigned to Ctrl+Shift+C. Ctrl+C goes into the command line as before.

2. Added cutting files from panels to clipboard via Ctrl+Shift+X.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Копирование файлов с панелей в буфер обмена перенесено на Ctrl+Shift+C. Ctrl+C уходит в комстроку, как раньше.

2. Добавлено вырезание файлов с панелей в буфер обмена по Ctrl+Shift+X.

--------------------------------------------------------------------------------
drkns 2019-11-21 20:56:02+00:00 - build 5512

1. M#0003470: Option "[ ] Detect virtual disks" for Disks menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#0003470: Опция "[ ] Определять виртуальные диски" для меню дисков.

--------------------------------------------------------------------------------
drkns 2019-11-20 00:55:00+00:00 - build 5511

1. Continuation of 1771.2 or 9 years later: second attempt to fix Backspace/Del madness in DIF_MASKEDIT.

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 1771.2 или 9 лет спустя: вторая попытка починить дичь с Backspace/Del в DIF_MASKEDIT.

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2019-11-18 22:58:30+00:00 - build 5510

1. Forum: Del doesn't work in Autocomplete

--------------------------------------------------------------------------------
drkns 2019-11-16 19:18:17+00:00 - build 5509

1. Add "[ ] Preserve timestamps" option to Copy dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В диалог копирования добавлена опция "[ ] Preserve timestamps".

--------------------------------------------------------------------------------
drkns 2019-11-10 16:42:35+00:00 - build 5508

1. Correction of 5506.

--------------------------------------------------------------------------------
drkns 2019-11-10 10:18:04+00:00 - build 5507

1. Continuation of 5506 for [x] Use system copy routine.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5506 и для [x] Use system copy routine.

--------------------------------------------------------------------------------
drkns 2019-11-09 21:25:47+00:00 - build 5506

1. File copying preserves creation and access times. Unconditionally for now. Shout if you need an option.

2. Detach of virtual disks didn't work in some cases.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Копирование файлов сохраняет времена создания и доступа. Пока безусловно. Если нужна опция - кричите.

2. Не работало отключение виртуальных дисков в определённых ситуациях.

3. Рефакторинг.

--------------------------------------------------------------------------------
shmuel 2019-11-09 15:06:08+02:00 - build 5505

1. API-function Menu() - added flag FMENU_NODRAWSHADOW.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. API-функция Menu() - добавлен флаг FMENU_NODRAWSHADOW.

--------------------------------------------------------------------------------
shmuel 2019-11-07 12:15:11+02:00 - build 5504

1. API-function Menu() - added flags for control of visibility and appearance of menu borders.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. API-функция Menu() - добавлены флаги для управления показом и видом рамки меню.

--------------------------------------------------------------------------------
MZK 2019-11-04 23:29:26-08:00

1. Translated more far:config help pages into English; cleaning up eng/TechInfo.txt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config; почистил eng/TechInfo.txt.

--------------------------------------------------------------------------------
shmuel 2019-10-31 19:29:22+02:00 - build 5503

1. Refactoring.

--------------------------------------------------------------------------------
shmuel 2019-10-30 22:24:15+02:00 - build 5502

1. M#3748: Panel.Item: return value when given incorrect parameters

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#3748: Panel.Item: возвращаемое значение при некорректных параметрах

--------------------------------------------------------------------------------
shmuel 2019-10-30 14:47:08+02:00 - build 5501

1. Keyboard macros could not be deleted or edited after 5496.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. После 5496 перестали удаляться и редактироваться клавиатурные макросы.

--------------------------------------------------------------------------------
shmuel 2019-10-28 23:30:53+02:00 - build 5500

1. Refactoring.

--------------------------------------------------------------------------------
shmuel 2019-10-28 20:59:35+02:00 - build 5499

1. As this case is not mentioned in the docs MacroAddMacro::SequenceText is allowed
   to be an empty string. An empty string is a valid script.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поскольку в документации данный случай не оговорен, MacroAddMacro::SequenceText может быть
   пустой строкой. Пустая строка - это валидный скрипт.

--------------------------------------------------------------------------------
drkns 2019-10-26 14:40:42+01:00 - build 5498

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-10-25 18:08:44+01:00 - build 5497

1. Continuation of 1053.2 - apply the workaround to the initial INPUT_RECORD as well - it might fall into plugins' hands.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 1053.2 - распространим костыль и на исходный INPUT_RECORD - он может попасть в руки плагинам.

--------------------------------------------------------------------------------
drkns 2019-10-24 11:12:59+01:00 - build 5496

1. Correction of 5495.

2. Minor refactoring to avoid such issues in future.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5495.

2. Мелкий рефакторинг дабы избежать подобного в дальнейшем.

--------------------------------------------------------------------------------
drkns 2019-10-24 02:04:06+01:00 - build 5495

1. Show Far and OS versions in the exception dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем версии Far и ОС в диалоге исключения.

--------------------------------------------------------------------------------
zg 2019-10-23 22:20:01+03:00 - build 5494

1. after 5024 the Mouse2002 plugin hang on a mouse selection. workaround.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. после 5024 плагин Mouse2002 зависал при выделении мышью. костыль.

--------------------------------------------------------------------------------
shmuel 2019-10-21 11:29:48+02:00 - build 5493

1. Panel.Item(X,Idx,10) - property 'SortGroup' - returns again a number rather than a boolean.
   Returning a boolean was a bug.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Panel.Item(X,Idx,10) - свойство 'SortGroup' - снова возвращает число, а не булевую величину.
   Возврат булевой величины был багом.

--------------------------------------------------------------------------------
shmuel 2019-10-20 13:03:24+02:00 - build 5492

1. Revert 5490: this change will be done in plugin LuaMacro.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Откат 5490: это изменение будет сделано в плагине LuaMacro.

--------------------------------------------------------------------------------
drkns 2019-10-20 00:07:00+01:00 - build 5491

1. Workaround for incorrect mouse coordinates when wheels are moved.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Workaround для неправильных координат мыши при вращении колёс.

--------------------------------------------------------------------------------
shmuel 2019-10-19 18:22:32+02:00 - build 5490

1. Panel.Item(X,Idx,8) and Panel.Item(X,Idx,10) given invalid Idx returned 0 now they return false.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Panel.Item(X,Idx,8) и Panel.Item(X,Idx,10) при невалидном Idx возвращали 0, теперь false.

--------------------------------------------------------------------------------
drkns 2019-10-19 14:36:42+01:00 - build 5489

1. Continuation of 5481 once more.

2. A few minor changes.

--------------------------------------------------------------------------------
drkns 2019-10-17 20:02:51+01:00 - build 5488

1. Refactoring.

2. When displaying the UI '\x9b' character is replaced with '\x203a', because '\x9b' is CSI.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. При выводе UI '\x9b' заменяется на '\x203a', т.к. '\x9b' - это CSI.

--------------------------------------------------------------------------------
svs 2019-10-14 08:38:17+03:00 - build 5487

1. SQLite 3.30.1

--------------------------------------------------------------------------------
drkns 2019-10-11 13:47:00+01:00 - build 5486

1. Revert of 5472, 4523, 4521 - Ctrl+Enter, Ctrl+[ and friends add a backslash to paths again.
   In case of quotes the backslash will be put inside, e.g. "C:\some path\", same as before.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Откат 5472, 4523, 4521 - Ctrl+Enter, Ctrl+[ и прочие вновь добавляют backslash к путям.
   При наличии кавычек backslash будет внутри - "С:\some path\", как раньше.

--------------------------------------------------------------------------------
drkns 2019-10-07 22:24:49+01:00 - build 5485

1. Refactoring.

2. Warnings.

--------------------------------------------------------------------------------
svs 2019-10-07 15:28:54+03:00 - build 5484

1. SQLite 3.30.0

--------------------------------------------------------------------------------
drkns 2019-10-06 10:09:55+01:00 - build 5483

1. Continuation of 5481 - odd bugs.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5481 - полезли нечётные баги.

--------------------------------------------------------------------------------
drkns 2019-10-06 01:13:54+01:00 - build 5482

1. Correction of 5481.

--------------------------------------------------------------------------------
drkns 2019-10-05 23:31:53+01:00 - build 5481

1. Refactoring.

2. More const.

3. More tests.

4. Warnings.

--------------------------------------------------------------------------------
drkns 2019-10-03 19:42:28+01:00 - build 5480

1. 0003742: Far incorrectly (?) passes names longer than 259 symbols to other programs.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003742: Far неправильно (?) передает другим программам пути файлов длиной >259 символов

--------------------------------------------------------------------------------
drkns 2019-10-02 18:22:31+01:00 - build 5479

1. Forum: lua:=mf.fsplit("\\\\SERVER\\share",1) doesn't work after 5211.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: в 5211 сломалось lua:=mf.fsplit("\\\\SERVER\\share",1)

--------------------------------------------------------------------------------
drkns 2019-09-24 19:31:14+01:00 - build 5478

1. Correction of 5225 - UTF-8 detection doesn't work in some cases.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5225 - в некоторых случаях не работало распознавание UTF-8.

--------------------------------------------------------------------------------
MZK 2019-09-23 19:41:13-07:00 - build 5477

1. Translated more far:config help pages into English and started cleaning up eng/TechInfo.txt.

2. Cosmetic change to Options::CmdlineSettings().

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config и начал чистить eng/TechInfo.txt.

2. Косметика в Options::CmdlineSettings().

--------------------------------------------------------------------------------
drkns 2019-09-18 08:15:51+01:00 - build 5476

1. Continuation of 5475.

--------------------------------------------------------------------------------
drkns 2019-09-17 22:46:48+01:00 - build 5475

1. Incorrect console text scrolling & restoring if the buffer is wider than the window.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Некорректная прокрутка и восстановление текста консоли, если буфер шире окна.

--------------------------------------------------------------------------------
drkns 2019-09-16 22:31:11+01:00 - build 5474

1. Correction of menu separators rendering.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение отображения разделителей в меню.

--------------------------------------------------------------------------------
drkns 2019-09-15 13:47:00+01:00 - build 5473

1. Vector representation of Far.ico (16, 24, 32, 48).
   Can be rendered to any size, with effects etc.
   Icons in the resources are recreated from the vector, added a few new versions.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Векторная репрезентация Far.ico (16, 24, 32, 48).
   Можно рендерить в любой размер, применять эффекты и т.д.
   ico в ресурсах перегенерированы из вектора, добавлена пара новых вариантов.

--------------------------------------------------------------------------------
drkns 2019-09-10 19:06:31+01:00 - build 5472

1. 0003011: Ctrl+Enter works wrong for ".." for case if path have spaces
   0003178: Incorrect position of closing quotation mark (") in full folder path
   0003198: Incorrect current folder path insertion
   0003200: Inconsistent behaviour of Ctrl+F on a regular folder and on ".."
   0003211: Redundant "\" when inserting a path from a panel
   0003700: Ctrl+enter in panel returns bad path: backslash out of quotes
   ...and probably more.
   As the number of reports suggests, inserting the slash after the quotation mark wasn't a good idea.
   However, inserting it before is not a good idea either (see #0003011), so now it's not inserted anywhere at all.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003011: Ctrl+Enter works wrong for ".." for case if path have spaces
   0003178: Неверное расположение завершающей двойной кавычки (") при получении полного пути к папке
   0003198: Неверная вставка текущей папки
   0003200: Неоднообразное поведение по Ctrl+F на "нормальной папке" и на ".."
   0003211: лишний "\" при вставке пути из панели
   0003700: Ctrl+enter in panel resurns bad path: backslash out of qoutes
   ...и наверное ещё.
   Как намекает количество репортов, вставлять слеш после кавычки было не очень удачным решением.
   Однако, вставлять его до - тоже не очень удачное решение (см. #0003011), поэтому теперь он не вставляется вообще.

--------------------------------------------------------------------------------
drkns 2019-09-09 19:18:40+01:00 - build 5471

1. Correction of 5437.

--------------------------------------------------------------------------------
zg 2019-09-08 21:10:55+03:00 - build 5470

1. crash at exit if opening of a modal editor was interrupted.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. при прерывании открытия модального редактора падение при выходе из фара.

--------------------------------------------------------------------------------
drkns 2019-09-07 15:06:49+01:00 - build 5469

1. fmt 6.0.0.

2. tinyxml2 7.1.0.

3. Catch2 2.9.2.

4. A few minor changes.

--------------------------------------------------------------------------------
drkns 2019-09-06 20:22:44+01:00 - build 5468

1. Forum: Search in viewer: [x] Whole words doesn't work if [x] Case sensitive is set.
   Actually the issue was much deeper and wider.

2. Forum: error setting file access rights.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поиск в Просмотрщике (Viewer): не учитывается [x] Whole words, если выставлено [x] Case sensitive
   На самом деле проблема была сильно глубже и шире.

2. С форума: Ошибка установки прав доступа к файлу

--------------------------------------------------------------------------------
MZK 2019-09-05 22:12:53-07:00

1. Translated more far:config help pages into English.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config.

--------------------------------------------------------------------------------
zg 2019-09-05 00:41:46+03:00 - build 5467

1. separate GUIDs for the dialogs to copy/move the file under cursor.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. отдельные гуиды для диалогов копирования/перемещения файла под курсором.

--------------------------------------------------------------------------------
drkns 2019-09-04 22:10:32+01:00 - build 5466

1. Continuation of 5464: in "!&" and "!&~" quoting is now on by defaut and can be disabled with 'q' modifier.

2. Minor refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5464: "!&" и "!&~" окавычивание теперь по умолчанию и отключается модификатором 'q'.

2. Мелкий рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-09-03 23:19:24+01:00 - build 5465

1. 0003736: Can't update file descriptions on a network drive.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003736: Невозможно изменить описание файла на сетевом диске

--------------------------------------------------------------------------------
drkns 2019-09-03 01:01:01+01:00 - build 5464

1. Experimental:
   - Metasymbols "!&" and "!&~" support "Q" modifier - "enclose names in quotes".
   - "Q" modifier in "!@!" and "!$!" now adds quotes unconditionally.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Экспериментально:
   - В метасимволах "!&" и "!&~" поддерживается модификатор "Q" - "заключать имена в кавычки".
   - В метасимволах "!@!" и "!$!" модификатор "Q" теперь добавляет кавычки безусловно.

--------------------------------------------------------------------------------
drkns 2019-09-02 21:09:11+01:00 - build 5463

1. Initialise COM as multithreaded, it seems to be more correct in our case.

2. Continuation of 5457.

3. Titles for far:config dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Инициализируем COM как multithreaded, вроде бы так правильнее в нашем случае.

2. Продолжение 5457.

3. Заголовки для диалога far:config.

--------------------------------------------------------------------------------
drkns 2019-09-01 20:26:46+01:00 - build 5462

1. Correction of 5448.2.

--------------------------------------------------------------------------------
zg 2019-09-01 13:53:23+03:00 - build 5461

1. visual artefacts in search results dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. визуальные артефакты в диалоге результатов поиска.

--------------------------------------------------------------------------------
drkns 2019-09-01 11:23:07+01:00 - build 5460

1. GCC 9.2.

2. Clang warnings.

--------------------------------------------------------------------------------
drkns 2019-08-28 21:55:48+01:00 - build 5459

1. Continuation of 5457.

--------------------------------------------------------------------------------
drkns 2019-08-28 17:03:39+01:00 - build 5458

1. A few workarounds to support Coverity.

2. Coverity warnings.

--------------------------------------------------------------------------------
drkns 2019-08-27 20:24:52+01:00 - build 5457

1. Forum: Improve out of the box keyboard navigation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Улучшения клавиатурной навигации в стандартной поставке

--------------------------------------------------------------------------------
drkns 2019-08-26 20:15:37+01:00 - build 5456

1. 0003735: Attribute Dialog: wrong focus for symlinks (correction of 5455).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003735: Attribute Dialog: разный фокус для symlink-папок (уточнение 5455).

--------------------------------------------------------------------------------
drkns 2019-08-25 22:22:22+01:00 - build 5455

1. It is known that time in Windows is measured in 100-ns intervals.
   In Attributes dialog all times were rounded to milliseconds, including those that weren't touched.
   From information security perspective this is an obvious footprint, so now the dialog exposes everything till the last tick.
   Same for filters and panels.

2. Rarely used attributes moved into a separate dialog.

3. Other cnahges in Attributes dialog:
   - Removed more copy-pasted code.
   - Unified the logic of attributes, dates and owners processing when switching "Process subfolders" and during the initial dialog population.

4. Attribute letters and their order are more or less in sync with Windows.

5. Forum: the folder of a first found file is not visible in a repeated search.

6. More types in far.natvis.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Как известно, время в Windows измеряется в 100-ns интервалах.
   В диалоге установки атрибутов все времена округлялись до миллисекунд, включая те, которые не трогали.
   С точки зрения информационной безопасности это явное палево, поэтому теперь диалог раскрывает всё до последнего тика.
   Аналогично в фильтрах и панелях.

2. Редкоиспользуемые атрибуты вынесены в отдельный диалог.

3. Прочие изменения в диалоге атрибутов:
   - Убрана еще куча копипасты.
   - Унифицирована логика обработки атрибутов, дат и владельцев при переключении "Process subfolders" и при начальном заполнении диалога.

4. Буквы и порядок атрибутов в панелях более-менее приведены в соответствие с Windows.

5. С форума: при повторном поиске каталог первого найденного файла не отображается.

6. Больше типов в far.natvis.

--------------------------------------------------------------------------------
MZK 2019-08-24 21:04:41-07:00

1. Translated more far:config help pages into English.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский ещё несколько страниц справки far:config.

--------------------------------------------------------------------------------
drkns 2019-08-22 23:34:45+01:00 - build 5454

1. Refactoring.

2. Minor optimisation of mapped network drives enumeration.

3. More types in far.natvis.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Мелкая оптимизация опроса mapped network drives.

3. Больше типов в far.natvis.

--------------------------------------------------------------------------------
drkns 2019-08-22 23:21:59+01:00 - build 5453

1. 0003733: Associations db lock blocks all other Far instances.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003733: блокируется работа всех инстансов фара, если залочена база ассоциаций.

--------------------------------------------------------------------------------
drkns 2019-08-18 15:08:42+01:00 - build 5452

1. Support FILE_ATTRIBUTE_RECALL_ON_OPEN, FILE_ATTRIBUTE_RECALL_ON_DATA_ACCESS, FILE_ATTRIBUTE_STRICTLY_SEQUENTIAL attributes. Because we can.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поддержка атрибутов FILE_ATTRIBUTE_RECALL_ON_OPEN, FILE_ATTRIBUTE_RECALL_ON_DATA_ACCESS, FILE_ATTRIBUTE_STRICTLY_SEQUENTIAL. Потому что можем.

--------------------------------------------------------------------------------
drkns 2019-08-16 23:06:24+01:00 - build 5451

1. Crash when importing malformed xml.

2. Fix GCC 7 build. Broken for a long time and no one said a word, time to stop supporting it?

3. Clang warnings.

4. Compile hook_wow64.cpp as everything else and modernise it a little.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Падение при импорте кривых xml.

2. Исправлена сборка в GCC 7. Поломано уже давно и все молчат, пора прекращать поддержку?

3. Clang warnings.

4. Компилируем hook_wow64.cpp так же, как и всё остальное, ну и обновим его немного.

--------------------------------------------------------------------------------
MZK 2019-08-12 22:51:26-07:00

1. Translated several far:config help pages into English.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский несколько страниц справки far:config.

--------------------------------------------------------------------------------
drkns 2019-08-11 19:02:00+01:00 - build 5450

1. Compare folders:
   - Optimisation of time comparison on FAT systems.
   - Time comparison for some reason worked with reduced precision not only on FAT.

2. Updated some commented code and replaced "#if 0" with "if constexpr (false)" where possible.

3. Removed "Sort by custom data" from the UI - it does nothing for the last 5 years.

4. Warnings.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Compare folders:
   - Оптимизация сравнения времени на FAT-системах.
   - Сравнение времени зачем-то работало с пониженной точностью для всего подряд, а не только для FAT.

2. Обновлён некоторый закомментированный код. "#if 0" по возможности заменено на "if constexpr (false)".

3. Из интерфейса удалено "Sort by custom data", т.к. оно ничего не делает уже 5 лет.

4. Warnings.

--------------------------------------------------------------------------------
drkns 2019-08-09 22:23:24+01:00 - build 5449

1. Drop some existing Windows 10 workarounds and add some new (#2366).
   Every day I love this OS more and more.

2. Correction of 5433 for those who want to press buttons fancifully.

3. Warnings.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Удаляем одни костыли для Windows 10 и добавляем другие (#2366).
   Я люблю эту ОС всё больше и больше с каждым днём.

2. Уточнение 5433 для желающих вычурно нажимать кнопки.

3. Warnings.

--------------------------------------------------------------------------------
drkns 2019-08-08 19:39:35+01:00 - build 5448

1. 0003717: #5411 should be optional

2. 0003730: Incorrect access rights after saving a file.

3. Support for a plethora of new reparse tags.

4. A little black magic for VS2019 build to work in Win2k.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003717: #5411 should be optional

2. 0003730: Неверные права доступа к файлу, сохранённому из Редактора

3. Поддержка кучи новых reparse tags.

4. Немного чёрной магии, чтобы VS2019 билд мог запускаться в Win2k.

--------------------------------------------------------------------------------
drkns 2019-08-07 22:16:22+01:00 - build 5447

1. Correction of 5418.

--------------------------------------------------------------------------------
drkns 2019-08-07 20:01:30+01:00 - build 5446

1. 0003729: Preserve encryption of system files after editing.

2. Same for copying.

3. Removed some copy-pasted code.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003729: Зашифрованный файл (+S+E) в папке (-E) сохраняется редактором как незашифрованный

2. То же самое в копировании.

3. Убрано немного копипасты.

--------------------------------------------------------------------------------
drkns 2019-08-07 00:44:00+01:00 - build 5445

1. Hex-viewer in UTF-16 mode shows hex as everywhere else - as bytes.
   The code page affects only the text part.
   Before: "0000000048: 006C 0061 007A 0079 │ 0020 0064 006F 0067  lazy dog"
   After:  "0000000048: 6C 00 61 00 7A 00 79 00 │ 20 00 64 00 6F 00 67 00  lazy dog"

2. Correction of 5441 - no need to request elevation when reading a directory.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Hex-viewer в режиме UTF-16 показывает hex как везде - байтами.
   Кодовая страница влияет только на отображение текстовой части.
   Было:  "0000000048: 006C 0061 007A 0079 │ 0020 0064 006F 0067  lazy dog"
   Стало: "0000000048: 6C 00 61 00 7A 00 79 00 │ 20 00 64 00 6F 00 67 00  lazy dog"

2. Уточнение 5441 - запросы повышения прав не нужны при чтении папки.

--------------------------------------------------------------------------------
drkns 2019-08-05 23:24:36+01:00 - build 5444

1. Move Grabber help to a separate topic.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Справка по грабберу вынесена в отдельный топик.

--------------------------------------------------------------------------------
shmuel 2019-08-04 03:04:52+02:00 - build 5443

1. Load macros before the first panels update in order to immediately show content-columns defined in macro-files.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Загружаем макросы до первого обновления панелей, чтобы сразу отображались контент-колонки, заданные в макрофайлах.

--------------------------------------------------------------------------------
drkns 2019-08-02 20:14:49+01:00 - build 5442

1. Forum: F9 -> Options -> File panel modes -> Ins -> crash.

--------------------------------------------------------------------------------
drkns 2019-08-02 01:32:31+01:00 - build 5441

1. It should be possible to pass access rights through elevation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Права доступа должны корректно протаскиваться через elevation.

--------------------------------------------------------------------------------
zg 2019-07-31 14:28:50+03:00 - build 5440

1. Forum: Cosmetic defects of positioning in filtered list.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: Косметические дефекты позиционирования в отфильтрованном списке.

--------------------------------------------------------------------------------
drkns 2019-07-31 01:27:30+01:00 - build 5439

1. Continuation of 5438 - improve error handling.

--------------------------------------------------------------------------------
drkns 2019-07-31 00:47:04+01:00 - build 5438

1. Copy option "Inherit access rights" was inadequate: copying the access rights from the parent folder is not "inheriting" in any way. And it has always been like that.

2. Everything else there related to access rights was inadequate as well.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В копировании неадекватно работала опция "Inherit access rights": копирование прав родительской папки - это ни разу не "наследование". Причём так было всегда.

2. Всё остальное там же, связанное с правами доступа, тоже не отличалось адекватностью.

--------------------------------------------------------------------------------
drkns 2019-07-29 22:50:07+01:00 - build 5437

1. Continuation of 5435.

--------------------------------------------------------------------------------
drkns 2019-07-28 19:35:59+01:00 - build 5436

1. Forum: Long <title> strings in !?<title>?<init>! don't fit into the dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Длинные строки <title> в !?<title>?<init>! выползают за границы диалога.

--------------------------------------------------------------------------------
drkns 2019-07-28 14:41:29+01:00 - build 5435

1. Moving a symlink with [x] Copy contents of symbolic links or over a network could suddenly delete files in the folder it was pointing to.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перенос симлинка с [x] Copy contents of symbolic links или по сети мог внезапно удалять файлы в папке, на которую он показывал.

--------------------------------------------------------------------------------
drkns 2019-07-28 01:27:05+01:00 - build 5434

1. SCM revision in far:about.

2. Manually built versions are marked as Private by default.

3. Other clarifications of displaying versions in the UI.

4. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. SCM revision в far:about.

2. Версии, собранные вручную, по умолчанию помечаются как Private.

3. Прочие уточнения вывода версии в интерфейсе.

4. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-07-23 19:23:43+01:00 - build 5433

1. VK_DECIMAL is not always the same as '.'.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. VK_DECIMAL не всегда то же самое, что и '.'.

--------------------------------------------------------------------------------
drkns 2019-07-23 07:20:01+01:00 - build 5432

1. Correction of 5429.

--------------------------------------------------------------------------------
drkns 2019-07-22 23:46:59+01:00 - build 5431

1. Correction of 5429.

2. Minor improvements in the leak detector.

3. After creating a minidump show where exactly the file is saved (or not saved).

4. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5429.

2. Мелкие улучшения детектора утечек памяти.

3. После создания минидампа показываем, куда именно сохранён (или не сохранён) файл.

4. Рефакторинг.

--------------------------------------------------------------------------------
zg 2019-07-23 01:28:35+03:00 - build 5430

1. Correction of 5428.

--------------------------------------------------------------------------------
drkns 2019-07-22 21:20:03+01:00 - build 5429

1. Plugin data leaks when searching on a plugin panel.

2. Stack overflow in the search in some cases.

3. Cancelling the search discards the rest of the queued messages now.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Утечки плагиновых данных при поиске на плагиновой панели.

2. Переполнение стека при поиске в некоторых случаях.

3. При отмене поиска не пытаемся пропихнуть остатки очереди сообщений в диалог.

--------------------------------------------------------------------------------
zg 2019-07-22 05:02:32+03:00 - build 5428

1. Don't redraw panels while searching.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. при поиске панели не перерисовываются.

--------------------------------------------------------------------------------
drkns 2019-07-21 17:27:47+01:00 - build 5427

1. GitHub #161: Tabs in descript.ion.

--------------------------------------------------------------------------------
drkns 2019-07-15 23:59:59+01:00 - build 5426

1. Removed a horrible pile of copypasted code from setattr & fileattr. Consequences are possible.

2. The "unchanged text" state didn't work properly in fixed width edit controls.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Удалена жуткая куча копипасты из setattr & fileattr. Возможны последствия.

2. Состояние "unchanged text" криво работало для фиксированных строк ввода.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-07-14 14:41:42+01:00 - build 5425

1. F3 in Command History shows where the command was executed from.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. F3 в истории команд показывает, откуда была исполнена команда.

2. Рефакторинг.

--------------------------------------------------------------------------------
svs 2019-07-12 17:21:37+03:00 - build 5424

1. SQLite 3.29.0

--------------------------------------------------------------------------------
drkns 2019-07-11 01:13:31+01:00 - build 5423

1. In code pages menu, take into account that in Windows 10 ANSI and OEM can be UTF-8.

2. Panel.Tree.TurnOffCompletely option does not suppress keybar labels anymore.

3. Clarification of *.lng.custom loading order.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В меню кодовых страниц учитывается, что в Windows 10 ANSI и OEM могут быть UTF-8.

2. Опция Panel.Tree.TurnOffCompletely больше не подавляет надписи на панели клавиш.

3. Уточнение порядка загрузки *.lng.custom.

--------------------------------------------------------------------------------
drkns 2019-07-10 07:52:22+01:00 - build 5422

1. Continuation of 5420.

--------------------------------------------------------------------------------
drkns 2019-07-09 17:26:58+01:00 - build 5421

1. Continuation of 5420.

--------------------------------------------------------------------------------
drkns 2019-07-08 23:41:11+01:00 - build 5420

1. Refactoring.

2. Minor help corrections.

--------------------------------------------------------------------------------
MZK 2019-07-07 16:21:47-07:00

1. Translated the @ElevationDlg help page into English.

2. Fixed description of the /title command line switch.

3. Minor corrections in help files.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл страницу справки @ElevationDlg на английский.

2. Подправил описание параметра /title командной строки.

3. Мелкие уточнения в файлах справки.

--------------------------------------------------------------------------------
lunakid 2019-07-05 12:27:39+01:00 - build 5419

1. GitHub #157: Allow reusing the original title via %Default in -title

--------------------------------------------------------------------------------
drkns 2019-06-30 12:38:34+01:00 - build 5418

1. Refactoring.

--------------------------------------------------------------------------------
MZK 2019-06-29 00:15:09-07:00

1. Revised @ViewerSettings and @ViewerMode help pages, both English and Russian

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переработал страницы справки @ViewerSettings и @ViewerMode, английскую и русскую

--------------------------------------------------------------------------------
drkns 2019-06-23 22:35:33+01:00 - build 5417

1. Correction of 5416.

--------------------------------------------------------------------------------
drkns 2019-06-21 20:40:14+01:00 - build 5416

1. Support FILE_ATTRIBUTE_PINNED and FILE_ATTRIBUTE_UNPINNED attributes.

2. Move attributes in filters & highlight/sorting groups dialogs to a separate dialog - it's not possible to squeeze more into the main one.

3. UI for names of highlight/sorting groups.

4. Show no more than 3 checked and 3 unchecked attributes in filters & highlight/sorting groups menus for the same reason.

5. Fix minor bugs in dialogs.

6. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поддержка атрибутов FILE_ATTRIBUTE_PINNED и FILE_ATTRIBUTE_UNPINNED.

2. Атрибуты в диалогах фильтров & групп раскраски/сортировки вынесены в отдельный диалог, т.к. в основной пихать уже некуда.

3. Интерфейс для имён групп раскраски/сортировки.

4. В меню фильтров & групп раскраски/сортировки отображается не более 3 включенных и 3 выключенных атрибутов по той же причине.

5. Исправлены мелкие баги в диалогах.

6. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-06-19 20:18:11+01:00 - build 5415

1. And again.

--------------------------------------------------------------------------------
drkns 2019-06-15 09:27:46+01:00 - build 5414

1. 5411 once more.

--------------------------------------------------------------------------------
drkns 2019-06-14 17:10:17+01:00 - build 5413

1. Continuation of 5411:
   - Take into account that the user can insidiously change the current directory after opening Editor.
   - Save hardlinks directly to not break them.

2. As it turned out, updating descriptions in ANSI plugins (e.g. Multiarc) never worked.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5411:
   - Учтём, что пользователь может коварно сменить текущий каталог после открытия редактора.
   - Хардлинки сохраняем напрямую, чтобы не разрывать.

2. Как выяснилось, обновление описаний в ANSI плагинах (e.g. Multiarc) не работало никогда.

--------------------------------------------------------------------------------
drkns 2019-06-13 10:40:47+01:00 - build 5412

1. Correction of 5409.

--------------------------------------------------------------------------------
drkns 2019-06-13 01:49:25+01:00 - build 5411

1. Based on 0003712: Far crashes when saving a file and the file content is lost:
   we indeed use not the safest possible way to save files.
   Now in Editor (and also when saving descriptions and user menu) we write into a new file
   and then replace the old one with it using ReplaceFileW.

2. Since ReplaceFileW allows to create backups with truly indescribable ease, let's use it:
   If Editor.CreateBackups is enabled in far:config - Editor will create .bak files when saving.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. По мотивам 0003712: При сохранении файла происходит краш фара и файл обретает нулевую длину:
   сохранять так, как мы сохраняем, действительно, не очень хорошо.
   Теперь в редакторе (а также при сохранении файлов описаний и user menu) запись выполняется в новый файл,
   которым затем заменяется старый при помощи ReplaceFileW.

2. Т.к. ReplaceFileW умеет с легкостью, поистине неописуемой, создавать резервные копии - воспользуемся этим:
   Если в far:config включить Editor.CreateBackups - редактор будет создавать .bak файлы при сохранении.

--------------------------------------------------------------------------------
drkns 2019-06-08 22:27:51+01:00 - build 5410

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-06-07 22:46:34+01:00 - build 5409

1. Eject didn't work for some USB sticks.

2. Refactoring.

3. Removed the remnants of ACTL_EJECTMEDIA.

4. Continuation of 5395: use "…" instead of "..." in lng & hlf as well.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не работало извлечение некоторых USB-дисков.

2. Рефакторинг там же.

3. Убраны остатки ACTL_EJECTMEDIA.

4. Продолжение 5395: используем "…" вместо "..." и в lng & hlf.

--------------------------------------------------------------------------------
drkns 2019-06-05 15:50:39+01:00 - build 5408

1. fmt allows checking format strings at compile time, let's use that.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. fmt позволяет проверять формат-строки в compile time, воспользуемся этим.

--------------------------------------------------------------------------------
zg 2019-06-04 11:53:20+03:00 - build 5407

1. 0003713: panel.GetPanelDirectory & panel.SetPanelDirectory inconsistency.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003713: Несогласованность panel.GetPanelDirectory и panel.SetPanelDirectory.

--------------------------------------------------------------------------------
drkns 2019-06-01 19:27:09+01:00 - build 5406

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-05-31 00:09:21+01:00 - build 5405

1. Refactoring, Clang & GCC warnings.

--------------------------------------------------------------------------------
drkns 2019-05-28 23:34:25+01:00 - build 5404

1. Continuation of 5403.

--------------------------------------------------------------------------------
drkns 2019-05-27 14:44:09+01:00 - build 5403

1. Menu Filter was using LIF_HIDDEN flag to hide items.
   That's fine, except that LIF_HIDDEN is a public flag that can se set by anyone,
   so turning the filter on and off was spawning sudden items sometimes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Фильр меню использовал флаг LIF_HIDDEN для сокрытия пунктов.
   Это прекрасно, за исключением того, что LIF_HIDDEN - публичный флаг, который может поставить кто угодно,
   и включение и выключение фильтра иногда приводило к внезапным пунктам.

--------------------------------------------------------------------------------
drkns 2019-05-26 20:25:11+01:00 - build 5402

1. Added diagnostic messages for configuration import & export failures.

2. Added errno capturing to exception handling.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Диагностические сообщения при ошибках импорта & экспорта конфигурации.

2. Отображение errno при обработке исключений.

--------------------------------------------------------------------------------
drkns 2019-05-25 14:14:54+01:00 - build 5401

1. 0003711: Allow multiple file list metasymbols.

--------------------------------------------------------------------------------
drkns 2019-05-22 19:43:43+01:00 - build 5400

1. As it turned out, XP x64 has everything we need so wrappers have been disabled for x64 (at least until they use something else in the CRT that isn't there).

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Как выяснилось, в XP x64 уже и так всё есть, поэтому отключим врапперы для x64 (пока в CRT не начнут использовать что-то, чего там нет).

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2019-05-21 21:42:42+01:00 - build 5399

1. x64 support in vc_crt_fix.asm. Probably we can work in XP x64 as well now.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поддержка x64 в vc_crt_fix.asm. Теперь, наверное, сможем работать и в XP x64.

--------------------------------------------------------------------------------
drkns 2019-05-15 23:45:23+02:00 - build 5398

1. https://docs.microsoft.com/en-us/windows/desktop/shell/launch
   "In general, trying to determine the list of available verbs for a particular file is somewhat complicated.
   In many cases, you can simply set the lpVerb parameter to NULL, which invokes the default command for the file type."

   Let's follow the manual here - the result of "trying to determine" is sometimes insane.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. https://docs.microsoft.com/en-us/windows/desktop/shell/launch
   "In general, trying to determine the list of available verbs for a particular file is somewhat complicated.
   In many cases, you can simply set the lpVerb parameter to NULL, which invokes the default command for the file type."

   Сделаем по документации, т.к. "trying to determine" иногда выдаёт дичь.

--------------------------------------------------------------------------------
drkns 2019-05-11 23:42:12+01:00 - build 5397

1. Fix build.

--------------------------------------------------------------------------------
drkns 2019-05-11 22:55:22+01:00 - build 5396

1. New fmt version.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-05-06 22:44:11+01:00 - build 5395

1. Use "…" instead of "..." for UI string truncation to save some space.

2. Minor changes in vcxproj and build scripts.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При обрезании строк в UI вместо "..." используется "…" для экономии места.

2. Мелкие уточнения vcxproj и сборочных скриптов.

--------------------------------------------------------------------------------
drkns 2019-05-04 17:16:12+01:00 - build 5394

1. initguid.cpp removed - GUIDs are initialised directly now.

2. A workaround to support GCC 7.1.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. initguid.cpp больше нет - GUIDы инициализируются напрямую.

2. Костыль для поддержки GCC 7.1.

--------------------------------------------------------------------------------
drkns 2019-05-03 22:15:49+01:00 - build 5393

1. 0003709: Incorrect relative dates in filters

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003709: Меняются значения относительных дат в фильтре

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2019-05-01 23:00:19+01:00 - build 5392

1. Refactoring.

2. More tests.

--------------------------------------------------------------------------------
drkns 2019-04-26 23:37:23+01:00 - build 5391

1. Continuation of 5368.

--------------------------------------------------------------------------------
drkns 2019-04-25 23:57:58+01:00 - build 5390

1. Refactoring.

2. More tests.

--------------------------------------------------------------------------------
drkns 2019-04-25 22:42:44+01:00 - build 5389

1. 0003706: Pressing Enter clears the selection in the current line.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003706: При нажатии Enter сбрасывается выделение в текущей строке

--------------------------------------------------------------------------------
svs 2019-04-24 16:11:54+03:00 - build 5388

1. SQLite 3.28.0

--------------------------------------------------------------------------------
drkns 2019-04-18 21:59:52+01:00 - build 5387

1. New fmt version.

2. Workaround for Clang 8.

3. Minor refactoring.

--------------------------------------------------------------------------------
drkns 2019-04-17 22:23:24+01:00 - build 5386

1. Build process:
   - bootstrap directory moved to IntDir (some generated files contain platfrom-specific data).
   - simplified the format of vbuild.m4 - now there is only a number.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Процесс сборки:
   - папка bootstrap переехала в IntDir (в некоторых генерируемых файлах содержатся платформозависимые данные).
   - упрощен формат vbuild.m4 - теперь там только номер.

--------------------------------------------------------------------------------
drkns 2019-04-16 08:17:59+01:00 - build 5385

1. Correction of 5384.

--------------------------------------------------------------------------------
drkns 2019-04-15 21:42:35+01:00 - build 5384

1. Refactoring.

2. Please do not check in files with crlf line endings into git. Thanks.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Пожалуйста, не пихайте в git файлы с crlf концами строк. Спасибо.

--------------------------------------------------------------------------------
drkns 2019-04-05 17:10:06+01:00 - build 5383

1. Forum: corrections for WindowMode = false.

--------------------------------------------------------------------------------
drkns 2019-04-03 20:01:25+01:00 - build 5382

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-04-02 19:41:21+01:00 - build 5381

1. Standard Boyer-Moore-Horspool implementation in Find File.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Стандартная имплементация Boyer-Moore-Horspool в поиске файлов.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-03-28 16:45:06+00:00 - build 5380

1. Running the screen saver resets the viewport position.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Запуск скринсейвера сбрасывает позицию вюьпорта.

--------------------------------------------------------------------------------
drkns 2019-03-28 13:54:13+00:00 - build 5379

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2019-03-25 17:22:38+00:00 - build 5378

1. Minor refactoring.

2. More tests.

--------------------------------------------------------------------------------
drkns 2019-03-22 23:45:48+00:00 - build 5377

1. Fix GCC debug build.

--------------------------------------------------------------------------------
drkns 2019-03-20 23:35:45+00:00 - build 5376

1. Use Catch2 for unit tests.

2. Run unit tests as a part of the build process (debug - always, release - optionally).

3. Continuation of 5373.2 - removed some more redundant code.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Для юнит-тестов используется Catch2.

2. Тесты запускаются как часть процесса сборки (debug - всегда, release - опционально).

3. Продолжение 5373.2 - убрано еще немного ненужного кода.

--------------------------------------------------------------------------------
drkns 2019-03-13 22:27:54+00:00 - build 5375

1. SQLite exceptions include the database name.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В исключениях SQLite указывается имя базы.

--------------------------------------------------------------------------------
w17 2019-03-12 15:24:39+03:00 - build 5374

1. Correction of 5360.

--------------------------------------------------------------------------------
drkns 2019-03-10 00:47:09+00:00 - build 5373

1. Minimal supported Visual Studio version is now 2017 Update 9.

2. Removed VS2015-specific workarounds, some parts are reimplemented more efficiently.

3. Win32 versions of mingw are supported again.

4. Clang warnings.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Минимальная поддерживаемая версия Visual Studio - 2017 Update 9.

2. Убраны костыли для поддержки VS2015, некоторые места переписаны более эффективно.

3. Снова поддерживаются win32-версии mingw.

4. Clang warnings.

--------------------------------------------------------------------------------
zg 2019-03-03 16:22:37+02:00 - build 5372

1. Forum: keybar is not updated after calling a plugin.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: линейка функциональных клавиш после архиватора не обновляется.

--------------------------------------------------------------------------------
svs 2019-02-27 13:44:44+03:00 - build 5371

1. SQLite 3.27.2

--------------------------------------------------------------------------------
drkns 2019-02-25 23:31:27+00:00 - build 5370

1. Some AI in executor to skip scrolling if possible, based on https://forum.farmanager.com/viewtopic.php?p=153198#p153198.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Немного AI в запускателе для пропуска прокрутки при возможности, по мотивам https://forum.farmanager.com/viewtopic.php?p=153198#p153198.

--------------------------------------------------------------------------------
MZK 2019-02-24 16:26:04-08:00

1. Revised @Viewer help page, both English and Russian

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переработал страницу справки @Viewer, английскую и русскую

--------------------------------------------------------------------------------
drkns 2019-02-24 02:23:08+00:00 - build 5369

1. Switching from editor to viewer didn't work in UTF-8 files due to a typo in 5345.

2. Lng read optimisation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Из-за опечатки в 5345 не работал переход из редактора в просмотр для UTF-8 файлов.

2. Оптимизация чтения lng.

--------------------------------------------------------------------------------
drkns 2019-02-22 23:12:51+00:00 - build 5368

1. Use '│' instead of ' ' as a separator in editor & viewer status lines. Readability should improve.

2. Show names for Unicode (UTF7-8-16) code pages instead of numbers in editor & viewer status lines.

3. Show proper names for system code pages in code pages menu.

4. Translation corrections.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В качестве разделителя в статусных строках редактора и просмотра вместо пробела используется '│'. Читабельность должна повыситься.

2. В статусных строках редактора и просмотра отображаются имена юникодных (UTF7-8-16) кодовых страниц вместо номеров.

3. В меню кодовых страниц отображаются полноценные имена для системных страниц.

4. Уточнения перевода.

--------------------------------------------------------------------------------
drkns 2019-02-22 20:02:42+00:00 - build 5367

1. Don't try to read labels from the main lng if lng.custom files are absent.

2. Translation corrections.

3. VS2015.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Если файлы lng.custom отсутствуют - не пытаемся читать метки из основного lng.

2. Уточнения перевода.

3. VS2015.

--------------------------------------------------------------------------------
drkns 2019-02-21 22:00:35+00:00 - build 5366

1. Show executed command exactly as entered by the user.

2. Removing selection worked incorrectly in Grabber.

3. Reading/setting file owners optimisation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем исполняемую команду в том виде, в котором её ввёл пользователь.

2. В граббере некорректно работало снятие выделения.

3. Оптимизация чтения/установки владельцев файлов.

--------------------------------------------------------------------------------
drkns 2019-02-16 21:38:09+00:00 - build 5365

1. Refactoring.

--------------------------------------------------------------------------------
w17 2019-02-12 18:22:53+03:00 - build 5364

1. M#3695: Excessive movements during search

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#3695: лишние перемещения при поиске

--------------------------------------------------------------------------------
svs 2019-02-12 09:12:09+03:00 - build 5363

1. SQLite 3.27.1

--------------------------------------------------------------------------------
drkns 2019-02-10 23:17:26+00:00 - build 5362

1. Continuation of 2493.

2. Refactoring.

--------------------------------------------------------------------------------
w17 2019-02-06 19:46:32+03:00 - build 5361

1. M#3694: Guid is required for viewer search dialog

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#3694: Требуется Guid для диалога поиска во вьювере

--------------------------------------------------------------------------------
w17 2019-02-06 19:27:23+03:00 - build 5360

1. M#3636: VCTL_GETFILENAME not working on QView close

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#3636: VCTL_GETFILENAME не работает при закрытии QView

--------------------------------------------------------------------------------
drkns 2019-02-05 23:40:18+00:00 - build 5359

1. Refactoring.

2. Fix 5356.3.

--------------------------------------------------------------------------------
drkns 2019-02-05 21:16:42+00:00 - build 5358

1. Forum: invalid from utf-8 perspective byte sequence sometimes was treated as a valid character.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: некорректная с точки зрения utf-8 последовательность байт иногда считалась корректным символом.

--------------------------------------------------------------------------------
drkns 2019-02-04 22:22:35+00:00 - build 5357

1. #78 Add a placeholder symbol for file descriptions

--------------------------------------------------------------------------------
drkns 2019-01-24 00:43:26+00:00 - build 5356

1. New version of fmt.

2. Task List didn't show captionless windows.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Новая версия fmt.

2. Task List не показывал окна без заголовков.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2019-01-18 00:27:00+00:00 - build 5355

1. 5353 broke GCC build due to a bug in fmt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 5353 сломал GCC билд из-за бага в fmt.

--------------------------------------------------------------------------------
drkns 2019-01-16 17:21:03+00:00 - build 5354

1. More 5352.

--------------------------------------------------------------------------------
w17 2019-01-16 18:07:41+03:00 - build 5353

1. fmt library & Far thousands separator.

--------------------------------------------------------------------------------
drkns 2019-01-15 20:56:22+00:00 - build 5352

1. 0003621: Add "Use shell name" option.

--------------------------------------------------------------------------------
drkns 2019-01-09 13:13:13+00:00 - build 5351

1. More 5350.

--------------------------------------------------------------------------------
drkns 2019-01-09 11:37:01+00:00 - build 5350

1. Don't try to set cursor size and position if it's not visible.

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не пытаемся устанавливать размер и позицию курсора, если его не видно.

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2019-01-05 14:08:45+00:00 - build 5349

1. 0003689: Search in encrypted archives doesn't work.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003689: Находятся не все файлы в запароленных зипах

--------------------------------------------------------------------------------
drkns 2019-01-01 16:19:36+00:00 - build 5348

1. Coverity warnings.

--------------------------------------------------------------------------------
drkns 2018-12-31 17:05:00+00:00 - build 5347

1. Key combinations like Ctrl+[Shift+]VK_OEM_8 didn't work.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не работали сочетания типа Ctrl+[Shift+]VK_OEM_8.

--------------------------------------------------------------------------------
drkns 2018-12-27 22:28:16+00:00 - build 5346

1. /analyze warnings.

--------------------------------------------------------------------------------
drkns 2018-12-26 11:22:00+00:00 - build 5345

1. std::function replaced with function_ref where possible. Something (somewhere, sometime) will work faster. Probably.

2. Clang warnings.

3. New version of fmt.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. std::function заменена на function_ref, где возможно. Что-то (где-то, когда-то) будет работать быстрее. Наверное.

2. Clang warnings.

3. Новая версия fmt.

--------------------------------------------------------------------------------
drkns 2018-12-23 16:09:53+00:00 - build 5344

1. ColorDialog uses more obvious colour (black) as the base of the preview by default.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. ColorDialog использует более очевидный цвет (чёрный) в качестве базы предпросмотра, если не указано иное.

--------------------------------------------------------------------------------
drkns 2018-12-16 19:12:45+00:00 - build 5343

1. Incorrect keybar position in non-fullscreen windows (typo in 5268).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Некорректная позиция линейки клавиш в неполноэкранных окнах (опечатка в 5268).

--------------------------------------------------------------------------------
drkns 2018-12-11 01:59:56+00:00 - build 5342

1. VS 2015.

--------------------------------------------------------------------------------
drkns 2018-12-10 22:50:11+00:00 - build 5341

1. Refactoring.

--------------------------------------------------------------------------------
zg 2018-12-10 16:16:53+02:00 - build 5340

1. 0003657: DM_SETTEXT doesn't reset LeftPos to 0.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003657: DM_SETTEXT не сбрасывает LeftPos в ноль.

--------------------------------------------------------------------------------
svs 2018-12-10 09:01:02+03:00 - build 5339

1. SQLite 3.26.0

--------------------------------------------------------------------------------
zg 2018-12-07 10:52:37+02:00 - build 5338

1. Continuation of 5337:
   - memory usage optimization.
   - "ChangeTime" is not restored.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5337:
   - оптимизация расхода памяти.
   - "ChangeTime" не восстанавливается.

--------------------------------------------------------------------------------
zg 2018-12-05 18:17:44+02:00 - build 5337

1. copying a folder keeps its timestamps.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. сохранение всех дат папки при копировании.

--------------------------------------------------------------------------------
drkns 2018-12-05 07:54:14+00:00 - build 5336

1. Fix 5334.

--------------------------------------------------------------------------------
drkns 2018-12-04 23:30:45+00:00 - build 5335

1. Crash in far:config dialog under certain circumstances.

2. Support for compilation with Visual Studio 2019.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Падение в диалоге far:config при определенных обстоятельствах.

2. Поддержка компиляции в Visual Studio 2019.

--------------------------------------------------------------------------------
drkns 2018-12-04 02:08:22+00:00 - build 5334

1. More fixes in concurrent access to sqlite.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Еще некоторые исправления конкурентного доступа к sqlite.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-12-02 00:14:12+00:00 - build 5333

1. As it turned out, SQlite, when finalising a write transaction, does not actually finalise it,
   but downgrade it to a read-only transaction if there are any active statements.
   This led to amusing effects during creation of subsequent transactions, and, eventually, to crashes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Как выяснилось, SQlite при завершении транзакции записи не завершает её,
   а даунгрейдит до транзакции чтения, если существуют активные стейтменты.
   Это приводило к забавным эффектам при попытках создания последующих транзакций и, в конце концов, к падениям.

--------------------------------------------------------------------------------
drkns 2018-11-29 18:07:01+00:00 - build 5332

1. Restore "ClearType-friendly redraw" for Windows 10 - still relevant for Legacy Console.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Вернём "ClearType-friendly redraw" для Windows 10 - это всё ещё актуально для Legacy Console.

--------------------------------------------------------------------------------
drkns 2018-11-28 19:20:40+00:00 - build 5331

1. VT-renderer wasn't expecting that plugins can provide arbitrary rubbish instead of normal colour.

2. ENABLE_VIRTUAL_TERMINAL_INPUT flag is cleared if set.

3. "ClearType-friendly redraw" option does nothing on Windows 10 now.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. VT-рендерер не учитывал, что плагины вместо нормального цвета вполне могут предоставлять шопопало.

2. Флаг ENABLE_VIRTUAL_TERMINAL_INPUT сбрасывается, если установлен.

3. В Windows 10 опция "ClearType-friendly redraw" ничего не делает.

--------------------------------------------------------------------------------
drkns 2018-11-28 01:12:50+00:00 - build 5330

1. Show LastError & NTSTATUS in the exception handler, if possible.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем LastError & NTSTATUS в обработчике исключений, если возможно.

--------------------------------------------------------------------------------
svs 2018-11-27 16:57:10+03:00 - build 5329

1. SQLite 3.25.3

--------------------------------------------------------------------------------
drkns 2018-11-26 23:46:06+00:00 - build 5328

1. 0001726: Entering symbols using Input Method Editor doesn't work.

--------------------------------------------------------------------------------
drkns 2018-11-25 22:07:47+00:00 - build 5327

1. Some improvements in exception handling.

2. Refactoring.

--------------------------------------------------------------------------------
w17 2018-11-23 16:13:05+03:00 - build 5326

1. New option 'Save view mode' (true by default)

2. New option 'Detect dump view mode' (true by default)
   If disabled, new files will be always opened in text mode.

3. Changed F2 key behaviour in viewer:
   For Dump - switch to Text,
   For Code (Hex) - switch to either Dump or Text (F4 and F2 choose different modes)

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Добавлена опция 'Сохранять режим просмотра' (умолчание = true)

2. Добавлена опция 'Автовыбор дамп режима просмотра' (умолчание = true)
   если отключить, новые файлы всегда будут открываться в текстовом режиме

3. Изменено поведение клавиши F2 в просмотре для режимов:
   Дамп - производится переключение в Текст,
   Код (Hex) - производится переключение в Дамп или Текст (F4 и F2 выбирают разные режимы)

--------------------------------------------------------------------------------
drkns 2018-11-21 09:17:30+00:00 - build 5325

1. Typo in 5324.

--------------------------------------------------------------------------------
drkns 2018-11-20 19:20:12+00:00 - build 5324

1. Partial revert of 5276: restored reading highlighting/sorting groups in the old format.
   If new parameters don't exist, but old ones do - we will read them, delete and save as a new immediately.

   The next attempt to finally remove the legacy code is in a year.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Частичный откат 5276: вернем чтение групп раскраски/сортировки в старом формате.
   При отсутствии новых параметров и наличии старых старые будут прочитаны, удалены и, не отходя от кассы, сохранены, как новые.

   Следующая попытка окончательного удаления легаси-кода - через год.

--------------------------------------------------------------------------------
drkns 2018-11-20 01:10:03+00:00 - build 5323

1. New versions of tinyxml2 and fmt.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-11-18 23:20:04+00:00 - build 5322

1. /clearcache command didn't work.

--------------------------------------------------------------------------------
drkns 2018-11-18 14:59:47+00:00 - build 5321

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-11-18 11:07:28+00:00 - build 5320

1. And FastFind again.

--------------------------------------------------------------------------------
drkns 2018-11-17 22:05:54+00:00 - build 5319

1. More 0003679: always reset a filter when closing a combobox.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 0003679: всегда сбрасываем фильтр при закрытии комбобокса.

--------------------------------------------------------------------------------
drkns 2018-11-17 00:11:01+00:00 - build 5318

1. 0003679: DM_LISTGETCURPOS works incorrectly after pressing Esc in a filtered combobox.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003679: После фильтрации комбобокса и нажатия Esc DM_LISTGETCURPOS работает неправильно

--------------------------------------------------------------------------------
zg 2018-11-15 15:00:02+02:00 - build 5317

1. ECTL_GETCOLOR was returning incorrect coordinates.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. ECTL_GETCOLOR неправильно возвращала координаты.

--------------------------------------------------------------------------------
drkns 2018-11-15 07:37:31+00:00 - build 5316

1. And FastFind again.

--------------------------------------------------------------------------------
drkns 2018-11-15 00:53:53+00:00 - build 5315

1. And once more.

--------------------------------------------------------------------------------
drkns 2018-11-14 00:40:20+00:00 - build 5314

1. Some improvements in exception handling.

2. Strange things when closing FastFind with a mouse.

3. Correction of 5304.

4. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения обработки исключений.

2. Странные эффекты при закрытии FastFind мышью.

3. Уточнение 5304.

4. Рефакторинг.

--------------------------------------------------------------------------------
zg 2018-11-14 20:28:30+02:00 - build 5313

1. gcc.

--------------------------------------------------------------------------------
drkns 2018-11-12 23:59:59+00:00 - build 5312

1. If codepage detection failed, but we know that it can't be valid UTF-8/16 -
   ANSI will be used, even if UTF-8/16 is the default. Less chance of damaging the text.

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Если определение кодовой страницы не удалось, но известно, что это точно не UTF-8/16 -
   будем использовать ANSI, даже если UTF-8/16 является умолчанием. Меньше вероятность порчи текста.

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2018-11-10 18:52:03+00:00 - build 5311

1. Since SQLite doesn't support nested transactions and we use them only for performance -
   nested begin/end are ignored now.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Т.к. SQLite не поддерживает вложенные транзакции, а используем мы их только для производительности -
   вложенные begin/end теперь игнорируются.

--------------------------------------------------------------------------------
drkns 2018-11-10 00:09:59+00:00 - build 5310

1. Small file sorting optimisations.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Мелкие оптимизации сортировки файлов.

2. Рефакторинг.

--------------------------------------------------------------------------------
w17 2018-11-09 14:25:26+03:00 - build 5309

1. GH #77 3.0.5300: Viewer Save file position is broken

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. GH #77 3.0.5300: Поломался Save file position в просмотровщике (F3)

--------------------------------------------------------------------------------
drkns 2018-11-09 09:02:24+00:00 - build 5308

1. 5307 revealed an ancient bug - incorrect handle usage.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 5307 выявил древний баг - некорректное использование хендла.

--------------------------------------------------------------------------------
drkns 2018-11-08 21:55:13+00:00 - build 5307

1. Some improvements in exception throwing and handling.

2. After 5304 the profile was consireded "read only" in some cases.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения создания и обработки исключений.

2. После 5304 в некоторых случаях ошибочно считалось, что профиль доступен только для чтения.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-11-08 08:56:21+00:00 - build 5306

1. Forum: Far hangs after moving the system date back a day.
   Some genius in MS implemented sleep_for in terms of sleep_until. *facepalm*

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Far виснет при переводе системной даты на день назад
   Какой-то гений в MS реализовал sleep_for через sleep_until. *facepalm*

--------------------------------------------------------------------------------
drkns 2018-11-08 00:26:26+00:00 - build 5305

1. Some improvements in exception handling.

2. Redundant allocations during subsequent SCTL_CREATESUBKEY calls.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения обработки исключений.

2. Повторные вызовы SCTL_CREATESUBKEY могли приводить к лишним выделениям памяти.

--------------------------------------------------------------------------------
drkns 2018-11-06 20:35:22+00:00 - build 5304

1. Major SQLite changes: now instead of returning false or error code (which we almost never checked anyway) on failures
   exceptions will be thrown. Currently they are handled during db opening (due all the shenanigans we do there)
   and plugin settings instantiation (for obvious reasons), i.e. SCTL_CREATE, as promised, will return FALSE in case of failure.
   This should also fix 0002940: SCTL_CREATE: issues when creating multiple instances of settings.
   In the rest of the code these possible exceptions are (currently) not handled, so you will notice if anything goes wrong.
   SQLITE_BUSY is processed separately - after a 5-sec timeout it will be possible to either retry or abort the operation

   In other words - these changes are quite experimental, here be dragons.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переделана работа с SQLite: теперь при неудаче вместо возврата false или кодов ошибок (которые мы почти нигде не проверяли)
   бросаются исключения. Они пока что перехватываются при открытии db (из-за всего сопутствующего этому процессу шаманства)
   и создании экземпляра настроек плагина (по понятным причинам), т.е. SCTL_CREATE, как и обещано, вернет FALSE в случае неудачи.
   Это должно заодно починить 0002940: SCTL_CREATE: проблемы при создании более одного экземпляра настроек.
   В остальном коде эти возможные исключения (пока) никак не обрабатываются, так что если у вас что пойдет не так - вы об этом узнаете.
   SQLITE_BUSY обрабатывается отдельно - после 5-секундного таймаута будет возможность повторить либо прервать операцию.

   Иными словами - изменения весьма экспериментальные, возможно всякое.

--------------------------------------------------------------------------------
MZK 2018-11-05 22:34:40-08:00

1. Translated help page @OSCommands into English and reworked the Russian page.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл страницу @OSCommands справки на английский и переработал русскую страницу.

--------------------------------------------------------------------------------
drkns 2018-11-05 18:44:11+00:00 - build 5303

1. Fix 5281.2.

--------------------------------------------------------------------------------
drkns 2018-10-30 22:03:16+00:00 - build 5302

1. GH #74 Problem with relative paths in arguments if running from directory with full path longer than MAX_PATH chars
   Let's try passing the short name to SHELLEXECUTEINFO.lpDirectory if the long one is longer than MAX_PATH.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. GH #74 Problem with relative paths in arguments if running from directory with full path longer than MAX_PATH chars
   Попробуем передавать в SHELLEXECUTEINFO.lpDirectory короткое имя, если длинное длиннее MAX_PATH.

--------------------------------------------------------------------------------
drkns 2018-10-29 19:17:34+00:00 - build 5301

1. Forum: Shift+BS doesn't reset the filter.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: Shift+BS не сбрасывает фильтр.

--------------------------------------------------------------------------------
drkns 2018-10-28 14:00:50+00:00 - build 5300

1. Reduce transactions lifetime in HierarchicalConfigDb for internal databases.
   For plugins everything is the same as before for now.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Сократим время жизни транзакций в HierarchicalConfigDb для внутренних баз.
   Для плагинов пока всё по прежнему.

--------------------------------------------------------------------------------
drkns 2018-10-27 17:44:42+01:00 - build 5299

1. Forum: Crash when renaming 1.1.1 to *.*.2

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: При попытке переименовать файл или каталог с именем 1.1.1 в *.*.2 FAR падает.

--------------------------------------------------------------------------------
drkns 2018-10-26 23:27:41+01:00 - build 5298

1. And once more.

--------------------------------------------------------------------------------
drkns 2018-10-26 23:09:45+01:00 - build 5297

1. Fix 5281.2.

--------------------------------------------------------------------------------
drkns 2018-10-26 19:48:27+01:00 - build 5296

1. Forum: Visual issue with moving items between groups in Files highlighting

--------------------------------------------------------------------------------
drkns 2018-10-26 18:59:10+01:00 - build 5295

1. FSF.FarClock / Far.UpTime worked incorrectly after 5080.

2. Color dialog improvements.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. После 5080 некоректно работали FSF.FarClock / Far.UpTime

2. Улучшения диалога выбора цвета.

--------------------------------------------------------------------------------
drkns 2018-10-26 01:20:13+01:00 - build 5294

1. Forum: Add color code (#RRGGBB) to the Color dialog

--------------------------------------------------------------------------------
drkns 2018-10-25 20:33:20+01:00 - build 5293

1. Fix 5291.

--------------------------------------------------------------------------------
drkns 2018-10-24 22:20:59+01:00 - build 5292

1. In command line and file associations "if [not] exist" parser didn't work properly - a first encountered "not" was affecting all nested "if", e.g. "if not exist foo if defined tmp echo yes".
   I suppose it newer worked properly.

2. A few minor changes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В комстроке и ассоциациях криво работал парсер "if [not] exist" - первый попавшийся "not" распространялся на все вложенные "if", например "if not exist foo if defined tmp echo yes".
   Подозреваю, правильно он не работал никогда.

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2018-10-24 00:09:27+01:00 - build 5291

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-10-22 22:26:20+01:00 - build 5290

1. Fix 5288.1.

--------------------------------------------------------------------------------
drkns 2018-10-21 15:23:33+01:00 - build 5289

1. Fix 5288.1.

--------------------------------------------------------------------------------
drkns 2018-10-20 23:14:28+01:00 - build 5288

1. Hello again, rainbow: continuation of build 2070 after seven years.
   - Added a new option "Use Virtual Terminal for rendering" to Interface settings.
   - Added "Advanced" button to Color dialog.
   - Fixed bugs related to colors combination.
   In other words - happy Windows 10 owners now can enjoy TrueColor without intermediaries and right on the spot.

2. Workaround for https://github.com/Microsoft/console/issues/281.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. И снова здравствуй, радуга: продолжение build 2070 семь лет спустя:
   - В Interface settings добавлена опция "Use Virtual Terminal for rendering".
   - В диалог выбора цвета добавлена кнопка "Advanced".
   - Исправлены баги с комбинированием цветов.
   Иными словами - счастливые обладатели Windows 10 теперь могут наслаждаться труколором без посредников и не отходя от кассы.

2. Workaround для https://github.com/Microsoft/console/issues/281.

--------------------------------------------------------------------------------
drkns 2018-10-14 13:21:57+01:00 - build 5287

1. Removed added in 2145 options "Highlight column separators" and "Double stripe separators".
   Separators always use Panel.Box colour and doubled between stripes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убраны добавленные в 2145 опции "Highlight column separators" и "Double stripe separators".
   Разделители всегда используют цвет Panel.Box и удваиваются между полосами.

--------------------------------------------------------------------------------
drkns 2018-10-14 02:29:18+01:00 - build 5286

1. Removed option "-a Disable display of characters with codes 0 - 31 and 255".
   Reason: Far already doesn't show control characters for like 15 years, always replacing them with unicode glyphs.

2. Removed option "-ag Disable display of pseudographics characters".
   Reason: not all pseudographics was covered anyway and only in the interface, but not in, say, editor content or file names.
   If for aesthetic reasons you find frames with -=|+ more pleasant than with ─═║┼ - System.BoxSymbols can be changed via far:config.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Опции "-a Disable display of characters with codes 0 - 31 and 255" больше нет.
   Причина: Far и так не выводит управляющие символы уже лет 15, всегда заменяя их юникодными глифами.

2. Опции "-ag Disable display of pseudographics characters" больше нет.
   Причина: это распространялось далеко не на всю псевдографику и только на элементы интерфейса, но не на, например, содержимое редактора или имена файлов.
   Если вдруг по эстетическим соображениям рамочки с -=|+ вам милее, чем с ─═║┼ - можно поправить System.BoxSymbols в far:config.

--------------------------------------------------------------------------------
drkns 2018-10-13 10:38:58+01:00 - build 5285

1. Show "<Folder>" or "<  Up  >" for folders in "P" column (allocation size) as well.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем "<Folder>" или "<  Up  >" для папок в столбце "P" (allocation size) тоже.

--------------------------------------------------------------------------------
drkns 2018-10-10 19:46:45+01:00 - build 5284

1. Fix 5281.2.

--------------------------------------------------------------------------------
drkns 2018-10-09 23:49:36+01:00 - build 5283

1. Fix 5273.1.

--------------------------------------------------------------------------------
svs 2018-10-09 09:22:17+03:00 - build 5282

1. SQLite 3.25.2

--------------------------------------------------------------------------------
drkns 2018-10-09 01:14:41+01:00 - build 5281

1. Fix bugs in string_view implementation for VS2015.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Исправлены ошибки в реализации string_view для VS2015.

2. Рефакторинг.

--------------------------------------------------------------------------------
w17 2018-10-06 21:06:14+03:00 - build 5280

1. Fix 3837

--------------------------------------------------------------------------------
drkns 2018-10-03 11:41:16+03:00 - build 5279

1. Correction of 5276.2.

--------------------------------------------------------------------------------
drkns 2018-10-02 19:19:52+03:00 - build 5278

1. #71: Ampersand in !?<title>?<init>!

--------------------------------------------------------------------------------
drkns 2018-10-02 02:59:59+03:00 - build 5277

1. The color preview in Files highlighting takes transparency into account.

2. The color preview in Color dialog takes transparency into account.

3. By default directories highlighting does not make an exception for ".." (simpler rules and faster processing).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В предпросмотре цвета в диалоге Files highlighting учитывается прозрачность.

2. В предпросмотре цвета в диалоге Color учитывается прозрачность.

3. По умолчанию раскраска каталогов не делает исключений для ".." (проще правила и быстрее обработка).

--------------------------------------------------------------------------------
drkns 2018-09-30 17:49:39+03:00 - build 5276

1. Continuation of 5068: removed reading filters and highlighting/sorting groups in the old format.

2. Filters menu now works in the same way as all other dynamic menus - all changes performed in it
   will be applied regardless of how it has been closed - using Esc or Enter.

3. Visual artefacts during moving items of the highlighting menu with Ctrl+Up / Ctrl+Down.
   Also, menu optimisation: items updated individually instead of "erase all and read from scratch".

4. New versions of tinyxml2 and fmt.

5. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5068: убрано чтение фильтров и групп раскраски/сортировки в старом формате.

2. Меню фильтров теперь ведет себя так же, как и все остальные динамические меню - все произведенные в нем изменения
   будут применены независимо от того, как его закрыли - по Esc или по Enter.

3. Визуальные артефакты при перемещении пунктов меню раскраски по Ctrl+Up / Ctrl+Down.
   Там же: Оптимизация меню: элементы обновляются индивидуально вместо "сотрём всё и прочитаем сначала".

4. Новые версии tinyxml2 и fmt.

5. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-09-30 02:13:21+03:00 - build 5275

1. Lng MListFileSize can contain "{3}" replacement field, which will receive a sum of files and folders.
   By replacing the string with something like "{0} bytes in {3} files" one can get the same selection status as before 4442.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Lng MListFileSize может содержать replacement field "{3}", куда будет помещена сумма файлов и папок.
   Заменив строку на что-то типа "{0} bytes in {3} files", можно получить почти такую же информацию о выделенных файлах, как было до 4442.

--------------------------------------------------------------------------------
drkns 2018-09-30 00:16:35+03:00 - build 5274

1. More 5141 aka M#3578: the fix didn't work for formats like "ddddddddd, dd/MM/yy".

2. Correction of wildcards processing in file names. It should be closer to cmd now.

3. Scanning directories on plugin panels uses the same UI as on the regular.

4. Crash on elevation dialog appearing during tree re-reading.

5. Window maximise/restore didn't work during some operations.

6. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5141 aka M#3578: исправление не работало для форматов типа "ddddddddd, dd/MM/yy".

2. Уточнения в обработке wildcards в именах файлов. Теперь должно быть больше похоже на cmd.

3. Сканирование папок на плагиновых панелях использует тот же UI, что и на обычных.

4. Падение при появлении elevation диалога во время перечитывания дерева.

5. Максимизация/восстановление окна не работали во время некоторых операций.

6. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-09-26 18:54:39+03:00 - build 5273

1. Added keyboard-style delays to mouse handling for cases like "a button is pressed and held for scrolling":
   action -> long pause -> action -> short pause -> action -> short pause -> action...

2. Small refactoring and a few more corrections of 5268.1.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Добавлены задержки в обработку мыши для случая "клавиша нажата и удерживается для прокрутки" в стиле клавиатурных:
   action -> long pause -> action -> short pause -> action -> short pause -> action...

2. Мелкий рефакторинг и еще пара уточнений 5268.1.

--------------------------------------------------------------------------------
MZK 2018-09-23 19:02:35-07:00

1. Translated help page @SelectFiles into English and reworked the Russian page.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл страницу @SelectFiles справки на английский и переработал русскую страницу.

--------------------------------------------------------------------------------
drkns 2018-09-20 07:47:30+01:00 - build 5272

1. Correction of 5264.1.

--------------------------------------------------------------------------------
MZK 2018-09-18 00:12:21-07:00

1. Help: clarified description of file size formatting options.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Подсказка: уточнил описание опций форматирования размера файла.

--------------------------------------------------------------------------------
w17 2018-09-17 21:04:43+03:00 - build 5271

1. Another correction of 5268.1.

--------------------------------------------------------------------------------
svs 2018-09-17 13:56:40+03:00 - build 5270

1. SQLite 3.25.0

--------------------------------------------------------------------------------
drkns 2018-09-16 07:59:04+01:00 - build 5269

1. Correction of 5268.1.

--------------------------------------------------------------------------------
drkns 2018-09-15 15:13:24+01:00 - build 5268

1. Refactoring. Patterns of "int X1, int X2, int Y1, int Y2" form are replaced with "rectangle", "int X, int Y" - with "point".

2. Experimental: Ctrl+U does not change the size of panels.

3. tag_build.bat should work correctly in locales other than 866.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг. Паттерны типа "int X1, int X2, int Y1, int Y2" заменены на rectangle, "int X, int Y" - на point.

2. Экспериментально: Ctrl+U не меняет размеры панелей.

3. tag_build.bat должен корректно работать в локалях, отличных от 866.

--------------------------------------------------------------------------------
zg 2018-09-13 12:09:52+03:00 - build 5267

1. correction of 5262: DialogInit(-1,-1,0,0) call is equal to DialogInit(-1,-1,1,1).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. уточнение 5262: вызов DialogInit(-1,-1,0,0) эквивалентен DialogInit(-1,-1,1,1).

--------------------------------------------------------------------------------
drkns 2018-09-10 20:39:25+01:00 - build 5266

1. Export of pluginhotkeys.db was broken.

--------------------------------------------------------------------------------
drkns 2018-09-06 23:43:10+01:00 - build 5265

1. Initial size calculation would display incorrectly when deleting several folders.

2. assert in debug when space is typed in the command line.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При удалении нескольких папок некорректно отображался изначальный подсчет размера.

2. assert в debug при вводе пробела в комстроку.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-09-04 21:37:50+01:00 - build 5264

1. In presence of the elevated process the main process would stop earlier than necessary.

2. Forum: Error getting help on plugin.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При наличии elevated-процесса основной процесс закрывался раньше, чем надо.

2. С форума: Ошибка при получении помощи по плагину.

--------------------------------------------------------------------------------
MZK 2018-09-02 23:09:13-07:00

1. Translated help page @ChangeDriveMode into English and edited Russian page.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл страницу @ChangeDriveMode справки на английский и поредактировал русскую страницу.

--------------------------------------------------------------------------------
drkns 2018-09-02 22:14:00+01:00 - build 5263

1. "Owner" field in attributes dialog has been moved to the bottom.

2. Refactoring.

3. Update Slovak translation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Поле "Owner" в диалоге атрибутов передвинуто вниз.

2. Рефакторинг.

3. Update Slovak translation.

--------------------------------------------------------------------------------
zg 2018-09-01 18:59:52+03:00 - build 5262

1. check for correctness of coordinates in DialogInit.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. проверка корректности координат в DialogInit.

--------------------------------------------------------------------------------
drkns 2018-08-22 23:59:59+01:00 - build 5261

1. Rollback of rollback of (4858), revert to 4853 and shared_mutex. It may improve search in archives. Or not.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Откат отката (4858) и возвращение к 4853 и shared_mutex. Возможно, поиску в архивах станет лучше. Или нет.

--------------------------------------------------------------------------------
zg 2018-08-22 17:50:28+03:00 - build 5260

1. rollback of 5256.

--------------------------------------------------------------------------------
drkns 2018-08-22 02:28:40+01:00 - build 5259

1. CRT VS 2017 15.8 turned out to be full of yet another junk, vc_crt_fix* are updated for support of old OS.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В CRT VS 2017 15.8 напихали очередной гадости, vc_crt_fix* обновлены для поддержки старых ОС.

--------------------------------------------------------------------------------
MZK 2018-08-19 16:14:41-07:00

1. Translated help page @Codepages.NoAutoDetectCP into English.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевел на английский страничку подсказки @Codepages.NoAutoDetectCP.

--------------------------------------------------------------------------------
drkns 2018-08-19 14:58:35+01:00 - build 5258

1. Corrections in processing of ".." in plugin panels.
   - OPIF_ADDDOTS always adds "..".
   - if OPIF_ADDDOTS is not set then the parent directory is the first ".." in the list regardless of FILE_ATTRIBUTE_DIRECTORY presence.
   - Distinguish between a virtual ".." and a real folder if possible.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения в обработке ".." в панелях плагинов.
   - OPIF_ADDDOTS добавляет ".." всегда.
   - если OPIF_ADDDOTS не установлен, то надкаталогом считается первый ".." в списке, независимо от наличия FILE_ATTRIBUTE_DIRECTORY.
   - Отличаем виртуальный ".." от настоящей папки, если возможно.

--------------------------------------------------------------------------------
drkns 2018-08-19 08:53:24+01:00 - build 5257

1. VS 2017 15.8.1.

--------------------------------------------------------------------------------
zg 2018-08-15 00:00:47+03:00 - build 5256

1. protect all plugin calls with a global critical section.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. все вызовы плагинов защищены глобальной критической секцией.

--------------------------------------------------------------------------------
drkns 2018-08-09 21:06:04+01:00 - build 5255

1. SQLite does not use rand_s() since 3.21 so Win2k support which has been introduced in 4710 now can be removed.

2. A couple of issues.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Оказывается, SQLite, начиная с 3.21, не использует rand_s() и костыль для поддержки Win2k, добавленный в 4710, больше не нужен.

2. Пара мелочей.

--------------------------------------------------------------------------------
drkns 2018-08-05 14:05:25+01:00 - build 5254

1. Continuation of 5252.

--------------------------------------------------------------------------------
drkns 2018-08-03 12:13:31+01:00 - build 5253

1. Continuation of 5249.

--------------------------------------------------------------------------------
drkns 2018-08-03 00:28:15+01:00 - build 5252

1. Correction of 5248.

--------------------------------------------------------------------------------
drkns 2018-08-02 19:06:57+01:00 - build 5251

1. Correction of 5250.2.

--------------------------------------------------------------------------------
drkns 2018-08-02 18:08:20+01:00 - build 5250

1. Refactoring.

2. A few small tweaks of interaction with sqlite.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Несколько мелких оптимизаций в работе с sqlite.

--------------------------------------------------------------------------------
zg 2018-08-02 18:54:18+03:00 - build 5249

1. correction of 5242.1 when the panel is closed in GetFilesW and DeleteFilesW.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. уточнение 5242.1, если панель закрывается внутри GetFilesW и DeleteFilesW.

--------------------------------------------------------------------------------
drkns 2018-08-01 15:04:37+01:00 - build 5248

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-07-25 00:21:37+01:00 - build 5247

1. Correction of 5240.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-07-23 23:54:41+01:00 - build 5246

1. Continuation of 5211.1. Associations !.! must be working again in archives.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5211.1. Должны снова работать ассоциации типа !.! в архивах.

--------------------------------------------------------------------------------
zg 2018-07-24 00:57:09+03:00 - build 5245

1. correction of 5242.1 if the panel is closed in GetFindDataW.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. уточнение 5242.1, если панель закрывается внутри GetFindDataW.

--------------------------------------------------------------------------------
drkns 2018-07-23 20:05:28+01:00 - build 5244

1. Refactoring of strings and string literals.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Мелкий рефакторинг на тему строк и строковых литералов.

--------------------------------------------------------------------------------
drkns 2018-07-22 23:02:33+01:00 - build 5243

1. Adapter UUID is checked on load, duplicates are ignored.

2. clang & gcc warnings.

3. Some renaming.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. UUID адаптера проверяется при загрузке, дубликаты игнорируются.

2. clang & gcc warnings.

3. Немного переименований.

--------------------------------------------------------------------------------
zg 2018-07-22 16:11:54+03:00 - build 5242

1. FCTL_CLOSEPANEL closes panel synchronously.

2. gcc warnings.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. FCTL_CLOSEPANEL синхронно закрывает панель.

2. gcc warnings.

--------------------------------------------------------------------------------
drkns 2018-07-21 18:41:29+01:00 - build 5241

1. Null character could not be entered in command line for some reason.

2. Strings containing null characters would be correctly added to db and incorrectly read.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Почему-то нельзя было ввести нулевой символ в комстроку.

2. Строки с нулевыми символами правильно добавлялись в дб, но неправильно извлекались.

--------------------------------------------------------------------------------
drkns 2018-07-20 23:07:50+01:00 - build 5240

1. Fix obtaining strings with winapi functions.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения получения строк через winapi-функции.

--------------------------------------------------------------------------------
drkns 2018-07-16 18:30:13+01:00 - build 5239

1. Correction of 5238.2.

--------------------------------------------------------------------------------
drkns 2018-07-15 14:42:42+01:00 - build 5238

1. New versions of tinyxml2 and fmt.

2. Adapters are shown in far:about.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Новые версии tinyxml2 и fmt.

2. Используемые адаптеры показываются в far:about.

--------------------------------------------------------------------------------
drkns 2018-07-14 20:45:49+01:00 - build 5237

1. Clang warnings.

2. Compiler is shown in far:about.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Clang warnings.

2. Использованный компилятор показывается в far:about.

--------------------------------------------------------------------------------
drkns 2018-07-08 14:29:41+01:00 - build 5236

1. Improve exceptions processing.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-07-07 14:31:27+01:00 - build 5235

1. Correction of 5215.

--------------------------------------------------------------------------------
drkns 2018-06-29 20:49:29+01:00 - build 5234

1. #54: Far crashes when trying to free up memory used to store Descript.ion file records

--------------------------------------------------------------------------------
drkns 2018-06-27 22:31:19+01:00 - build 5233

1. Continuation of 5068: remove storing filters and highlighting/sorting groups in the old format.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5068: убрана запись фильтров и групп раскраски/сортировки в старом формате.

2. Рефакторинг.

--------------------------------------------------------------------------------
zg 2018-06-27 13:41:38+03:00 - build 5232

1. correction of 5222.

--------------------------------------------------------------------------------
drkns 2018-06-22 19:39:48+01:00 - build 5231

1. Correction of 5230.2.

--------------------------------------------------------------------------------
drkns 2018-06-21 22:26:50+01:00 - build 5230

1. 0003531: Sort far:config entries.

2. "Eat Your Own Dog Food" - implementation of #1 revealed inconveniences in Dialog API.
   FarListItem now contains intptr_t UserData in order to bind data to the list item
   not fiddling with sending messages (unrelated to DM_LIST<G|S>ETDATA, there's other data).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003531: Sort far:config entries.

2. "Eat Your Own Dog Food" - имплементация п.1 выявила неудобства в Dialog API.
   FarListItem теперь содержит intptr_t UserData для ассоциирования данных с элементом списка
   без ритуальных приседаний с посылкой сообщений (никак не связано с DM_LIST<G|S>ETDATA, там отдельные данные).

--------------------------------------------------------------------------------
drkns 2018-06-21 18:53:53+01:00 - build 5229

1. 0003621: It would be good to show "volume label" for network devices.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003621: Хорошо было бы показывать "метку тома" для сетевых устройств.

--------------------------------------------------------------------------------
w17 2018-06-20 17:40:35+03:00 - build 5228

1. M#3614: arclite does not update sizes of files inside archive if external editor is used

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. M#3614: arclite не обновляет размеры файлов внутри архива при использовании внешнего редактора

--------------------------------------------------------------------------------
svs 2018-06-09 18:11:19+03:00 - build 5227

1. SQLite 3.24.0

--------------------------------------------------------------------------------
zg 2018-06-05 12:47:24+03:00 - build 5226

1. do not sort panel while receiving file list from plugin.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. во время получения списка файлов от плагина панель не сортируется.

--------------------------------------------------------------------------------
drkns 2018-06-03 10:21:52+01:00 - build 5225

1. Naive logic "if the file contains ASCII only then open it with default codepage" would not take
   into account that user could set the default codepage to UTF-16.
   Also, simplify the codepage guessing logic.

2. Continuation of 5215, 5205, 5141 : date/time parsing in attributes/filters dialogs does not look for
   separators - we have got the input mask and know exactly what to search and where.

3. If editor settings have "[x] Allow editing files opened for writing" set then append FILE_SHARE_DELETE.

4. Correct the UTF-8 recognition algorithm.

5. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Наивная логика "если файл содержит только ASCII - открываем его с кодовой страницей по умолчанию" не учитывала,
   что пользователь может коварно назначить кодовой страницей по умолчанию какой-нибудь UTF-16.
   Там же: в целом упрощена логика угадывания кодовой страницы.

2. Продолжение 5215, 5205, 5141 : при разборе даты и времени, введенных в диалогах аттрибутов/фильтров,
   не используем парсинг по разделителям - у нас есть маска ввода и точное знание, где и что искать.

3. Если в настройках редактора "[x] Allow editing files opened for writing", то подставляем еще и FILE_SHARE_DELETE.

4. Уточнен алгоритм распознавания UTF-8.

5. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-05-28 17:48:30+01:00 - build 5224

1. After F3 on plugin panel and cancelling the scanning the allocated memory was not freed.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. При нажатии F3 на панели плагина и отмене сканирования не освобождалась память.

2. Мелкий рефакторинг там же.

--------------------------------------------------------------------------------
drkns 2018-05-23 22:50:03+01:00 - build 5223

1. fmt v5.

2. VS2017 warning: std::all_of - nodiscard.

3. "Find all" menu could be bigger than needed.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. fmt v5.

2. VS2017 warning: std::all_of - nodiscard.

3. Меню "Find all" могло быть больше чем нужно.

--------------------------------------------------------------------------------
zg 2018-05-23 16:25:25+03:00 - build 5222

1. crash if help is opened with menu and then the console window is closed with "X".

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. если в меню вызвать помощь, а потом закрыть окно консоли через «крестик», фар падает.

--------------------------------------------------------------------------------
zg 2018-05-22 21:28:23+03:00 - build 5221

1. forum: If a dialog is redrawing something inside itself regularly (say, once a second)
   while user is trying to grab (AltIns) the part of console window
   then the displayed capture area is being reset constantly.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: Если диалог регулярно (например, ежесекундно) что-то у себя перерисовывает,
   а пользователь пытается грабить (AltIns) часть консольного окна,
   то отображаемая область захвата постоянно сбрасывается.

--------------------------------------------------------------------------------
drkns 2018-05-20 17:11:57+01:00 - build 5220

1. Links to main help file themes were erroneously considered external.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ссылки на темы основного файла помощи ошибочно считались внешними.

--------------------------------------------------------------------------------
drkns 2018-05-20 11:51:48+01:00 - build 5219

1. Forum: clock won't refresh.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: не обновляются часы.

--------------------------------------------------------------------------------
drkns 2018-05-19 15:06:40+01:00 - build 5218

1. Another odd bug after 5211.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Еще один нечётный баг после 5211.

--------------------------------------------------------------------------------
drkns 2018-05-19 13:37:59+01:00 - build 5217

1. Bring interface of handmade string_view closer to the standard one. Part 2 - iterators.

2. Use std::string_view (if present).

3. Metacharacters wouldn't expand in the caption of variable substitution dialog called from user menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Приближаем интерфейс самодельного string_view к стандартному. Часть 2 - итераторы.

2. Используем std::string_view (если есть).

3. Не разворачивались метасимволы в заголовке диалога подстановки переменных, вызываемого из user menu.

--------------------------------------------------------------------------------
drkns 2018-05-18 21:42:40+01:00 - build 5216

1. Bring interface of handmade string_view closer to the standard one. Part 1 - _sv -> sv.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Приближаем интерфейс самодельного string_view к стандартному. Часть 1 - _sv -> sv.

--------------------------------------------------------------------------------
drkns 2018-05-17 21:55:24+01:00 - build 5215

1. Continuation of 5211 - odd bugs.

2. #0003608: 3.0.5214 x86 - changing attributes resets year to 2000 in DD.MM.YYYY (should be 5205).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5211 - полезли нечётные баги.

2. #0003608: 3.0.5214 x86 - смена атрибутов сбрасывает у ДД.ММ.ГГГГ год в 2000 (а на самом деле 5205).

--------------------------------------------------------------------------------
drkns 2018-05-16 23:07:37+01:00 - build 5214

1. Use OS regional settings to group digits in numbers.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Для группировки цифр в числах используются региональные настройки ОС.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-05-15 22:05:12+01:00 - build 5213

1. Another pair of corrections for 5211.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-05-14 19:29:57+01:00 - build 5212

1. Correction of 5211.

--------------------------------------------------------------------------------
drkns 2018-05-14 00:15:53+01:00 - build 5211

1. Refactoring. A lot of changes in fnparse.cpp, possible glitches in processing of metacharacters.

2. In some cases, possiblility of empty short filename returned by OS was ignored.
   Now it should be checked everywhere.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг. Много изменений в fnparse.cpp, возможны чудеса в обработке метасимволов.

2. В некоторых случаях не учитывалось, что ОС может возвращать для файла пустое короткое имя.
   Теперь вроде бы учитывается везде.

--------------------------------------------------------------------------------
drkns 2018-05-10 23:23:38+01:00 - build 5210

1. 0003606: Pause before displaying result of Ctrl+Q on folder

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003606: Задержка результата Ctrl+Q на папке

--------------------------------------------------------------------------------
drkns 2018-05-07 16:51:02+01:00 - build 5209

1. Remove unwanted things from headers.hpp. Part 3.

2. 0003605: Command 'cd /d' doesn't work in User Menu

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убираем из headers.hpp то, чего там не должно быть. Часть 3.

2. 0003605: Command 'cd /d' doesn't work in User Menu

--------------------------------------------------------------------------------
zg 2018-05-06 17:39:35+03:00 - build 5208

1. AltF1 F4 Enter - the dialog disappears and appears again after cursor move.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. AltF1 F4 Enter - диалог пропал, после перемещения кусора - появляется.

--------------------------------------------------------------------------------
zg 2018-05-06 14:57:28+03:00 - build 5207

1. forum: Invoke Options->File panel modes dialog, then proceed to, say, Long descriptions and press Ctrl+Enter - the dialog disappears.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: Если вызвать диалог Options->File panel modes и перейти, например, на Long descriptions нажав затем Ctrl+Enter то диалог пропадет.

--------------------------------------------------------------------------------
drkns 2018-05-05 17:04:38+01:00 - build 5206

1. Remove unwanted things from headers.hpp. Part 2.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убираем из headers.hpp то, чего там не должно быть. Часть 2.

--------------------------------------------------------------------------------
w17 2018-05-04 15:40:01+03:00 - build 5205

1. forum: crash while parsing a date out of spaces if the date separator is also a space.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: креш при парсинге даты из пробелов, если сепаратор даты тоже пробел.

--------------------------------------------------------------------------------
zg 2018-05-04 12:57:28+03:00 - build 5204

1. forum: unpacking an archive on Shift-F2: the name of the archive is not substituted as a folder for unpacking.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. с форума: распаковка архива по Shift-F2: не подставляется имя архива в качестве папки для распаковки.

--------------------------------------------------------------------------------
drkns 2018-05-03 21:55:10+01:00 - build 5203

1. Remove unwanted things from headers.hpp. Part 1.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Убираем из headers.hpp то, чего там не должно быть. Часть 1.

--------------------------------------------------------------------------------
drkns 2018-05-02 21:03:29+01:00 - build 5202

1. GCC 7.1 warning.

2. Possible truncation of a file name in copy dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. GCC 7.1 warning.

2. В имени файла в диалоге копирования могло обрезаться лишнее.

--------------------------------------------------------------------------------
drkns 2018-05-02 00:54:38+01:00 - build 5201

1. Possible garbage in drive change error dialog.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В диалоге ошибки смены диска мог показываться мусор.

--------------------------------------------------------------------------------
drkns 2018-05-01 22:48:34+01:00 - build 5200

1. For some global objects independent of the rest of code and potentially required everywhere
   (imports, console, memcheck), use Nifty Counters to guarantee their availability at any time.

2. Incluse precompiled headers and memcheck with the compiler tools.

3. Other refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Для некоторых глобальных объектов, не зависящих от прочего кода и потенциально нужных везде
   (imports, console, memcheck) применим Nifty Counters для гарантии их наличия в любой момент времени.

2. Инклюдим precompiled headers и memcheck средствами компилятора.

3. Прочий рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-04-28 17:04:23+01:00 - build 5199

1. Remove formatting with spaces from *.lng finally.

2. GCC.

3. Warnings.

4. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Из *.lng окончательно искорено форматирование пробелами.

2. GCC.

3. Warnings.

4. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-04-26 23:49:40+01:00 - build 5198

1. Do not show stack on *.lng reading errors.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не показываем стек при ошибках чтения *.lng.

--------------------------------------------------------------------------------
drkns 2018-04-25 20:44:36+01:00 - build 5197

1. Show no more than 5 processes in blocked file dialog.
   Also show additional information on the processes.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем не более 5 процессов в диалоге о заблокированном файле.
   Показываем дополнительную информацию о процессах там же.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-04-24 23:29:12+01:00 - build 5196

1. Because of introduction string_view::data() without terminating zero in C++17
   and potential bugs while replacing string to string_view where \0 is important,
   use string::c_str() instead string::data() where it is justified.

   A rule of thumb: if string::size() is used somewhere nearby then data() is ok, else use c_str().

   Examples:
   auto RawPointer = string.c_str();               // c_str here
   WinapiFunction1(string.c_str());                // c_str too
   WinapiFunction2(string.data(), string.size());  // data here

2. Minor refactoring related to #1.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В связи с появлением в C++17 string_view::data() без завершающего нуля
   и потенциальными багами при замене string на string_view там, где \0 важен -
   используем string::c_str() вместо string::data() там, где это логически оправдано.

   Rule of thumb: если где-то рядом используется string::size() - data() ok, иначе c_str().

   Примеры:
   auto RawPointer = string.c_str();               // тут c_str
   WinapiFunction1(string.c_str());                // тут тоже c_str
   WinapiFunction2(string.data(), string.size());  // тут data

2. Связанный с #1 мелкий рефакторинг.

--------------------------------------------------------------------------------
w17 2018-04-23 23:42:59+03:00 - build 5195

1. Correction of 5194.

--------------------------------------------------------------------------------
drkns 2018-04-21 20:27:25+01:00 - build 5194

1. Show less rubbish in Task List.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем меньше мусора в списке задач.

--------------------------------------------------------------------------------
MZK 2018-04-15 18:17:41-07:00

1. Reworked @CodePagesMenu and @EditCodePageNameDlg help pages.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переработал странички справки @CodePagesMenu и @EditCodePageNameDlg.

--------------------------------------------------------------------------------
MZK 2018-04-14 14:38:52-07:00 - build 5193

1. Reworked @FindAllMenu and @FileOpenCreate help pages.

2. Minor improvement of the Find-all menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переработал странички справки @FindAllMenu и @FileOpenCreate.

2. Маленькое улучшение меню с результатами поиска всех вхождений.

--------------------------------------------------------------------------------
drkns 2018-04-14 19:18:53+01:00 - build 5192

1. Continuation of 5190.

--------------------------------------------------------------------------------
drkns 2018-04-14 11:34:11+01:00 - build 5191

1. Continuation of 5190.

--------------------------------------------------------------------------------
drkns 2018-04-13 23:41:30+01:00 - build 5190

1. Continue experimenting with launcher - now it is also used to launch links from help pages.
   Side effect - one can launch http://example.com etc. from command line.
   Also trying to define console-ness for the specified of associated program if shortcuts are launched.

2. GCC 7.3.

3. Correction of 5188.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение экспериментов с запускателем - теперь он используется и для запуска ссылок из помощи.
   Побочный эффект - из комстроки можно запускать http://example.com и т.п.
   Там же - пытаемся определять консольность указанной или ассоциированной программы в том числе и при запуске ярлыков.

2. GCC 7.3.

3. Уточнение 5188.

--------------------------------------------------------------------------------
svs 2018-04-12 20:41:01+03:00 - build 5189

1. SQLite 3.23.1

--------------------------------------------------------------------------------
drkns 2018-04-09 07:48:13+01:00 - build 5188

1. Limit the Find-All menu hight to the half of the window heigh.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Ограничим высоту меню с результатами поиска всех вхождений половиной высоты окна.

--------------------------------------------------------------------------------
drkns 2018-04-09 07:28:34+01:00 - build 5187

1. Forum: Bug in renaming (Shift-F6) a file on a network share.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума - Ошибка при переименовании (Shift-F6) файла на сетевой шаре.

--------------------------------------------------------------------------------
drkns 2018-04-08 13:30:30+01:00 - build 5186

1. Removed 'System settings / CD drive auto mount' (Windows 9x artefact, forgotten in 662).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Удалена опция System settings / CD drive auto mount (артефакт Windows 9x, забытый в 662).

--------------------------------------------------------------------------------
MZK 2018-04-07 21:20:12-07:00 - build 5185

1. Find-all menu disappeared after go to a bookmark (LeftCtrl+0..9).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Меню Найти-все исчезало после перехода к закладке (LeftCtrl+0..9).

--------------------------------------------------------------------------------
drkns 2018-04-05 11:07:08+03:00 - build 5184

1. Correction of 5182.

--------------------------------------------------------------------------------
svs 2018-04-04 20:22:36+03:00 - build 5183

1. SQLite 3.23.0

--------------------------------------------------------------------------------
drkns 2018-04-04 19:02:50+03:00 - build 5182

1. Repeated search of the string suffix did not work (aftermath of 5181). Try to fix another way.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не работал повторный поиск окончания строки (последствия 5181). Попробуем исправить иначе.

--------------------------------------------------------------------------------
MZK 2018-04-02 20:46:14-07:00 - build 5181

1. Fixed buffer overflow in SearchString + refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Починил переполнение буфера в SearchString + рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-04-02 16:36:26+03:00 - build 5180

1. Correction of 5175.

--------------------------------------------------------------------------------
zg 2018-04-02 13:55:55+03:00 - build 5179

1. ctrlenter in "menu with the list of all matching entries" incorrectly refreshed the screen.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. ctrlenter в "меню с результатами поиска всех вхождений" некорректно перерисовывал экран.

--------------------------------------------------------------------------------
w17 2018-04-02 12:04:49+03:00 - build 5178

1. Extract alternate streams from .wim archives

--------------------------------------------------------------------------------
drkns 2018-03-31 01:41:08+03:00 - build 5177

1. Use std::any (if present).

--------------------------------------------------------------------------------
drkns 2018-03-30 11:35:45+03:00 - build 5176

1. Continuation of 5175.

--------------------------------------------------------------------------------
drkns 2018-03-29 13:05:45+03:00 - build 5175

1. Forum: crash on File panel modes -> Ins Enter.

2. Incorrect deletion of multiple selected symlinks.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: падение при File panel modes -> Ins Enter.

2. Некорректно работало удаление нескольких выделенных симлинков.

3. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-03-23 19:16:27+00:00 - build 5174

1. Continuation of 5173 - similar changes in deletion progress window.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Продолжение 5173 - аналогичные изменения в прогрессе удаления.

--------------------------------------------------------------------------------
drkns 2018-03-23 00:15:02+00:00 - build 5173

1. Folder scanning window is rearranged:
   - now it always looks identical (F3 on a folder, before copying, before deleting)
   - total size and number of items is displayed
   - F3 on multiple folders does not flicker any more.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Немного переделан "диалог" сканирования папок:
   - теперь это всегда (F3 на папке, перед копированием, перед удалением) выглядит одинаково
   - выводится суммарный размер и количество элементов
   - F3 на нескольких папках больше не дёргается и не мерцает.

--------------------------------------------------------------------------------
drkns 2018-03-20 21:35:50+00:00 - build 5172

1. Correction of 5171.

--------------------------------------------------------------------------------
drkns 2018-03-19 22:47:53+00:00 - build 5171

1. Choice of standard association in archive plugin choice menu worked incorrectly.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В меню выбора архивного плагина неадекватно работал выбор стандартной ассоциации.

2. Рефакторинг.

--------------------------------------------------------------------------------
MZK 2018-03-18 21:30:11-07:00

1. Rewrote @PreserveStyle help page (Both English and Russian).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Переписал страницу @PreserveStyle справки (английскую и русскую).

--------------------------------------------------------------------------------
drkns 2018-03-14 22:33:55+00:00 - build 5170

1. Non-functional cosmetics:
   - virtual override -> override
   - (void) -> ()
   - // fallthrough -> [[fallthrough]];
   - --memcpy

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Нефункциональная косметика:
   - virtual override -> override
   - (void) -> ()
   - // fallthrough -> [[fallthrough]];
   - --memcpy

--------------------------------------------------------------------------------
drkns 2018-03-14 10:01:32+00:00 - build 5169

1. A couple of corrections of 5168.

--------------------------------------------------------------------------------
drkns 2018-03-13 22:40:25+00:00 - build 5168

1. Refactoring.

2. clang warnings.

3. Corrections of 5154.

--------------------------------------------------------------------------------
yjh 2018-03-11 14:04:57+03:00 - build 5167

1. Corrections for old OS versions support with the use of DelayLoad

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнения в поддержке старых версий системы с использованием DelayLoad

--------------------------------------------------------------------------------
drkns 2018-03-11 09:47:19+00:00 - build 5166

1. 0003591: F9 "Right" item is highlighted while "Left" is not

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003591: По F9 пункт "Правая" подсвечивается, а "Левая" нет

--------------------------------------------------------------------------------
drkns 2018-03-10 21:35:39+00:00 - build 5165

1. Correction of 5164.1.

--------------------------------------------------------------------------------
drkns 2018-03-10 20:23:38+00:00 - build 5164

1. Fix VS2017.6 warnings instead of suppressing them.

2. "NoDrives" OS policy was not applied to detached network volumes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Исправим предупреждения VS2017.6 вместо их подавления.

2. Политика ОС "NoDrives" не применялась к отключённым сетевым дискам.

--------------------------------------------------------------------------------
drkns 2018-03-05 19:15:49+00:00 - build 5163

1. Correction of 5161.

--------------------------------------------------------------------------------
drkns 2018-03-05 08:01:15+00:00 - build 5162

1. Fix VS2015 build.

--------------------------------------------------------------------------------
drkns 2018-03-04 22:56:16+00:00 - build 5161

1. Static analysis warnings.

2. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-03-03 17:24:57+00:00 - build 5160

1. Do not mix narrow and wide characters in fmt calls.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не смешиваем узкие и широкие символы в вызовах fmt.

--------------------------------------------------------------------------------
zg 2018-03-03 17:11:47+02:00 - build 5159

1. correction of 5049: crash after passing null pointer to PointToName.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. уточнение 5049: PointToName падала при передачи нулевого указателя.

--------------------------------------------------------------------------------
drkns 2018-03-02 13:57:21+00:00 - build 5158

1. Correction of 5155.

--------------------------------------------------------------------------------
drkns 2018-03-02 09:54:21+00:00 - build 5157

1. Correction of 5155.

--------------------------------------------------------------------------------
drkns 2018-03-02 09:28:54+00:00 - build 5156

1. Correction of 5155.

--------------------------------------------------------------------------------
drkns 2018-03-01 21:45:36+00:00 - build 5155

1. Refactoring.

--------------------------------------------------------------------------------
MZK 2018-02-28 22:26:27-08:00

1. Translated and edited @Viewer help page (both English and Russian).

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл и поредактировал страницу @Viewer справки (английскую и русскую).

--------------------------------------------------------------------------------
drkns 2018-03-01 00:25:44+00:00 - build 5154

1. Continuation of 5150.3.

2. Refactoring.

--------------------------------------------------------------------------------
zg 2018-02-28 14:24:01+02:00 - build 5153

1. ECTL_SETSTRING did not set eol when the string is empty.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. ECTL_SETSTRING при пустой строке не устанавливал eol.

--------------------------------------------------------------------------------
zg 2018-02-27 13:51:24+02:00 - build 5152

1. Correction of 5150.2.

--------------------------------------------------------------------------------
drkns 2018-02-26 00:18:23+00:00 - build 5151

1. fmt v5.

--------------------------------------------------------------------------------
drkns 2018-02-25 23:42:42+00:00 - build 5150

1. Sorting settings (numeric & case-sensitive) are moved to System Settings.
   Base comparison mode (linguistic / invariant / ordinal) now can be set there as well.
   Sorting settings are applied globally across the board.

2. The function FSF.CompareStrings is available to plugins. It allows to sort the way Far sorts
   (exactly how is not specified and depends on the settings).
   FSF.LStricmp and FSF.LStrnicmp - deprecated; their use is discouraged.

3. FCTL_SETNUMERICSORT, FCTL_SETCASESENSITIVESORT, PFLAGS_NUMERICSORT, PFLAGS_CASESENSITIVESORT do not exist anymore.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Настройки сортировки (numeric & case-sensitive) вынесены в System Settings.
   Там же теперь можно выбрать базовое сравнение (linguistic / invariant / ordinal).
   Настройки сортировки применяются глобально ко всему.

2. Для плагинов доступна функция FSF.CompareStrings, позволяющая сортировать так же, как сортирует Far (как именно - не оговорено и зависит от настроек).
   FSF.LStricmp и FSF.LStrnicmp - deprecated и не рекомендуются к использованию.

3. FCTL_SETNUMERICSORT, FCTL_SETCASESENSITIVESORT, PFLAGS_NUMERICSORT, PFLAGS_CASESENSITIVESORT больше нет.

--------------------------------------------------------------------------------
MZK 2018-02-22 23:18:21-08:00

1. Edited @CopyFiles help page (English and Russian).

2. Minor help additions and corrections; English translation.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Отредактировал страницу @CopyFiles справки (английскую и русскую).

2. Мелкие добавления и уточнения справки, перевод на английский.

--------------------------------------------------------------------------------
MZK 2018-02-21 22:37:57-08:00 - build 5149

1. Fixed VC15 64-bit compilation error: C3487: 'int': all return expressions must deduce to the same type: previously it was '__int64'.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Пофиксил ошибку компиляции в VC15 64-бит: C3487: 'int': all return expressions must deduce to the same type: previously it was '__int64'.

--------------------------------------------------------------------------------
drkns 2018-02-21 21:29:53+00:00 - build 5148

1. Numeric sort is now more like "as in Windows" with regard to sequences of zeros.

2. In Windows 7 and above, the system function (SORT_DIGITSASNUMBERS) is used for case-insensitive numeric sort.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Числовая сортировка теперь больше похожа на "как в Windows" в плане обработки идущих подряд нулей.

2. В Windows 7 и выше для регистронезависимой числовой сортировки используется системная функция (SORT_DIGITSASNUMBERS).

--------------------------------------------------------------------------------
drkns 2018-02-21 01:56:58+00:00 - build 5147

1. Show module name in the stack trace.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Показываем имя модуля в stack trace.

--------------------------------------------------------------------------------
zg 2018-02-17 17:43:21+02:00 - build 5146

1. 0003580: Text in input field is shifted when entering text in another field.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003580: Текст в поле ввода смещается при вводе текста в другое поле.

--------------------------------------------------------------------------------
MZK 2018-02-13 23:19:56-08:00

1. Description of columns and stripes on @PanelViewModes and @PanelSettings help pages.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Описание колонок и полос в страничках @PanelViewModes и @PanelSettings.

--------------------------------------------------------------------------------
drkns 2018-02-13 20:42:25+00:00 - build 5145

1. Refactoring.

2. Autodetect gcc platform.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Рефакторинг.

2. Автодетект платформы при сборке в gcc.

--------------------------------------------------------------------------------
MZK 2018-02-11 19:01:14-08:00 - build 5144

1. In the FileList class, renamed "global columns" to "stripes" + refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. В классе FileList переименовал "global columns" в "stripes" + рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-02-11 14:03:19+00:00 - build 5143

1. Correction of 5140 - revert trimming of spaces in lists.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5140 - вернём обрезание пробелов в списках.

2. Рефакторинг.

--------------------------------------------------------------------------------
drkns 2018-02-09 00:33:16+00:00 - build 5142

1. Correction of 5140 - revert the logic "separator in square brackets is not a separator" for lists of masks.

2. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Уточнение 5140 - вернём логику "если разделитель в квадратных скобках, то это не разделитель" для списков масок.

2. Рефакторинг.

--------------------------------------------------------------------------------
w17 2018-02-08 15:04:43+03:00 - build 5141

1. Forum: Commas in date

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Форум: Запятые в дате

--------------------------------------------------------------------------------
drkns 2018-02-07 23:31:59+00:00 - build 5140

1. Unify Go To dialogs (Alt+F8) in viewer and editor - now this is one dialog. Bugs are expected.

2. UserDefinedList is fully removed. String tokenization is now lazy everywhere and does minimum or zero allocations.

3. Other refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Унифицированы диалоги Go To (Alt+F8) во вьювере и редакторе - теперь это один диалог. Возможны баги.

2. Окончательно истреблен UserDefinedList. Токенизация строк теперь везде ленивая и с минимальным или нулевым количеством аллокаций.

3. Прочий рефакторинг.

--------------------------------------------------------------------------------
MZK 2018-02-04 22:16:59-08:00

1. Translated @FindFileAdvanced and @PanelSettings help pages to English in FarEng.hlf.m4.

2. Added missing option descriptions to Russian and English help.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский странички @FindFileAdvanced и @PanelSettings в FarEng.hlf.m4.

2. Добавил отсутсвующие описания параметров в русскую и английскую справку.

--------------------------------------------------------------------------------
w17 2018-02-05 01:51:12+03:00 - build 5139

1. fix 5136.2

--------------------------------------------------------------------------------
zg 2018-02-04 19:58:46+02:00 - build 5138

1. guid for "Plugin information" dialog.

--------------------------------------------------------------------------------
zg 2018-02-04 15:03:05+02:00 - build 5137

1. if the height of editor/viewer is less than 3 then the hotkeys panel is not shown.

2. if the height of editor/viewer is less than 2 then the status line is not shown.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. если высота редактора/просмотра меньше трёх - панель клавиш не показывается.

2. если высота редактора/просмотра меньше двух - статусная строка не показывается.

--------------------------------------------------------------------------------
drkns 2018-02-03 14:02:24+00:00 - build 5136

1. There were no warnings on rewrite when moving multiple files into one of them.
   An old bug existing from 1.0 b4.

2. GH #22: Add support for symbolic links creation without elevation.

3. Corrections of hlf, lng and documentation.

4. Support for git in update_headers.bat

5. Minor fixes.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Не выдавались предупреждения о перезаписи при переносе нескольких файлов в один из них.
   Древнейший баг, существует аж с 1.0 b4.

2. GH #22: Add support for symbolic links creation without elevation.

3. Уточнения hlf, lng и документации.

4. Поддержка git в update_headers.bat

5. Пара мелочей.

--------------------------------------------------------------------------------
MZK 2018-02-01 22:43:46-08:00

1. Translated @FindFile help page to English in FarEng.hlf.m4.

2. Replaced "codepage" with "code page" in the help and resource files.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский страничку @FindFile в FarEng.hlf.m4.

2. В справке и файле ресурсов заменил "codepage" на "code page".

--------------------------------------------------------------------------------
zg 2018-02-01 22:12:58+02:00 - build 5135

1. In the part-screen editor/viewer, only editor/viewer was redrawn after CtrlO.

2. In the part-screen editor/viewer, CtrlB/CtrlShiftB did not work.

3. Forum: In the part-screen editor/viewer, hotkey panel sometimes did not refresh.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. в неполноэкранном редакторе/просмотре после ctrlo отрисовывался только редактор/просмотр.

2. в неполноэкранном редакторе/просмотре не работали ctrlb/ctrlshiftb.

3. с форума: в неполноэкранном редакторе/просмотре не всегда отрисовывалась панель клавиш.

--------------------------------------------------------------------------------
MZK 2018-01-28 15:50:33-08:00

1. Translated @FarAbout and @FarConfig help pages to English in FarEng.hlf.m4.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Перевёл на английский странички @FarAbout and @FarConfig в FarEng.hlf.m4.

--------------------------------------------------------------------------------
zg 2018-01-27 14:55:05+02:00 - build 5134

1. 0003577: Incorrect UNDO functioning after Editor.InsStr.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003577: Неправильная работа UNDO после Editor.InsStr.

--------------------------------------------------------------------------------
drkns 2018-01-25 22:03:48+00:00 - build 5133

1. '@' in launcher now turns off the echo.

2. 0003525: FCTL_SETUSERSCREEN: undesirable carriage return.
   Suppress it by passing 1 to Param1.

3. Refactoring.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. '@' в запускателе теперь подавляет эхо.

2. 0003525: FCTL_SETUSERSCREEN: нежелательный перевод строки.
   Чтобы перевода не было - передавайте 1 в Param1.

3. Рефакторинг.

--------------------------------------------------------------------------------
svs 2018-01-24 11:56:03+03:00 - build 5132

1. SQLite 3.22.0

--------------------------------------------------------------------------------
drkns 2018-01-24 07:37:22+00:00 - build 5131

1. '@' now has no meaning in launcher and is ignored.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. '@' в запускателе больше не имеет сакрального смысла и просто игнорируется.

--------------------------------------------------------------------------------
zg 2018-01-21 15:17:46+02:00 - build 5130

1. correction of 5118.

--------------------------------------------------------------------------------
drkns 2018-01-20 15:25:15+00:00 - build 5129

1. Forum: F5 in filters menu works for the next item

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. С форума: В меню фильтров F5 отрабатывает для следующего элемента

--------------------------------------------------------------------------------
drkns 2018-01-15 21:52:18+00:00 - build 5128

1. 0003575: Selection with "+" with the use of filters

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003575: Выделение "+", используя фильтр

--------------------------------------------------------------------------------
zg 2018-01-15 17:29:26+02:00 - build 5127

1. SendDlgMessage(hDlg,DM_ENABLEREDRAW,TRUE,0) forbid dialog redraw if it was enabled.

2. excessive DM_ENABLEREDRAW calls in color settings menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. SendDlgMessage(hDlg,DM_ENABLEREDRAW,TRUE,0) запрещал отрисовку диалога, если она была разрешена.

2. лишние вызовы DM_ENABLEREDRAW в меню настройки цветов.

--------------------------------------------------------------------------------
drkns 2018-01-11 23:30:04+00:00 - build 5126

1. Refactoring.

--------------------------------------------------------------------------------
drkns 2018-01-11 16:23:01+00:00 - build 5125

1. 0003574: Alt+F7 search won't work in directories if their names contain a comma

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. 0003574: Поиск по Alt+F7 не работает в каталогах, где в названии есть запятая

--------------------------------------------------------------------------------
drkns 2018-01-10 23:23:33+00:00 - build 5124

1. Private buffer for ostream as a replacement for CachedWrite.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Собственный буфер для ostream как замена CachedWrite.

--------------------------------------------------------------------------------
zg 2018-01-07 17:29:09+02:00 - build 5123

1. after 5118 filling of autocompletion menu vas visible.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. после 5118 было видно, как заполняется меню автодополнения.

--------------------------------------------------------------------------------
drkns 2018-01-06 18:38:21+00:00 - build 5122

1. Standard input/output streams use their own buffer (for more correct processing of unicode).

2. New version of tinyxml2.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Для стандартных потоков ввода-вывода используется собственный буфер (для более адекватной работы с юникодом).

2. Новая версия tinyxml2.

--------------------------------------------------------------------------------
drkns 2018-01-05 23:03:50+00:00 - build 5121

1. Fixes for handling exceptions.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. Всякое на тему обработки исключений.

--------------------------------------------------------------------------------
drkns 2018-01-05 21:47:18+00:00 - build 5120

1. Static analysis warnings & minor refactoring.

--------------------------------------------------------------------------------
drkns 2018-01-04 18:17:13+00:00 - build 5119

1. Correction of 5108.

2. Optimization for GetFileString.

--------------------------------------------------------------------------------
zg 2018-01-04 15:56:53+02:00 - build 5118

1. reduce the number of redraws for vertical menu.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. уменьшено количество перерисовок вертикального меню.

--------------------------------------------------------------------------------
zg 2018-01-04 14:17:44+02:00 - build 5117

1. if the dialog has cancelled moving while ctrlf5 effect, the keypress is passed to the dialog procedure.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. если при нажатии ctrlf5 диалог отказался от перемещения, нажатие отдаётся в диалоговую процедуру.

--------------------------------------------------------------------------------
zg 2017-12-30 19:30:26+02:00 - build 5116

1. 0003573: If File View (F3) is invoked from Find Files (Alt-F7) results, switching to Edit (F6) shows Find Files dialog.

--------------------------------------------------------------------------------
drkns 2017-12-27 21:45:47+00:00 - build 5115

1. Correction of 5114.

--------------------------------------------------------------------------------
drkns 2017-12-21 21:50:42+00:00 - build 5114

1. After 4563 the recursive tree walk would not enter DFS catalogs.
   Conceptually, while walking the tree we are only interested in junction and symlink, but FILE_ATTRIBUTE_REPARSE_POINT
   can formally mean anything, therefore checking only this attribute is not enough.
   Now protection from recursive links and other useful and useless intellect in this and other places
   is applied only to IO_REPARSE_TAG_MOUNT_POINT and IO_REPARSE_TAG_SYMLINK.

· · · · · · · · · · · · · · · · · · · · · · · · ·

1. После 4563 рекурсивный обход дерева не спускался в DFS-каталоги.
   Концептуально в обходе дерева нас интересуют только junction и symlink, но FILE_ATTRIBUTE_REPARSE_POINT
   формально может означать что угодно, поэтому проверять один этот атрибут недостаточно.
   Теперь защита от рекурсивных линков и прочий нужный и ненужный интеллект в этом и других местах
   распространяется только на IO_REPARSE_TAG_MOUNT_POINT и IO_REPARSE_TAG_SYMLINK.

--------------------------------------------------------------------------------
drkns 2017-12-20 23:36:38+00:00 - build 5113

1. Another correction of 5108.

2. For lines inserted by ansi plugins, explicit absence of EOL could be ignored.

